/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern9 ()
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[1], E_HImode))
        return -1;
      return 1;

    case E_PSImode:
      if (!register_operand (operands[1], E_PSImode))
        return -1;
      return 2;

    case E_SImode:
      if (!register_operand (operands[1], E_SImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern15 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!register_operand (operands[0], E_QImode)
          || GET_MODE (x3) != E_QImode
          || !register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_SFmode:
      if (!register_operand (operands[0], E_SFmode)
          || GET_MODE (x3) != E_SFmode
          || !register_operand (operands[1], E_SFmode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern18 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_PSImode)
      || GET_MODE (x1) != E_PSImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!combine_pseudo_register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!combine_pseudo_register_operand (operands[1], E_HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern23 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_QQmode:
      if (!register_operand (operands[0], E_QQmode)
          || GET_MODE (x3) != E_QQmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 0;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 1;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 2;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 3;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 4;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 5;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 6;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 7;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 8;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 9;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 10;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 11;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 12;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 13;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 14;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 15;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 16;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 17;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 18;

        default:
          return -1;
        }

    case E_UQQmode:
      if (!register_operand (operands[0], E_UQQmode)
          || GET_MODE (x3) != E_UQQmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 19;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 20;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 21;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 22;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 23;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 24;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 25;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 26;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 27;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 28;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 29;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 30;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 31;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 32;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 33;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 34;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 35;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 36;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 37;

        default:
          return -1;
        }

    case E_HQmode:
      if (!register_operand (operands[0], E_HQmode)
          || GET_MODE (x3) != E_HQmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 38;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 39;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 40;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 41;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 42;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 43;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 44;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 45;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 46;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 47;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 48;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 49;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 50;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 51;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 52;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 53;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 54;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 55;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 56;

        default:
          return -1;
        }

    case E_UHQmode:
      if (!register_operand (operands[0], E_UHQmode)
          || GET_MODE (x3) != E_UHQmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 57;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 58;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 59;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 60;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 61;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 62;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 63;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 64;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 65;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 66;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 67;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 68;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 69;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 70;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 71;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 72;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 73;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 74;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 75;

        default:
          return -1;
        }

    case E_HAmode:
      if (!register_operand (operands[0], E_HAmode)
          || GET_MODE (x3) != E_HAmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 76;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 77;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 78;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 79;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 80;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 81;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 82;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 83;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 84;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 85;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 86;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 87;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 88;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 89;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 90;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 91;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 92;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 93;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 94;

        default:
          return -1;
        }

    case E_UHAmode:
      if (!register_operand (operands[0], E_UHAmode)
          || GET_MODE (x3) != E_UHAmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 95;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 96;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 97;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 98;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 99;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 100;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 101;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 102;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 103;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 104;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 105;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 106;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 107;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 108;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 109;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 110;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 111;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 112;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 113;

        default:
          return -1;
        }

    case E_SQmode:
      if (!register_operand (operands[0], E_SQmode)
          || GET_MODE (x3) != E_SQmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 114;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 115;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 116;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 117;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 118;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 119;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 120;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 121;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 122;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 123;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 124;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 125;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 126;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 127;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 128;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 129;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 130;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 131;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 132;

        default:
          return -1;
        }

    case E_USQmode:
      if (!register_operand (operands[0], E_USQmode)
          || GET_MODE (x3) != E_USQmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 133;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 134;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 135;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 136;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 137;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 138;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 139;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 140;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 141;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 142;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 143;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 144;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 145;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 146;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 147;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 148;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 149;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 150;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 151;

        default:
          return -1;
        }

    case E_SAmode:
      if (!register_operand (operands[0], E_SAmode)
          || GET_MODE (x3) != E_SAmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 152;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 153;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 154;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 155;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 156;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 157;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 158;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 159;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 160;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 161;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 162;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 163;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 164;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 165;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 166;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 167;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 168;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 169;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 170;

        default:
          return -1;
        }

    case E_USAmode:
      if (!register_operand (operands[0], E_USAmode)
          || GET_MODE (x3) != E_USAmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 171;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 172;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 173;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 174;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 175;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 176;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 177;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 178;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 179;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 180;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 181;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 182;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 183;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 184;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 185;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 186;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 187;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 188;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 189;

        default:
          return -1;
        }

    case E_DQmode:
      if (!register_operand (operands[0], E_DQmode)
          || GET_MODE (x3) != E_DQmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 190;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 191;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 192;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 193;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 194;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 195;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 196;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 197;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 198;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 199;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 200;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 201;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 202;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 203;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 204;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 205;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 206;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 207;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 208;

        default:
          return -1;
        }

    case E_UDQmode:
      if (!register_operand (operands[0], E_UDQmode)
          || GET_MODE (x3) != E_UDQmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 209;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 210;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 211;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 212;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 213;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 214;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 215;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 216;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 217;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 218;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 219;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 220;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 221;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 222;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 223;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 224;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 225;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 226;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 227;

        default:
          return -1;
        }

    case E_DAmode:
      if (!register_operand (operands[0], E_DAmode)
          || GET_MODE (x3) != E_DAmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 228;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 229;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 230;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 231;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 232;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 233;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 234;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 235;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 236;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 237;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 238;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 239;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 240;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 241;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 242;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 243;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 244;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 245;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 246;

        default:
          return -1;
        }

    case E_UDAmode:
      if (!register_operand (operands[0], E_UDAmode)
          || GET_MODE (x3) != E_UDAmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 247;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 248;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 249;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 250;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 251;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 252;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 253;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 254;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 255;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 256;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 257;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 258;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 259;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 260;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 261;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 262;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 263;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 264;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 265;

        default:
          return -1;
        }

    case E_TAmode:
      if (!register_operand (operands[0], E_TAmode)
          || GET_MODE (x3) != E_TAmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 266;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 267;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 268;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 269;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 270;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 271;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 272;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 273;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 274;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 275;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 276;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 277;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 278;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 279;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 280;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 281;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 282;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 283;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 284;

        default:
          return -1;
        }

    case E_UTAmode:
      if (!register_operand (operands[0], E_UTAmode)
          || GET_MODE (x3) != E_UTAmode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 285;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 286;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 287;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 288;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 289;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 290;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 291;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 292;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 293;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 294;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 295;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 296;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 297;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 298;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 299;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 300;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 301;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 302;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 303;

        default:
          return -1;
        }

    case E_QImode:
      if (!register_operand (operands[0], E_QImode)
          || GET_MODE (x3) != E_QImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 304;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 305;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 306;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 307;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 308;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 309;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 310;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 311;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 312;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 313;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 314;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 315;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 316;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 317;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 318;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 319;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 320;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 321;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 322;

        default:
          return -1;
        }

    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x3) != E_HImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 323;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 324;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 325;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 326;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 327;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 328;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 329;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 330;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 331;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 332;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 333;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 334;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 335;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 336;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 337;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 338;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 339;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 340;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 341;

        default:
          return -1;
        }

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 342;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 343;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 344;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 345;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 346;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 347;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 348;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 349;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 350;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 351;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 352;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 353;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 354;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 355;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 356;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 357;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 358;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 359;

        case E_DImode:
          if (!register_operand (operands[1], E_DImode))
            return -1;
          return 360;

        default:
          return -1;
        }

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x3) != E_DImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QQmode:
          if (!register_operand (operands[1], E_QQmode))
            return -1;
          return 361;

        case E_UQQmode:
          if (!register_operand (operands[1], E_UQQmode))
            return -1;
          return 362;

        case E_HQmode:
          if (!register_operand (operands[1], E_HQmode))
            return -1;
          return 363;

        case E_UHQmode:
          if (!register_operand (operands[1], E_UHQmode))
            return -1;
          return 364;

        case E_HAmode:
          if (!register_operand (operands[1], E_HAmode))
            return -1;
          return 365;

        case E_UHAmode:
          if (!register_operand (operands[1], E_UHAmode))
            return -1;
          return 366;

        case E_SQmode:
          if (!register_operand (operands[1], E_SQmode))
            return -1;
          return 367;

        case E_USQmode:
          if (!register_operand (operands[1], E_USQmode))
            return -1;
          return 368;

        case E_SAmode:
          if (!register_operand (operands[1], E_SAmode))
            return -1;
          return 369;

        case E_USAmode:
          if (!register_operand (operands[1], E_USAmode))
            return -1;
          return 370;

        case E_DQmode:
          if (!register_operand (operands[1], E_DQmode))
            return -1;
          return 371;

        case E_UDQmode:
          if (!register_operand (operands[1], E_UDQmode))
            return -1;
          return 372;

        case E_DAmode:
          if (!register_operand (operands[1], E_DAmode))
            return -1;
          return 373;

        case E_UDAmode:
          if (!register_operand (operands[1], E_UDAmode))
            return -1;
          return 374;

        case E_TAmode:
          if (!register_operand (operands[1], E_TAmode))
            return -1;
          return 375;

        case E_UTAmode:
          if (!register_operand (operands[1], E_UTAmode))
            return -1;
          return 376;

        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 377;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 378;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 379;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_21 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  switch (pattern13 (x1))
    {
    case 0:
      return recog_7 (x1, insn, pnum_clobbers);

    case 1:
      x2 = XEXP (x1, 1);
      x3 = XEXP (x2, 1);
      switch (GET_CODE (x3))
        {
        case REG:
        case SUBREG:
          switch (pattern3 (x2))
            {
            case 0:
              return 180; /* *addhi3_zero_extend_split */

            case 1:
              return 226; /* *addpsi3.zero_extend.qi_split */

            case 2:
              return 230; /* *addpsi3.zero_extend.hi_split */

            case 3:
              return 228; /* *addsi3.zero_extend.qi_split */

            case 4:
              return 232; /* *addsi3.zero_extend.hi_split */

            case 5:
              return 234; /* *addsi3.zero_extend.psi_split */

            default:
              return -1;
            }

        case CONST_INT:
        case CONST:
        case SYMBOL_REF:
          operands[2] = x3;
          if (pattern189 (x2) != 0)
            return -1;
          if (const_m255_to_m1_operand (operands[2], E_HImode))
            return 184; /* *addhi3_zero_extend.const_split */
          if (!const_0mod256_operand (operands[2], E_HImode))
            return -1;
          return 186; /* *aligned_add_symbol */

        case ZERO_EXTEND:
          if (pattern161 (x2) != 0)
            return -1;
          return 189; /* *usum_widenqihi3_split */

        default:
          return -1;
        }

    case 2:
      return 187; /* *addhi3_zero_extend.ashift1.split */

    case 3:
      if (!
#line 10794 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed))
        return -1;
      return 1369; /* *shl.ext.and1-to-skip.hi */

    case 4:
      if (!
#line 10794 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed))
        return -1;
      return 1375; /* *shl.ext.and1-to-skip.psi */

    case 5:
      if (!
#line 10794 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed))
        return -1;
      return 1387; /* *shl.ext.and1-to-skip.psi */

    case 6:
      if (!
#line 10794 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed))
        return -1;
      return 1381; /* *shl.ext.and1-to-skip.si */

    case 7:
      if (!
#line 10794 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed))
        return -1;
      return 1393; /* *shl.ext.and1-to-skip.si */

    case 8:
      if (!
#line 10794 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed))
        return -1;
      return 1399; /* *shl.ext.and1-to-skip.si */

    case 9:
      if (!
#line 10794 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed))
        return -1;
      return 1368; /* *shl.ext.and1-to-skip.hi */

    case 10:
      if (!
#line 10794 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed))
        return -1;
      return 1374; /* *shl.ext.and1-to-skip.psi */

    case 11:
      if (!
#line 10794 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed))
        return -1;
      return 1386; /* *shl.ext.and1-to-skip.psi */

    case 12:
      if (!
#line 10794 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed))
        return -1;
      return 1380; /* *shl.ext.and1-to-skip.si */

    case 13:
      if (!
#line 10794 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed))
        return -1;
      return 1392; /* *shl.ext.and1-to-skip.si */

    case 14:
      if (!
#line 10794 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed))
        return -1;
      return 1398; /* *shl.ext.and1-to-skip.si */

    case 15:
      return 224; /* *addhi3.sign_extend.qi_split */

    case 16:
      return 225; /* *addpsi3.sign_extend.qi_split */

    case 17:
      return 229; /* *addpsi3.sign_extend.hi_split */

    case 18:
      return 227; /* *addsi3.sign_extend.qi_split */

    case 19:
      return 231; /* *addsi3.sign_extend.hi_split */

    case 20:
      return 233; /* *addsi3.sign_extend.psi_split */

    case 21:
      return 316; /* *addqi3.msbit_split */

    case 22:
      return 318; /* *addhi3.msbit_split */

    case 23:
      return 320; /* *addpsi3.msbit_split */

    case 24:
      return 322; /* *addsi3.msbit_split */

    case 25:
      return 324; /* *addhi3.sex.msbit_split */

    case 26:
      return 326; /* *addpsi3.sex.msbit_split */

    case 27:
      return 330; /* *addpsi3.sex.msbit_split */

    case 28:
      return 328; /* *addsi3.sex.msbit_split */

    case 29:
      return 332; /* *addsi3.sex.msbit_split */

    case 30:
      return 334; /* *addsi3.sex.msbit_split */

    case 31:
      return 317; /* *addqi3.msbit_split */

    case 32:
      return 319; /* *addhi3.msbit_split */

    case 33:
      return 321; /* *addpsi3.msbit_split */

    case 34:
      return 323; /* *addsi3.msbit_split */

    case 35:
      return 325; /* *addhi3.sex.msbit_split */

    case 36:
      return 327; /* *addpsi3.sex.msbit_split */

    case 37:
      return 331; /* *addpsi3.sex.msbit_split */

    case 38:
      return 329; /* *addsi3.sex.msbit_split */

    case 39:
      return 333; /* *addsi3.sex.msbit_split */

    case 40:
      return 335; /* *addsi3.sex.msbit_split */

    case 41:
      if (pnum_clobbers != NULL
          && 
#line 2386 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 380; /* *addqi3.ge0 */
        }
      return 412; /* *addqi3.ge0_split */

    case 42:
      if (pnum_clobbers != NULL
          && 
#line 2386 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 388; /* *addqi3.ge0 */
        }
      return 420; /* *addqi3.ge0_split */

    case 43:
      if (pnum_clobbers != NULL
          && 
#line 2386 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 396; /* *addqi3.ge0 */
        }
      return 428; /* *addqi3.ge0_split */

    case 44:
      if (pnum_clobbers != NULL
          && 
#line 2386 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 404; /* *addqi3.ge0 */
        }
      return 436; /* *addqi3.ge0_split */

    case 45:
      if (pnum_clobbers != NULL
          && 
#line 2386 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 382; /* *addhi3.ge0 */
        }
      return 414; /* *addhi3.ge0_split */

    case 46:
      if (pnum_clobbers != NULL
          && 
#line 2386 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 390; /* *addhi3.ge0 */
        }
      return 422; /* *addhi3.ge0_split */

    case 47:
      if (pnum_clobbers != NULL
          && 
#line 2386 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 398; /* *addhi3.ge0 */
        }
      return 430; /* *addhi3.ge0_split */

    case 48:
      if (pnum_clobbers != NULL
          && 
#line 2386 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 406; /* *addhi3.ge0 */
        }
      return 438; /* *addhi3.ge0_split */

    case 49:
      if (pnum_clobbers != NULL
          && 
#line 2386 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 384; /* *addpsi3.ge0 */
        }
      return 416; /* *addpsi3.ge0_split */

    case 50:
      if (pnum_clobbers != NULL
          && 
#line 2386 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 392; /* *addpsi3.ge0 */
        }
      return 424; /* *addpsi3.ge0_split */

    case 51:
      if (pnum_clobbers != NULL
          && 
#line 2386 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 400; /* *addpsi3.ge0 */
        }
      return 432; /* *addpsi3.ge0_split */

    case 52:
      if (pnum_clobbers != NULL
          && 
#line 2386 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 408; /* *addpsi3.ge0 */
        }
      return 440; /* *addpsi3.ge0_split */

    case 53:
      if (pnum_clobbers != NULL
          && 
#line 2386 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 386; /* *addsi3.ge0 */
        }
      return 418; /* *addsi3.ge0_split */

    case 54:
      if (pnum_clobbers != NULL
          && 
#line 2386 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 394; /* *addsi3.ge0 */
        }
      return 426; /* *addsi3.ge0_split */

    case 55:
      if (pnum_clobbers != NULL
          && 
#line 2386 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 402; /* *addsi3.ge0 */
        }
      return 434; /* *addsi3.ge0_split */

    case 56:
      if (pnum_clobbers != NULL
          && 
#line 2386 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 410; /* *addsi3.ge0 */
        }
      return 442; /* *addsi3.ge0_split */

    case 57:
      if (pnum_clobbers != NULL
          && 
#line 2386 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 381; /* *addqi3.lt0 */
        }
      return 413; /* *addqi3.lt0_split */

    case 58:
      if (pnum_clobbers != NULL
          && 
#line 2386 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 389; /* *addqi3.lt0 */
        }
      return 421; /* *addqi3.lt0_split */

    case 59:
      if (pnum_clobbers != NULL
          && 
#line 2386 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 397; /* *addqi3.lt0 */
        }
      return 429; /* *addqi3.lt0_split */

    case 60:
      if (pnum_clobbers != NULL
          && 
#line 2386 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 405; /* *addqi3.lt0 */
        }
      return 437; /* *addqi3.lt0_split */

    case 61:
      if (pnum_clobbers != NULL
          && 
#line 2386 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 383; /* *addhi3.lt0 */
        }
      return 415; /* *addhi3.lt0_split */

    case 62:
      if (pnum_clobbers != NULL
          && 
#line 2386 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 391; /* *addhi3.lt0 */
        }
      return 423; /* *addhi3.lt0_split */

    case 63:
      if (pnum_clobbers != NULL
          && 
#line 2386 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 399; /* *addhi3.lt0 */
        }
      return 431; /* *addhi3.lt0_split */

    case 64:
      if (pnum_clobbers != NULL
          && 
#line 2386 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 407; /* *addhi3.lt0 */
        }
      return 439; /* *addhi3.lt0_split */

    case 65:
      if (pnum_clobbers != NULL
          && 
#line 2386 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 385; /* *addpsi3.lt0 */
        }
      return 417; /* *addpsi3.lt0_split */

    case 66:
      if (pnum_clobbers != NULL
          && 
#line 2386 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 393; /* *addpsi3.lt0 */
        }
      return 425; /* *addpsi3.lt0_split */

    case 67:
      if (pnum_clobbers != NULL
          && 
#line 2386 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 401; /* *addpsi3.lt0 */
        }
      return 433; /* *addpsi3.lt0_split */

    case 68:
      if (pnum_clobbers != NULL
          && 
#line 2386 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 409; /* *addpsi3.lt0 */
        }
      return 441; /* *addpsi3.lt0_split */

    case 69:
      if (pnum_clobbers != NULL
          && 
#line 2386 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 387; /* *addsi3.lt0 */
        }
      return 419; /* *addsi3.lt0_split */

    case 70:
      if (pnum_clobbers != NULL
          && 
#line 2386 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 395; /* *addsi3.lt0 */
        }
      return 427; /* *addsi3.lt0_split */

    case 71:
      if (pnum_clobbers != NULL
          && 
#line 2386 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 403; /* *addsi3.lt0 */
        }
      return 435; /* *addsi3.lt0_split */

    case 72:
      if (pnum_clobbers != NULL
          && 
#line 2386 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
        {
          *pnum_clobbers = 1;
          return 411; /* *addsi3.lt0 */
        }
      return 443; /* *addsi3.lt0_split */

    case 73:
      x2 = XEXP (x1, 1);
      if (pattern125 (x2, 
E_QImode) != 0)
        return -1;
      x4 = XEXP (x2, 0);
      x5 = XEXP (x4, 1);
      operands[2] = x5;
      x3 = XEXP (x2, 1);
      operands[3] = x3;
      if (!register_operand (operands[3], E_QImode))
        return -1;
      switch (GET_CODE (operands[2]))
        {
        case REG:
        case SUBREG:
          if (!register_operand (operands[2], E_QImode))
            return -1;
          if (
#line 2592 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
            return 490; /* *maddqi4_split */
          if (pnum_clobbers == NULL
              || !
#line 2607 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 491; /* *maddqi4 */

        case CONST_INT:
          if (pnum_clobbers == NULL
              || !const_int_operand (operands[2], E_QImode)
              || !
#line 2645 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
            return -1;
          *pnum_clobbers = 1;
          return 494; /* *maddqi4.const */

        default:
          return -1;
        }

    case 74:
      x2 = XEXP (x1, 1);
      switch (pattern127 (x2))
        {
        case 0:
          if (!register_operand (operands[3], E_HImode))
            return -1;
          x4 = XEXP (x2, 0);
          x5 = XEXP (x4, 1);
          switch (GET_CODE (x5))
            {
            case SIGN_EXTEND:
              if (GET_MODE (x5) != E_HImode)
                return -1;
              x6 = XEXP (x5, 0);
              operands[2] = x6;
              if (!register_operand (operands[2], E_QImode))
                return -1;
              if (
#line 2701 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
                return 496; /* *maddqihi4_split */
              if (pnum_clobbers == NULL
                  || !
#line 2716 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              *pnum_clobbers = 1;
              return 498; /* *maddqihi4 */

            case ZERO_EXTEND:
              if (GET_MODE (x5) != E_HImode)
                return -1;
              x6 = XEXP (x5, 0);
              operands[2] = x6;
              if (!register_operand (operands[2], E_QImode))
                return -1;
              if (
#line 2759 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL
   && reload_completed
   && SIGN_EXTEND != ZERO_EXTEND))
                return 505; /* *sumsubqihi4_split */
              if (pnum_clobbers == NULL
                  || !
#line 2776 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL
   && reload_completed
   && SIGN_EXTEND != ZERO_EXTEND))
                return -1;
              *pnum_clobbers = 1;
              return 507; /* *sumsubqihi4 */

            case CONST_INT:
              if (pnum_clobbers == NULL)
                return -1;
              operands[2] = x5;
              if (s8_operand (operands[2], E_HImode)
                  && 
#line 2855 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
                {
                  *pnum_clobbers = 1;
                  return 513; /* *maddqihi4.sconst */
                }
              if (!u8_operand (operands[2], E_HImode)
                  || !
#line 2947 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL
   && !s8_operand (operands[2], VOIDmode)))
                return -1;
              *pnum_clobbers = 1;
              return 519; /* *sumaddqihi4.uconst */

            default:
              return -1;
            }

        case 1:
          if (!
#line 10774 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed))
            return -1;
          return 1332; /* *mul.ext.and1-to-skip.hi */

        case 2:
          if (!
#line 10774 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed))
            return -1;
          return 1338; /* *mul.ext.and1-to-skip.psi */

        case 3:
          if (!
#line 10774 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed))
            return -1;
          return 1350; /* *mul.ext.and1-to-skip.psi */

        case 4:
          if (!
#line 10774 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed))
            return -1;
          return 1344; /* *mul.ext.and1-to-skip.si */

        case 5:
          if (!
#line 10774 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed))
            return -1;
          return 1356; /* *mul.ext.and1-to-skip.si */

        case 6:
          if (!
#line 10774 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed))
            return -1;
          return 1362; /* *mul.ext.and1-to-skip.si */

        default:
          return -1;
        }

    case 75:
      x2 = XEXP (x1, 1);
      switch (pattern128 (x2))
        {
        case 0:
          if (
#line 2701 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
            return 497; /* *umaddqihi4_split */
          if (pnum_clobbers == NULL
              || !
#line 2716 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
            return -1;
          *pnum_clobbers = 1;
          return 499; /* *umaddqihi4 */

        case 1:
          if (
#line 2759 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL
   && reload_completed
   && ZERO_EXTEND != SIGN_EXTEND))
            return 504; /* *usmsubqihi4_split */
          if (pnum_clobbers == NULL
              || !
#line 2776 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL
   && reload_completed
   && ZERO_EXTEND != SIGN_EXTEND))
            return -1;
          *pnum_clobbers = 1;
          return 506; /* *usmsubqihi4 */

        case 2:
          x4 = XEXP (x2, 0);
          x5 = XEXP (x4, 1);
          if (XWINT (x5, 0) == 2L)
            {
              x3 = XEXP (x2, 1);
              operands[2] = x3;
              if (
#line 2832 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(!reload_completed
   && !reg_overlap_mentioned_p (operands[0], operands[1])))
                return 512; /* *umaddqihi4.2 */
            }
          if (pnum_clobbers == NULL)
            return -1;
          operands[2] = x5;
          if (!u8_operand (operands[2], E_HImode))
            return -1;
          x3 = XEXP (x2, 1);
          operands[3] = x3;
          if (!
#line 2855 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
            return -1;
          *pnum_clobbers = 1;
          return 514; /* *umaddqihi4.uconst */

        case 3:
          if (!
#line 10774 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed))
            return -1;
          return 1333; /* *mul.ext.and1-to-skip.hi */

        case 4:
          if (!
#line 10774 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed))
            return -1;
          return 1339; /* *mul.ext.and1-to-skip.psi */

        case 5:
          if (!
#line 10774 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed))
            return -1;
          return 1351; /* *mul.ext.and1-to-skip.psi */

        case 6:
          if (!
#line 10774 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed))
            return -1;
          return 1345; /* *mul.ext.and1-to-skip.si */

        case 7:
          if (!
#line 10774 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed))
            return -1;
          return 1357; /* *mul.ext.and1-to-skip.si */

        case 8:
          if (!
#line 10774 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed))
            return -1;
          return 1363; /* *mul.ext.and1-to-skip.si */

        default:
          return -1;
        }

    case 76:
      x2 = XEXP (x1, 1);
      switch (pattern129 (x2))
        {
        case 0:
          if (!
#line 10757 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1320; /* *mul.and1-to-skip.qi */

        case 1:
          if (!
#line 10757 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1323; /* *mul.and1-to-skip.hi */

        case 2:
          if (!
#line 10757 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1326; /* *mul.and1-to-skip.psi */

        case 3:
          if (!
#line 10757 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1329; /* *mul.and1-to-skip.si */

        default:
          return -1;
        }

    case 77:
      if (!
#line 10732 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
        return -1;
      return 1272; /* *pixop-to-skip.qi */

    case 78:
      if (!
#line 10732 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
        return -1;
      return 1284; /* *pixop-to-skip.qi */

    case 79:
      if (!
#line 10732 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
        return -1;
      return 1296; /* *pixop-to-skip.qi */

    case 80:
      if (!
#line 10732 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
        return -1;
      return 1308; /* *pixop-to-skip.qi */

    case 81:
      if (!
#line 10732 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
        return -1;
      return 1275; /* *pixop-to-skip.hi */

    case 82:
      if (!
#line 10732 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
        return -1;
      return 1287; /* *pixop-to-skip.hi */

    case 83:
      if (!
#line 10732 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
        return -1;
      return 1299; /* *pixop-to-skip.hi */

    case 84:
      if (!
#line 10732 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
        return -1;
      return 1311; /* *pixop-to-skip.hi */

    case 85:
      if (!
#line 10732 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
        return -1;
      return 1278; /* *pixop-to-skip.psi */

    case 86:
      if (!
#line 10732 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
        return -1;
      return 1290; /* *pixop-to-skip.psi */

    case 87:
      if (!
#line 10732 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
        return -1;
      return 1302; /* *pixop-to-skip.psi */

    case 88:
      if (!
#line 10732 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
        return -1;
      return 1314; /* *pixop-to-skip.psi */

    case 89:
      if (!
#line 10732 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
        return -1;
      return 1281; /* *pixop-to-skip.si */

    case 90:
      if (!
#line 10732 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
        return -1;
      return 1293; /* *pixop-to-skip.si */

    case 91:
      if (!
#line 10732 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
        return -1;
      return 1305; /* *pixop-to-skip.si */

    case 92:
      if (!
#line 10732 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
        return -1;
      return 1317; /* *pixop-to-skip.si */

    case 93:
      if (!
#line 10813 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && exact_log2 (UINTVAL (operands[2]) & GET_MODE_MASK (HImode))
      == INTVAL (operands[4])
   && ! reload_completed))
        return -1;
      return 1404; /* *shl.and-to-skip.hi */

    case 94:
      if (!
#line 10813 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && exact_log2 (UINTVAL (operands[2]) & GET_MODE_MASK (PSImode))
      == INTVAL (operands[4])
   && ! reload_completed))
        return -1;
      return 1407; /* *shl.and-to-skip.psi */

    case 95:
      if (!
#line 10813 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && exact_log2 (UINTVAL (operands[2]) & GET_MODE_MASK (SImode))
      == INTVAL (operands[4])
   && ! reload_completed))
        return -1;
      return 1410; /* *shl.and-to-skip.si */

    default:
      return -1;
    }
}

 int
recog_51 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_CCmode)
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_MODE (x5) != E_CCmode)
    return -1;
  x6 = XEXP (x5, 1);
  operands[1] = x6;
  x7 = XEXP (x2, 0);
  operands[2] = x7;
  if (!scratch_operand (operands[2], E_QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || !nonmemory_operand (operands[1], E_HImode)
          || !
#line 6819 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 864; /* cmphi3 */

    case E_HQmode:
      if (!register_operand (operands[0], E_HQmode)
          || !nonmemory_operand (operands[1], E_HQmode)
          || !
#line 6819 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 865; /* cmphq3 */

    case E_UHQmode:
      if (!register_operand (operands[0], E_UHQmode)
          || !nonmemory_operand (operands[1], E_UHQmode)
          || !
#line 6819 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 866; /* cmpuhq3 */

    case E_HAmode:
      if (!register_operand (operands[0], E_HAmode)
          || !nonmemory_operand (operands[1], E_HAmode)
          || !
#line 6819 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 867; /* cmpha3 */

    case E_UHAmode:
      if (!register_operand (operands[0], E_UHAmode)
          || !nonmemory_operand (operands[1], E_UHAmode)
          || !
#line 6819 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 868; /* cmpuha3 */

    case E_PSImode:
      if (!register_operand (operands[0], E_PSImode)
          || !nonmemory_operand (operands[1], E_PSImode)
          || !
#line 6854 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 869; /* *cmppsi */

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || !nonmemory_operand (operands[1], E_SImode)
          || !
#line 6886 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 870; /* *cmpsi */

    case E_SQmode:
      if (!register_operand (operands[0], E_SQmode)
          || !nonmemory_operand (operands[1], E_SQmode)
          || !
#line 6886 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 871; /* *cmpsq */

    case E_USQmode:
      if (!register_operand (operands[0], E_USQmode)
          || !nonmemory_operand (operands[1], E_USQmode)
          || !
#line 6886 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 872; /* *cmpusq */

    case E_SAmode:
      if (!register_operand (operands[0], E_SAmode)
          || !nonmemory_operand (operands[1], E_SAmode)
          || !
#line 6886 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 873; /* *cmpsa */

    case E_USAmode:
      if (!register_operand (operands[0], E_USAmode)
          || !nonmemory_operand (operands[1], E_USAmode)
          || !
#line 6886 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 874; /* *cmpusa */

    default:
      return -1;
    }
}

 int
recog_60 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      res = recog_39 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    case ZERO_EXTRACT:
      res = recog_40 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      break;

    default:
      break;
    }
  x5 = XEXP (x2, 0);
  if (GET_CODE (x5) != REG)
    return -1;
  x6 = XEXP (x3, 1);
  if (GET_CODE (x6) == MEM)
    {
      res = recog_41 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
    }
  if (REGNO (x5) != 36
      || GET_MODE (x5) != E_CCmode)
    return -1;
  operands[0] = x4;
  operands[1] = x6;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!nonimmediate_operand (operands[0], E_QImode)
          || !nox_general_operand (operands[1], E_QImode)
          || !
#line 862 "../../gcc-15.1.0/gcc/config/avr/avr.md"
((register_operand (operands[0], QImode)
    || reg_or_0_operand (operands[1], QImode))
   && reload_completed))
        return -1;
      return 116; /* movqi_insn */

    case E_QQmode:
      if (!nonimmediate_operand (operands[0], E_QQmode)
          || !nox_general_operand (operands[1], E_QQmode)
          || !
#line 862 "../../gcc-15.1.0/gcc/config/avr/avr.md"
((register_operand (operands[0], QQmode)
    || reg_or_0_operand (operands[1], QQmode))
   && reload_completed))
        return -1;
      return 117; /* movqq_insn */

    case E_UQQmode:
      if (!nonimmediate_operand (operands[0], E_UQQmode)
          || !nox_general_operand (operands[1], E_UQQmode)
          || !
#line 862 "../../gcc-15.1.0/gcc/config/avr/avr.md"
((register_operand (operands[0], UQQmode)
    || reg_or_0_operand (operands[1], UQQmode))
   && reload_completed))
        return -1;
      return 118; /* movuqq_insn */

    case E_HImode:
      if (!nonimmediate_operand (operands[0], E_HImode)
          || !nox_general_operand (operands[1], E_HImode)
          || !
#line 971 "../../gcc-15.1.0/gcc/config/avr/avr.md"
((register_operand (operands[0], HImode)
    || reg_or_0_operand (operands[1], HImode))
   && reload_completed))
        return -1;
      return 133; /* *movhi */

    case E_HQmode:
      if (!nonimmediate_operand (operands[0], E_HQmode)
          || !nox_general_operand (operands[1], E_HQmode)
          || !
#line 971 "../../gcc-15.1.0/gcc/config/avr/avr.md"
((register_operand (operands[0], HQmode)
    || reg_or_0_operand (operands[1], HQmode))
   && reload_completed))
        return -1;
      return 134; /* *movhq */

    case E_UHQmode:
      if (!nonimmediate_operand (operands[0], E_UHQmode)
          || !nox_general_operand (operands[1], E_UHQmode)
          || !
#line 971 "../../gcc-15.1.0/gcc/config/avr/avr.md"
((register_operand (operands[0], UHQmode)
    || reg_or_0_operand (operands[1], UHQmode))
   && reload_completed))
        return -1;
      return 135; /* *movuhq */

    case E_HAmode:
      if (!nonimmediate_operand (operands[0], E_HAmode)
          || !nox_general_operand (operands[1], E_HAmode)
          || !
#line 971 "../../gcc-15.1.0/gcc/config/avr/avr.md"
((register_operand (operands[0], HAmode)
    || reg_or_0_operand (operands[1], HAmode))
   && reload_completed))
        return -1;
      return 136; /* *movha */

    case E_UHAmode:
      if (!nonimmediate_operand (operands[0], E_UHAmode)
          || !nox_general_operand (operands[1], E_UHAmode)
          || !
#line 971 "../../gcc-15.1.0/gcc/config/avr/avr.md"
((register_operand (operands[0], UHAmode)
    || reg_or_0_operand (operands[1], UHAmode))
   && reload_completed))
        return -1;
      return 137; /* *movuha */

    case E_PSImode:
      if (!nonimmediate_operand (operands[0], E_PSImode)
          || !nox_general_operand (operands[1], E_PSImode)
          || !
#line 1144 "../../gcc-15.1.0/gcc/config/avr/avr.md"
((register_operand (operands[0], PSImode)
    || register_operand (operands[1], PSImode)
    || const0_rtx == operands[1])
   && reload_completed))
        return -1;
      return 140; /* *movpsi */

    case E_SImode:
      if (!nonimmediate_operand (operands[0], E_SImode)
          || !nox_general_operand (operands[1], E_SImode)
          || !
#line 1204 "../../gcc-15.1.0/gcc/config/avr/avr.md"
((register_operand (operands[0], SImode)
    || reg_or_0_operand (operands[1], SImode))
   && reload_completed))
        return -1;
      return 151; /* *movsi */

    case E_SQmode:
      if (!nonimmediate_operand (operands[0], E_SQmode)
          || !nox_general_operand (operands[1], E_SQmode)
          || !
#line 1204 "../../gcc-15.1.0/gcc/config/avr/avr.md"
((register_operand (operands[0], SQmode)
    || reg_or_0_operand (operands[1], SQmode))
   && reload_completed))
        return -1;
      return 152; /* *movsq */

    case E_USQmode:
      if (!nonimmediate_operand (operands[0], E_USQmode)
          || !nox_general_operand (operands[1], E_USQmode)
          || !
#line 1204 "../../gcc-15.1.0/gcc/config/avr/avr.md"
((register_operand (operands[0], USQmode)
    || reg_or_0_operand (operands[1], USQmode))
   && reload_completed))
        return -1;
      return 153; /* *movusq */

    case E_SAmode:
      if (!nonimmediate_operand (operands[0], E_SAmode)
          || !nox_general_operand (operands[1], E_SAmode)
          || !
#line 1204 "../../gcc-15.1.0/gcc/config/avr/avr.md"
((register_operand (operands[0], SAmode)
    || reg_or_0_operand (operands[1], SAmode))
   && reload_completed))
        return -1;
      return 154; /* *movsa */

    case E_USAmode:
      if (!nonimmediate_operand (operands[0], E_USAmode)
          || !nox_general_operand (operands[1], E_USAmode)
          || !
#line 1204 "../../gcc-15.1.0/gcc/config/avr/avr.md"
((register_operand (operands[0], USAmode)
    || reg_or_0_operand (operands[1], USAmode))
   && reload_completed))
        return -1;
      return 155; /* *movusa */

    case E_SFmode:
      if (!nonimmediate_operand (operands[0], E_SFmode)
          || !nox_general_operand (operands[1], E_SFmode)
          || !
#line 1252 "../../gcc-15.1.0/gcc/config/avr/avr.md"
((register_operand (operands[0], SFmode)
    || reg_or_0_operand (operands[1], SFmode))
   && reload_completed))
        return -1;
      return 158; /* *movsf */

    default:
      return -1;
    }
}

 int
recog_64 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case SIGN_EXTEND:
      if (GET_MODE (x5) != E_HImode)
        return -1;
      x6 = XEXP (x4, 1);
      if (GET_CODE (x6) != CONST_INT)
        return -1;
      x7 = XEXP (x3, 0);
      operands[0] = x7;
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x4) != E_HImode)
        return -1;
      x8 = XEXP (x5, 0);
      operands[1] = x8;
      if (!register_operand (operands[1], E_QImode))
        return -1;
      if (XWINT (x6, 0) == 1L)
        {
          x9 = XEXP (x2, 0);
          if (GET_CODE (x9) == REG
              && REGNO (x9) == 36
              && GET_MODE (x9) == E_CCmode
              && 
#line 3081 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return 527; /* *ashiftqihi2.signx.1 */
        }
      x9 = XEXP (x2, 0);
      if (!scratch_operand (x9, E_QImode))
        return -1;
      operands[3] = x9;
      operands[2] = x6;
      if (const_2_to_6_operand (operands[2], E_HImode)
          && 
#line 3092 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
        return 528; /* *ashifthi3.signx.const */
      operands[2] = x9;
      if (XWINT (x6, 0) != 7L
          || !
#line 3110 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
        return -1;
      return 529; /* *ashifthi3.signx.const7 */

    case ZERO_EXTEND:
      if (GET_MODE (x5) != E_HImode)
        return -1;
      x7 = XEXP (x3, 0);
      operands[0] = x7;
      if (pattern224 (x1) != 0
          || !
#line 3128 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
        return -1;
      return 530; /* *ashifthi3.zerox.const */

    case REG:
    case SUBREG:
      operands[1] = x5;
      res = recog_47 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (GET_CODE (x5) != REG)
        return -1;
      switch (pattern170 (x1))
        {
        case 0:
          if (!
#line 642 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3332; /* *ashldi3_insn */

        case 1:
          if (!
#line 642 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3336; /* *ashldq3_insn */

        case 2:
          if (!
#line 642 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3340; /* *ashludq3_insn */

        case 3:
          if (!
#line 642 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3344; /* *ashlda3_insn */

        case 4:
          if (!
#line 642 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3348; /* *ashluda3_insn */

        case 5:
          if (!
#line 642 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3352; /* *ashlta3_insn */

        case 6:
          if (!
#line 642 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
            return -1;
          return 3356; /* *ashluta3_insn */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_69 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != CLOBBER
      || pattern209 (x1, 
E_QImode) != 0)
    return -1;
  x6 = XEXP (x3, 2);
  operands[2] = x6;
  x7 = XEXP (x3, 0);
  switch (GET_CODE (x7))
    {
    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x7;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!reg_or_low_io_operand (operands[1], E_QImode)
              || !const_0_to_7_operand (operands[2], E_QImode)
              || !
#line 10408 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 1149; /* *extzvqi */

        case E_HImode:
          if (!reg_or_low_io_operand (operands[1], E_HImode)
              || !const_0_to_15_operand (operands[2], E_QImode)
              || !
#line 10408 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 1150; /* *extzvhi */

        case E_PSImode:
          if (!reg_or_low_io_operand (operands[1], E_PSImode)
              || !const_0_to_23_operand (operands[2], E_QImode)
              || !
#line 10408 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 1151; /* *extzvpsi */

        case E_SImode:
          if (!reg_or_low_io_operand (operands[1], E_SImode)
              || !const_0_to_31_operand (operands[2], E_QImode)
              || !
#line 10408 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 1152; /* *extzvsi */

        default:
          return -1;
        }

    case NOT:
      if (GET_MODE (x7) != E_QImode)
        return -1;
      x8 = XEXP (x7, 0);
      operands[1] = x8;
      if (!reg_or_low_io_operand (operands[1], E_QImode)
          || !const_0_to_7_operand (operands[2], E_QImode)
          || !
#line 10454 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 1156; /* *extzv.not */

    default:
      return -1;
    }
}

 int
recog_76 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  switch (pattern242 (x1, 
UMOD))
    {
    case 0:
      x2 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x2) != SET)
        return -1;
      x3 = XEXP (x2, 1);
      if (GET_CODE (x3) != UMOD)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != REG
          || REGNO (x4) != 24)
        return -1;
      x5 = XEXP (x3, 1);
      if (GET_CODE (x5) != REG
          || REGNO (x5) != 22)
        return -1;
      x6 = XEXP (x2, 0);
      if (GET_CODE (x6) != REG)
        return -1;
      x7 = XVECEXP (x1, 0, 0);
      x8 = XEXP (x7, 0);
      switch (REGNO (x8))
        {
        case 24:
          if (pattern379 (x1, 
E_QImode, 
E_CCmode, 
36, 
23, 
25) != 0
              || !
#line 3978 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 589; /* *udivmodqi4_call */

        case 22:
          if (pattern379 (x1, 
E_HImode, 
E_QImode, 
21, 
26, 
24) != 0)
            return -1;
          return 594; /* *udivmodhi4_call_split */

        default:
          return -1;
        }

    case 1:
      switch (pattern324 (x1))
        {
        case 0:
          if (!
#line 625 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(reload_completed))
            return -1;
          return 3122; /* *udivsa3.call */

        case 1:
          if (!
#line 625 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(reload_completed))
            return -1;
          return 3124; /* *udivusa3.call */

        default:
          return -1;
        }

    case 2:
      return 616; /* *udivmodsi4_call_split */

    case 3:
      if (!
#line 577 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(reload_completed))
        return -1;
      return 3110; /* *udivhq3.call */

    case 4:
      if (!
#line 577 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(reload_completed))
        return -1;
      return 3112; /* *udivuhq3.call */

    case 5:
      if (!
#line 577 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(reload_completed))
        return -1;
      return 3114; /* *udivha3.call */

    case 6:
      if (!
#line 577 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(reload_completed))
        return -1;
      return 3116; /* *udivuha3.call */

    default:
      return -1;
    }
}

 int
recog_82 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != PLUS)
    return -1;
  x5 = XEXP (x3, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x6 = XEXP (x2, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 36)
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x7) != SET)
    return -1;
  x8 = XEXP (x7, 1);
  if (GET_CODE (x8) != PLUS)
    return -1;
  x9 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x9) != CLOBBER)
    return -1;
  x10 = XEXP (x4, 0);
  operands[3] = x10;
  x11 = XEXP (x4, 1);
  operands[1] = x11;
  x12 = XEXP (x7, 0);
  operands[0] = x12;
  x13 = XEXP (x8, 0);
  operands[4] = x13;
  x14 = XEXP (x8, 1);
  operands[5] = x14;
  x15 = XEXP (x9, 0);
  operands[2] = x15;
  if (!scratch_operand (operands[2], E_QImode))
    return -1;
  switch (GET_MODE (x6))
    {
    case E_CCZNmode:
      if (GET_MODE (x3) != E_CCZNmode)
        return -1;
      switch (GET_MODE (x4))
        {
        case E_HImode:
          if (pattern380 (x8, 
E_HImode) != 0
              || !
#line 7334 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 916; /* *add.for.cczn.hi */

        case E_PSImode:
          if (pattern380 (x8, 
E_PSImode) != 0
              || !
#line 7334 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 917; /* *add.for.cczn.psi */

        case E_SImode:
          if (pattern380 (x8, 
E_SImode) != 0
              || !
#line 7334 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 918; /* *add.for.cczn.si */

        default:
          return -1;
        }

    case E_CCNmode:
      if (GET_MODE (x3) != E_CCNmode)
        return -1;
      switch (GET_MODE (x4))
        {
        case E_HImode:
          if (pattern364 (x8, 
E_HImode) != 0
              || !
#line 7353 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 919; /* *add.for.ccn.hi */

        case E_PSImode:
          if (pattern364 (x8, 
E_PSImode) != 0
              || !
#line 7353 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 920; /* *add.for.ccn.psi */

        case E_SImode:
          if (pattern364 (x8, 
E_SImode) != 0
              || !
#line 7353 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 921; /* *add.for.ccn.si */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_85 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case SET:
      return recog_84 (x1, insn, pnum_clobbers);

    case UNSPEC_VOLATILE:
      x3 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x3) != SET)
        return -1;
      switch (XVECLEN (x2, 0))
        {
        case 1:
          if (pnum_clobbers == NULL
              || pattern175 (x1) != 0)
            return -1;
          x4 = XEXP (x3, 1);
          x5 = XEXP (x4, 1);
          operands[0] = x5;
          if (!immediate_operand (operands[0], E_HImode))
            return -1;
          x6 = XVECEXP (x1, 0, 2);
          x7 = XEXP (x6, 1);
          x8 = XEXP (x7, 1);
          if (!rtx_equal_p (x8, operands[0]))
            return -1;
          *pnum_clobbers = 2;
          return 997; /* epilogue_restores */

        case 2:
          x4 = XEXP (x3, 1);
          if (GET_CODE (x4) != UNSPEC_VOLATILE
              || XVECLEN (x4, 0) != 1)
            return -1;
          x9 = XVECEXP (x2, 0, 0);
          operands[0] = x9;
          switch (XINT (x2, 1))
            {
            case 3:
              if (pnum_clobbers == NULL
                  || pattern279 (x1) != 0
                  || !
#line 8673 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_gasisr_prologues))
                return -1;
              *pnum_clobbers = 1;
              return 998; /* *gasisr */

            case 10:
              switch (pattern246 (x1))
                {
                case 0:
                  return 1003; /* delay_cycles_1 */

                case 1:
                  return 1005; /* delay_cycles_2 */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_89 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x3) != CLOBBER)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x4))
    {
    case SET:
      x5 = XVECEXP (x1, 0, 3);
      if (GET_CODE (x5) != CLOBBER)
        return -1;
      x6 = XEXP (x3, 0);
      if (GET_CODE (x6) != REG)
        return -1;
      x7 = XEXP (x4, 1);
      switch (GET_CODE (x7))
        {
        case CONST_INT:
          if (XWINT (x7, 0) != 0L
              || pattern174 (x1) != 0
              || REGNO (x6) != 36
              || GET_MODE (x6) != E_CCmode)
            return -1;
          switch (pattern288 (x1))
            {
            case 0:
              if (!
#line 1476 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
                return -1;
              return 169; /* *clrmemqi */

            case 1:
              if (!
#line 1510 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
                return -1;
              return 171; /* *clrmemhi */

            default:
              return -1;
            }

        case DIV:
          if (pattern226 (x1, 
MOD) != 0)
            return -1;
          x8 = XEXP (x4, 0);
          operands[0] = x8;
          switch (pattern342 (x1))
            {
            case 0:
              return 584; /* divmodqi4 */

            case 1:
              return 590; /* divmodhi4 */

            case 2:
              return 612; /* divmodsi4 */

            default:
              break;
            }
          x9 = XEXP (x2, 0);
          if (REGNO (x9) != 26
              || pattern343 (x1) != 0
              || !
#line 4324 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 608; /* *divmodpsi4_call */

        case UDIV:
          if (pattern226 (x1, 
UMOD) != 0)
            return -1;
          x8 = XEXP (x4, 0);
          operands[0] = x8;
          switch (pattern342 (x1))
            {
            case 0:
              return 587; /* udivmodqi4 */

            case 1:
              return 593; /* udivmodhi4 */

            case 2:
              return 615; /* udivmodsi4 */

            default:
              break;
            }
          x9 = XEXP (x2, 0);
          if (REGNO (x9) != 26
              || pattern343 (x1) != 0
              || !
#line 4373 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 611; /* *udivmodpsi4_call */

        default:
          return -1;
        }

    case UNSPEC_VOLATILE:
      switch (XVECLEN (x4, 0))
        {
        case 1:
          if (pattern149 (x1) != 0)
            return -1;
          x10 = XVECEXP (x1, 0, 2);
          x11 = XEXP (x10, 0);
          if (GET_MODE (x11) != E_HImode)
            return -1;
          x5 = XVECEXP (x1, 0, 3);
          if (GET_CODE (x5) != USE
              || pattern369 (x1, 
E_CCmode, 
36) != 0)
            return -1;
          x12 = XVECEXP (x1, 0, 1);
          operands[0] = x12;
          if (!immediate_operand (operands[0], E_HImode))
            return -1;
          x13 = XEXP (x10, 1);
          x14 = XEXP (x13, 1);
          operands[1] = x14;
          if (!immediate_operand (operands[1], E_HImode))
            return -1;
          return 996; /* call_prologue_saves */

        case 2:
          if (XINT (x4, 1) != 10)
            return -1;
          x15 = XVECEXP (x4, 0, 1);
          if (GET_CODE (x15) != CONST_INT)
            return -1;
          x12 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x12) != SET)
            return -1;
          x16 = XEXP (x12, 1);
          if (GET_CODE (x16) != UNSPEC_VOLATILE
              || XVECLEN (x16, 0) != 1
              || XINT (x16, 1) != 6
              || GET_MODE (x16) != E_BLKmode)
            return -1;
          x10 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x10) != CLOBBER)
            return -1;
          x5 = XVECEXP (x1, 0, 3);
          if (GET_CODE (x5) != CLOBBER
              || pattern247 (x1) != 0)
            return -1;
          switch (XWINT (x15, 0))
            {
            case 3L:
              x6 = XEXP (x3, 0);
              if (GET_CODE (x6) != REG
                  || REGNO (x6) != 36
                  || GET_MODE (x6) != E_CCmode
                  || !
#line 8837 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
                return -1;
              return 1008; /* *delay_cycles_3 */

            case 4L:
              x6 = XEXP (x3, 0);
              operands[5] = x6;
              if (!scratch_operand (operands[5], E_QImode))
                return -1;
              return 1009; /* delay_cycles_4 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_2 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  switch (GET_CODE (x3))
    {
    case SIGN_EXTEND:
      switch (pattern130 (x2))
        {
        case 0:
          if (!(
#line 2015 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(2 > 1) && 
#line 2017 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_135 (insn, operands);

        case 1:
          if (!(
#line 2015 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(3 > 1) && 
#line 2017 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_137 (insn, operands);

        case 2:
          if (!(
#line 2015 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(3 > 2) && 
#line 2017 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_141 (insn, operands);

        case 3:
          if (!(
#line 2015 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(4 > 1) && 
#line 2017 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_139 (insn, operands);

        case 4:
          if (!(
#line 2015 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(4 > 2) && 
#line 2017 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_143 (insn, operands);

        case 5:
          if (!(
#line 2015 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(4 > 3) && 
#line 2017 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_145 (insn, operands);

        default:
          return NULL;
        }

    case ZERO_EXTEND:
      switch (pattern130 (x2))
        {
        case 0:
          if (!(
#line 2015 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(2 > 1) && 
#line 2017 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_136 (insn, operands);

        case 1:
          if (!(
#line 2015 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(3 > 1) && 
#line 2017 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_138 (insn, operands);

        case 2:
          if (!(
#line 2015 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(3 > 2) && 
#line 2017 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_142 (insn, operands);

        case 3:
          if (!(
#line 2015 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(4 > 1) && 
#line 2017 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_140 (insn, operands);

        case 4:
          if (!(
#line 2015 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(4 > 2) && 
#line 2017 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_144 (insn, operands);

        case 5:
          if (!(
#line 2015 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(4 > 3) && 
#line 2017 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_146 (insn, operands);

        default:
          return NULL;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[2] = x3;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      switch (GET_MODE (operands[0]))
        {
        case E_PSImode:
          if (pattern192 (x2, 
E_PSImode) != 0
              || !
#line 2077 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_148 (insn, operands);

        case E_QImode:
          if (pattern213 (x2, 
E_QImode) != 0
              || !
#line 2104 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_149 (insn, operands);

        case E_QQmode:
          if (pattern213 (x2, 
E_QQmode) != 0
              || !
#line 2104 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_150 (insn, operands);

        case E_UQQmode:
          if (pattern213 (x2, 
E_UQQmode) != 0
              || !
#line 2104 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_151 (insn, operands);

        default:
          return NULL;
        }

    case LSHIFTRT:
      switch (pattern131 (x2))
        {
        case 0:
          if (!
#line 2299 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_166 (insn, operands);

        case 1:
          if (!
#line 2299 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_168 (insn, operands);

        case 2:
          if (!
#line 2299 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_170 (insn, operands);

        case 3:
          if (!
#line 2299 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_172 (insn, operands);

        case 4:
          if (!(
#line 2350 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(2 > 1) && 
#line 2352 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_194 (insn, operands);

        case 5:
          if (!(
#line 2350 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(3 > 1) && 
#line 2352 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_196 (insn, operands);

        case 6:
          if (!(
#line 2350 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(3 > 2) && 
#line 2352 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_200 (insn, operands);

        case 7:
          if (!(
#line 2350 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(4 > 1) && 
#line 2352 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_198 (insn, operands);

        case 8:
          if (!(
#line 2350 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(4 > 2) && 
#line 2352 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_202 (insn, operands);

        case 9:
          if (!(
#line 2350 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(4 > 3) && 
#line 2352 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_204 (insn, operands);

        default:
          return NULL;
        }

    case ASHIFTRT:
      switch (pattern131 (x2))
        {
        case 0:
          if (!
#line 2299 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_167 (insn, operands);

        case 1:
          if (!
#line 2299 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_169 (insn, operands);

        case 2:
          if (!
#line 2299 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_171 (insn, operands);

        case 3:
          if (!
#line 2299 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_173 (insn, operands);

        case 4:
          if (!(
#line 2350 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(2 > 1) && 
#line 2352 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_195 (insn, operands);

        case 5:
          if (!(
#line 2350 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(3 > 1) && 
#line 2352 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_197 (insn, operands);

        case 6:
          if (!(
#line 2350 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(3 > 2) && 
#line 2352 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_201 (insn, operands);

        case 7:
          if (!(
#line 2350 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(4 > 1) && 
#line 2352 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_199 (insn, operands);

        case 8:
          if (!(
#line 2350 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(4 > 2) && 
#line 2352 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_203 (insn, operands);

        case 9:
          if (!(
#line 2350 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(4 > 3) && 
#line 2352 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_205 (insn, operands);

        default:
          return NULL;
        }

    case GE:
      switch (pattern133 (x2))
        {
        case 0:
          if (!
#line 2422 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_238 (insn, operands);

        case 1:
          if (!
#line 2422 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_246 (insn, operands);

        case 2:
          if (!
#line 2422 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_254 (insn, operands);

        case 3:
          if (!
#line 2422 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_262 (insn, operands);

        case 4:
          if (!
#line 2422 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_240 (insn, operands);

        case 5:
          if (!
#line 2422 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_248 (insn, operands);

        case 6:
          if (!
#line 2422 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_256 (insn, operands);

        case 7:
          if (!
#line 2422 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_264 (insn, operands);

        case 8:
          if (!
#line 2422 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_242 (insn, operands);

        case 9:
          if (!
#line 2422 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_250 (insn, operands);

        case 10:
          if (!
#line 2422 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_258 (insn, operands);

        case 11:
          if (!
#line 2422 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_266 (insn, operands);

        case 12:
          if (!
#line 2422 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_244 (insn, operands);

        case 13:
          if (!
#line 2422 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_252 (insn, operands);

        case 14:
          if (!
#line 2422 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_260 (insn, operands);

        case 15:
          if (!
#line 2422 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_268 (insn, operands);

        default:
          return NULL;
        }

    case LT:
      switch (pattern133 (x2))
        {
        case 0:
          if (!
#line 2422 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_239 (insn, operands);

        case 1:
          if (!
#line 2422 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_247 (insn, operands);

        case 2:
          if (!
#line 2422 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_255 (insn, operands);

        case 3:
          if (!
#line 2422 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_263 (insn, operands);

        case 4:
          if (!
#line 2422 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_241 (insn, operands);

        case 5:
          if (!
#line 2422 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_249 (insn, operands);

        case 6:
          if (!
#line 2422 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_257 (insn, operands);

        case 7:
          if (!
#line 2422 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_265 (insn, operands);

        case 8:
          if (!
#line 2422 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_243 (insn, operands);

        case 9:
          if (!
#line 2422 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_251 (insn, operands);

        case 10:
          if (!
#line 2422 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_259 (insn, operands);

        case 11:
          if (!
#line 2422 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_267 (insn, operands);

        case 12:
          if (!
#line 2422 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_245 (insn, operands);

        case 13:
          if (!
#line 2422 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_253 (insn, operands);

        case 14:
          if (!
#line 2422 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_261 (insn, operands);

        case 15:
          if (!
#line 2422 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_269 (insn, operands);

        default:
          return NULL;
        }

    case MULT:
      x4 = XEXP (x2, 0);
      operands[3] = x4;
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          if (pattern190 (x2) != 0
              || !register_operand (operands[2], E_QImode)
              || !(
#line 2618 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 2620 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_278 (insn, operands);

        case SIGN_EXTEND:
          if (pattern211 (x2) != 0)
            return NULL;
          x6 = XEXP (x3, 1);
          switch (GET_CODE (x6))
            {
            case SIGN_EXTEND:
              x7 = XEXP (x6, 0);
              operands[2] = x7;
              if (!register_operand (operands[2], E_QImode)
                  || !(
#line 2730 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 2732 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_283 (insn, operands);

            case ZERO_EXTEND:
              x7 = XEXP (x6, 0);
              operands[2] = x7;
              if (!register_operand (operands[2], E_QImode)
                  || !(
#line 2794 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL
   && reload_completed
   && SIGN_EXTEND != ZERO_EXTEND) && 
#line 2798 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_288 (insn, operands);

            default:
              return NULL;
            }

        case ZERO_EXTEND:
          if (pattern211 (x2) != 0)
            return NULL;
          x6 = XEXP (x3, 1);
          switch (GET_CODE (x6))
            {
            case ZERO_EXTEND:
              x7 = XEXP (x6, 0);
              operands[2] = x7;
              if (!register_operand (operands[2], E_QImode)
                  || !(
#line 2730 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 2732 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_284 (insn, operands);

            case SIGN_EXTEND:
              x7 = XEXP (x6, 0);
              operands[2] = x7;
              if (!register_operand (operands[2], E_QImode)
                  || !(
#line 2794 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL
   && reload_completed
   && ZERO_EXTEND != SIGN_EXTEND) && 
#line 2798 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_287 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_13 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[1] = x3;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      x5 = XEXP (x2, 1);
      operands[2] = x5;
      switch (GET_MODE (operands[0]))
        {
        case E_QImode:
          if (pattern192 (x2, 
E_QImode) == 0
              && (
#line 2205 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 2207 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
            return gen_split_162 (insn, operands);
          break;

        case E_HImode:
          if (pattern192 (x2, 
E_HImode) == 0
              && (
#line 3273 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 3275 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
            return gen_split_310 (insn, operands);
          break;

        case E_QQmode:
          if (pattern192 (x2, 
E_QQmode) == 0
              && (
#line 296 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL) && 
#line 298 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
            return gen_split_1821 (insn, operands);
          break;

        case E_UQQmode:
          if (pattern192 (x2, 
E_UQQmode) == 0
              && (
#line 317 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL) && 
#line 319 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
            return gen_split_1822 (insn, operands);
          break;

        default:
          break;
        }
      if (GET_CODE (x3) != REG
          || REGNO (x3) != 16
          || GET_CODE (x5) != REG
          || REGNO (x5) != 20
          || GET_CODE (x4) != REG)
        return NULL;
      switch (pattern25 (x1, 
24))
        {
        case 0:
          if (!(
#line 468 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL) && 
#line 470 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
            return NULL;
          return gen_split_1828 (insn, operands);

        case 1:
          if (!(
#line 468 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL) && 
#line 470 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
            return NULL;
          return gen_split_1829 (insn, operands);

        default:
          return NULL;
        }

    case SIGN_EXTEND:
      switch (pattern31 (x1))
        {
        case 0:
          x6 = XEXP (x3, 0);
          operands[1] = x6;
          if (register_operand (operands[1], E_QImode))
            {
              res = split_3 (x1, insn);
              if (res != NULL_RTX)
                return res;
            }
          if (GET_CODE (x6) != REG)
            return NULL;
          x4 = XEXP (x1, 0);
          if (GET_CODE (x4) != REG)
            return NULL;
          switch (REGNO (x6))
            {
            case 18:
              if (GET_MODE (x6) != E_HImode)
                return NULL;
              x5 = XEXP (x2, 1);
              if (GET_CODE (x5) != SIGN_EXTEND
                  || pattern249 (x5, 
E_HImode, 
E_SImode) != 0
                  || pattern198 (x1, 
E_SImode, 
22) != 0
                  || !(
#line 3775 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 3777 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_337 (insn, operands);

            case 26:
              if (pattern199 (x1, 
E_SImode, 
22, 
18, 
E_HImode) != 0
                  || !(
#line 3846 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 3848 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_342 (insn, operands);

            case 25:
              if (pattern199 (x1, 
E_PSImode, 
18, 
22, 
E_QImode) != 0
                  || !(
#line 4225 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 4227 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_357 (insn, operands);

            default:
              return NULL;
            }

        case 1:
          if (!(
#line 10870 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed) && 
#line 10874 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_975 (insn, operands);

        case 2:
          if (!(
#line 10870 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed) && 
#line 10874 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_977 (insn, operands);

        case 3:
          if (!(
#line 10870 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed) && 
#line 10874 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_981 (insn, operands);

        case 4:
          if (!(
#line 10870 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed) && 
#line 10874 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_979 (insn, operands);

        case 5:
          if (!(
#line 10870 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed) && 
#line 10874 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_983 (insn, operands);

        case 6:
          if (!(
#line 10870 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed) && 
#line 10874 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_985 (insn, operands);

        default:
          return NULL;
        }

    case ZERO_EXTEND:
      switch (pattern31 (x1))
        {
        case 0:
          x4 = XEXP (x1, 0);
          operands[0] = x4;
          res = split_4 (x1, insn);
          if (res != NULL_RTX)
            return res;
          x6 = XEXP (x3, 0);
          if (GET_CODE (x6) != REG)
            return NULL;
          switch (pattern134 (x1))
            {
            case 0:
              if (!(
#line 3775 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 3777 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_338 (insn, operands);

            case 1:
              if (!(
#line 3825 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 3827 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_341 (insn, operands);

            case 2:
              if (!(
#line 3846 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 3848 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_343 (insn, operands);

            default:
              return NULL;
            }

        case 1:
          if (!(
#line 10870 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed) && 
#line 10874 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_976 (insn, operands);

        case 2:
          if (!(
#line 10870 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed) && 
#line 10874 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_978 (insn, operands);

        case 3:
          if (!(
#line 10870 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed) && 
#line 10874 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_982 (insn, operands);

        case 4:
          if (!(
#line 10870 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed) && 
#line 10874 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_980 (insn, operands);

        case 5:
          if (!(
#line 10870 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed) && 
#line 10874 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_984 (insn, operands);

        case 6:
          if (!(
#line 10870 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed) && 
#line 10874 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_986 (insn, operands);

        default:
          return NULL;
        }

    case NOT:
      x6 = XEXP (x3, 0);
      if (GET_CODE (x6) != ZERO_EXTEND)
        return NULL;
      x7 = XEXP (x6, 0);
      if (GET_CODE (x7) != NOT)
        return NULL;
      if (GET_MODE (x7) == E_QImode)
        {
          res = split_5 (x1, insn);
          if (res != NULL_RTX)
            return res;
        }
      if (GET_MODE (x7) != E_HImode
          || pattern163 (x1) != 0
          || !(
#line 3867 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 3869 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_344 (insn, operands);

    case AND:
      switch (pattern33 (x1))
        {
        case 0:
          if (!(
#line 10840 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10843 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_955 (insn, operands);

        case 1:
          if (!(
#line 10840 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10843 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_959 (insn, operands);

        case 2:
          if (!(
#line 10840 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10843 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_963 (insn, operands);

        case 3:
          if (!(
#line 10840 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10843 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_967 (insn, operands);

        case 4:
          if (!(
#line 10840 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10843 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_956 (insn, operands);

        case 5:
          if (!(
#line 10840 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10843 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_960 (insn, operands);

        case 6:
          if (!(
#line 10840 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10843 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_964 (insn, operands);

        case 7:
          if (!(
#line 10840 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10843 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_968 (insn, operands);

        case 8:
          if (!(
#line 10840 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10843 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_957 (insn, operands);

        case 9:
          if (!(
#line 10840 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10843 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_961 (insn, operands);

        case 10:
          if (!(
#line 10840 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10843 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_965 (insn, operands);

        case 11:
          if (!(
#line 10840 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10843 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_969 (insn, operands);

        case 12:
          if (!(
#line 10840 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10843 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_958 (insn, operands);

        case 13:
          if (!(
#line 10840 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10843 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_962 (insn, operands);

        case 14:
          if (!(
#line 10840 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10843 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_966 (insn, operands);

        case 15:
          if (!(
#line 10840 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed) && 
#line 10843 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_970 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_16 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  rtx_insn *res ATTRIBUTE_UNUSED;
  switch (pattern17 (x1))
    {
    case 0:
      x2 = XEXP (x1, 1);
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      switch (pattern88 (x1))
        {
        case 0:
          if (
#line 6223 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
            return gen_split_540 (insn, operands);
          break;

        case 1:
          if (
#line 6259 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
            return gen_split_542 (insn, operands);
          break;

        case 2:
          if (
#line 6279 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
            return gen_split_543 (insn, operands);
          break;

        case 3:
          if (
#line 6300 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
            return gen_split_544 (insn, operands);
          break;

        case 4:
          if (
#line 6334 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
            return gen_split_545 (insn, operands);
          break;

        default:
          break;
        }
      switch (GET_CODE (x3))
        {
        case SUBREG:
          switch (pattern89 (x1))
            {
            case 0:
              if (!(
#line 10547 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(! reload_completed) && 
#line 10549 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_747 (insn, operands);

            case 1:
              if (!(
#line 10547 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(! reload_completed) && 
#line 10549 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_748 (insn, operands);

            case 2:
              if (!(
#line 10547 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(! reload_completed) && 
#line 10549 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_749 (insn, operands);

            case 3:
              if (!(
#line 10547 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(! reload_completed) && 
#line 10549 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_750 (insn, operands);

            default:
              return NULL;
            }

        case REG:
          if (REGNO (x3) != 18
              || GET_MODE (x3) != E_DImode
              || pattern34 (x1, 
E_DImode, 
18) != 0
              || !(
#line 421 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 423 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1919 (insn, operands);

        default:
          return NULL;
        }

    case 1:
      if (!
#line 6241 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_541 (insn, operands);

    case 2:
      if (!(
#line 10675 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed) && 
#line 10679 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_790 (insn, operands);

    case 3:
      if (!(
#line 10675 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed) && 
#line 10679 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_791 (insn, operands);

    case 4:
      if (!(
#line 10675 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed) && 
#line 10679 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_792 (insn, operands);

    case 5:
      if (!(
#line 10675 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed) && 
#line 10679 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_793 (insn, operands);

    case 6:
      if (!(
#line 10675 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed) && 
#line 10679 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_794 (insn, operands);

    case 7:
      if (!(
#line 10675 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed) && 
#line 10679 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_795 (insn, operands);

    case 8:
      if (!(
#line 10675 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed) && 
#line 10679 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_796 (insn, operands);

    case 9:
      if (!(
#line 10675 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed) && 
#line 10679 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_797 (insn, operands);

    case 10:
      if (!(
#line 10675 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed) && 
#line 10679 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_802 (insn, operands);

    case 11:
      if (!(
#line 10675 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed) && 
#line 10679 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_803 (insn, operands);

    case 12:
      if (!(
#line 10675 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed) && 
#line 10679 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_804 (insn, operands);

    case 13:
      if (!(
#line 10675 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed) && 
#line 10679 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_805 (insn, operands);

    case 14:
      if (!(
#line 10675 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed) && 
#line 10679 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_798 (insn, operands);

    case 15:
      if (!(
#line 10675 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed) && 
#line 10679 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_799 (insn, operands);

    case 16:
      if (!(
#line 10675 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed) && 
#line 10679 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_800 (insn, operands);

    case 17:
      if (!(
#line 10675 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed) && 
#line 10679 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_801 (insn, operands);

    case 18:
      if (!(
#line 10675 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed) && 
#line 10679 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_806 (insn, operands);

    case 19:
      if (!(
#line 10675 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed) && 
#line 10679 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_807 (insn, operands);

    case 20:
      if (!(
#line 10675 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed) && 
#line 10679 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_808 (insn, operands);

    case 21:
      if (!(
#line 10675 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed) && 
#line 10679 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_809 (insn, operands);

    case 22:
      if (!(
#line 10675 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed) && 
#line 10679 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_810 (insn, operands);

    case 23:
      if (!(
#line 10675 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed) && 
#line 10679 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_811 (insn, operands);

    case 24:
      if (!(
#line 10675 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed) && 
#line 10679 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_812 (insn, operands);

    case 25:
      if (!(
#line 10675 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed) && 
#line 10679 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
        return NULL;
      return gen_split_813 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_20 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return NULL;
  x4 = XEXP (x2, 0);
  switch (GET_CODE (x4))
    {
    case XOR:
      switch (pattern93 (x1))
        {
        case 0:
          if (!(
#line 10133 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(INTVAL (operands[4]) & (1 << INTVAL (operands[3]))) && 
#line 10135 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_666 (insn, operands);

        case 1:
          if (!(
#line 10509 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(! reload_completed
   && ((1 << INTVAL (operands[3])) & INTVAL (operands[2])) != 0) && 
#line 10512 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_742 (insn, operands);

        default:
          return NULL;
        }

    case REG:
    case SUBREG:
    case MEM:
      operands[1] = x4;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      switch (pattern181 (x2))
        {
        case 0:
          if (
#line 10387 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
            return gen_split_720 (insn, operands);
          break;

        case 1:
          if (
#line 10387 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
            return gen_split_721 (insn, operands);
          break;

        case 2:
          if (
#line 10387 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
            return gen_split_722 (insn, operands);
          break;

        case 3:
          if (
#line 10387 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
            return gen_split_723 (insn, operands);
          break;

        case 4:
          return gen_split_724 (insn, operands);

        case 5:
          return gen_split_725 (insn, operands);

        default:
          break;
        }
      if (GET_CODE (x4) != SUBREG)
        return NULL;
      switch (pattern139 (x1))
        {
        case 0:
          if (!(
#line 10486 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(! reload_completed
   && IN_RANGE (UINTVAL(operands[2]) & GET_MODE_MASK(HImode),
                1U << (8 * 0), 0x80U << (8 * 0))
   && exact_log2 (UINTVAL(operands[2]) & GET_MODE_MASK(HImode))
      == 8 * 0 + INTVAL (operands[3])) && 
#line 10492 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_730 (insn, operands);

        case 1:
          if (!(
#line 10486 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(! reload_completed
   && IN_RANGE (UINTVAL(operands[2]) & GET_MODE_MASK(PSImode),
                1U << (8 * 0), 0x80U << (8 * 0))
   && exact_log2 (UINTVAL(operands[2]) & GET_MODE_MASK(PSImode))
      == 8 * 0 + INTVAL (operands[3])) && 
#line 10492 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_734 (insn, operands);

        case 2:
          if (!(
#line 10486 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(! reload_completed
   && IN_RANGE (UINTVAL(operands[2]) & GET_MODE_MASK(SImode),
                1U << (8 * 0), 0x80U << (8 * 0))
   && exact_log2 (UINTVAL(operands[2]) & GET_MODE_MASK(SImode))
      == 8 * 0 + INTVAL (operands[3])) && 
#line 10492 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_738 (insn, operands);

        case 3:
          if (!(
#line 10486 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(! reload_completed
   && IN_RANGE (UINTVAL(operands[2]) & GET_MODE_MASK(HImode),
                1U << (8 * 1), 0x80U << (8 * 1))
   && exact_log2 (UINTVAL(operands[2]) & GET_MODE_MASK(HImode))
      == 8 * 1 + INTVAL (operands[3])) && 
#line 10492 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_731 (insn, operands);

        case 4:
          if (!(
#line 10486 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(! reload_completed
   && IN_RANGE (UINTVAL(operands[2]) & GET_MODE_MASK(PSImode),
                1U << (8 * 1), 0x80U << (8 * 1))
   && exact_log2 (UINTVAL(operands[2]) & GET_MODE_MASK(PSImode))
      == 8 * 1 + INTVAL (operands[3])) && 
#line 10492 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_735 (insn, operands);

        case 5:
          if (!(
#line 10486 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(! reload_completed
   && IN_RANGE (UINTVAL(operands[2]) & GET_MODE_MASK(SImode),
                1U << (8 * 1), 0x80U << (8 * 1))
   && exact_log2 (UINTVAL(operands[2]) & GET_MODE_MASK(SImode))
      == 8 * 1 + INTVAL (operands[3])) && 
#line 10492 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_739 (insn, operands);

        case 6:
          if (!(
#line 10486 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(! reload_completed
   && IN_RANGE (UINTVAL(operands[2]) & GET_MODE_MASK(HImode),
                1U << (8 * 2), 0x80U << (8 * 2))
   && exact_log2 (UINTVAL(operands[2]) & GET_MODE_MASK(HImode))
      == 8 * 2 + INTVAL (operands[3])) && 
#line 10492 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_732 (insn, operands);

        case 7:
          if (!(
#line 10486 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(! reload_completed
   && IN_RANGE (UINTVAL(operands[2]) & GET_MODE_MASK(PSImode),
                1U << (8 * 2), 0x80U << (8 * 2))
   && exact_log2 (UINTVAL(operands[2]) & GET_MODE_MASK(PSImode))
      == 8 * 2 + INTVAL (operands[3])) && 
#line 10492 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_736 (insn, operands);

        case 8:
          if (!(
#line 10486 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(! reload_completed
   && IN_RANGE (UINTVAL(operands[2]) & GET_MODE_MASK(SImode),
                1U << (8 * 2), 0x80U << (8 * 2))
   && exact_log2 (UINTVAL(operands[2]) & GET_MODE_MASK(SImode))
      == 8 * 2 + INTVAL (operands[3])) && 
#line 10492 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_740 (insn, operands);

        case 9:
          if (!(
#line 10486 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(! reload_completed
   && IN_RANGE (UINTVAL(operands[2]) & GET_MODE_MASK(HImode),
                1U << (8 * 3), 0x80U << (8 * 3))
   && exact_log2 (UINTVAL(operands[2]) & GET_MODE_MASK(HImode))
      == 8 * 3 + INTVAL (operands[3])) && 
#line 10492 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_733 (insn, operands);

        case 10:
          if (!(
#line 10486 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(! reload_completed
   && IN_RANGE (UINTVAL(operands[2]) & GET_MODE_MASK(PSImode),
                1U << (8 * 3), 0x80U << (8 * 3))
   && exact_log2 (UINTVAL(operands[2]) & GET_MODE_MASK(PSImode))
      == 8 * 3 + INTVAL (operands[3])) && 
#line 10492 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_737 (insn, operands);

        case 11:
          if (!(
#line 10486 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(! reload_completed
   && IN_RANGE (UINTVAL(operands[2]) & GET_MODE_MASK(SImode),
                1U << (8 * 3), 0x80U << (8 * 3))
   && exact_log2 (UINTVAL(operands[2]) & GET_MODE_MASK(SImode))
      == 8 * 3 + INTVAL (operands[3])) && 
#line 10492 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_741 (insn, operands);

        default:
          return NULL;
        }

    case NOT:
      if (pattern94 (x1) != 0
          || !
#line 10441 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_726 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_30 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != REG)
    return NULL;
  x5 = XEXP (x2, 0);
  if (GET_CODE (x5) != REG)
    return NULL;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  if (REGNO (x7) != 22)
    return NULL;
  switch (pattern338 (x1))
    {
    case 0:
      if (!(
#line 3315 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(!AVR_HAVE_MUL) && 
#line 3317 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
        return NULL;
      return gen_split_311 (insn, operands);

    case 1:
      if (!(
#line 377 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(!AVR_HAVE_MUL) && 
#line 379 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1823 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_32 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x2) != CLOBBER)
    return NULL;
  x3 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x3))
    {
    case SET:
      x4 = XEXP (x2, 0);
      if (GET_CODE (x4) != REG)
        return NULL;
      x5 = XEXP (x3, 1);
      switch (GET_CODE (x5))
        {
        case MEM:
          if (pattern104 (x3) != 0)
            return NULL;
          x6 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x6) != CLOBBER)
            return NULL;
          x7 = XEXP (x6, 0);
          if (GET_CODE (x7) != REG
              || REGNO (x7) != 21
              || GET_MODE (x7) != E_QImode)
            return NULL;
          switch (pattern375 (x1))
            {
            case 0:
              if (!(
#line 715 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)) && 
#line 718 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_47 (insn, operands);

            case 1:
              if (!(
#line 715 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)) && 
#line 718 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_48 (insn, operands);

            case 2:
              if (!(
#line 715 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)) && 
#line 718 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_49 (insn, operands);

            case 3:
              if (!(
#line 715 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)) && 
#line 718 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_50 (insn, operands);

            case 4:
              if (!(
#line 715 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)) && 
#line 718 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_51 (insn, operands);

            case 5:
              if (!(
#line 715 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)) && 
#line 718 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_52 (insn, operands);

            case 6:
              if (!(
#line 715 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)) && 
#line 718 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_53 (insn, operands);

            case 7:
              if (!(
#line 715 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)) && 
#line 718 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_54 (insn, operands);

            case 8:
              if (!(
#line 715 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)) && 
#line 718 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_55 (insn, operands);

            case 9:
              if (!(
#line 715 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)) && 
#line 718 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_56 (insn, operands);

            case 10:
              if (!(
#line 715 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)) && 
#line 718 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_57 (insn, operands);

            case 11:
              if (!(
#line 715 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)) && 
#line 718 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_58 (insn, operands);

            case 12:
              if (!(
#line 715 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)) && 
#line 718 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_59 (insn, operands);

            case 13:
              if (!(
#line 715 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)) && 
#line 718 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_60 (insn, operands);

            case 14:
              if (!(
#line 715 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, true)
    || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, true)) && 
#line 718 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
                return NULL;
              return gen_split_61 (insn, operands);

            default:
              return NULL;
            }

        case MULT:
          x6 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x6) != CLOBBER)
            return NULL;
          x7 = XEXP (x6, 0);
          if (GET_CODE (x7) != REG)
            return NULL;
          x8 = XEXP (x5, 0);
          switch (GET_CODE (x8))
            {
            case ZERO_EXTEND:
              x9 = XEXP (x8, 0);
              if (GET_CODE (x9) == REG)
                {
                  switch (pattern267 (x1))
                    {
                    case 0:
                      if ((
#line 2437 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(!AVR_HAVE_MUL) && 
#line 2439 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
                        return gen_split_270 (insn, operands);
                      break;

                    case 1:
                      if ((
#line 675 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && AVR_HAVE_MUL) && 
#line 678 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
( reload_completed)))
                        return gen_split_1964 (insn, operands);
                      break;

                    default:
                      break;
                    }
                }
              if (GET_MODE (x8) != E_SImode)
                return NULL;
              switch (pattern271 (x1))
                {
                case 0:
                  if (!(
#line 3483 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed) && 
#line 3485 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
                    return NULL;
                  return gen_split_314 (insn, operands);

                case 1:
                  if (!(
#line 3483 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed) && 
#line 3485 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
                    return NULL;
                  return gen_split_315 (insn, operands);

                case 2:
                  if (!(
#line 3646 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed) && 
#line 3648 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
                    return NULL;
                  return gen_split_320 (insn, operands);

                case 3:
                  if (!(
#line 3646 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed) && 
#line 3648 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
                    return NULL;
                  return gen_split_328 (insn, operands);

                case 4:
                  if (!(
#line 3646 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed) && 
#line 3648 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
                    return NULL;
                  return gen_split_324 (insn, operands);

                case 5:
                  if (!(
#line 3646 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed) && 
#line 3648 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
                    return NULL;
                  return gen_split_332 (insn, operands);

                case 6:
                  if (!(
#line 3646 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed) && 
#line 3648 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
                    return NULL;
                  return gen_split_322 (insn, operands);

                case 7:
                  if (!(
#line 3646 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed) && 
#line 3648 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
                    return NULL;
                  return gen_split_330 (insn, operands);

                case 8:
                  if (!(
#line 3646 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed) && 
#line 3648 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
                    return NULL;
                  return gen_split_326 (insn, operands);

                case 9:
                  if (!(
#line 3646 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed) && 
#line 3648 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
                    return NULL;
                  return gen_split_334 (insn, operands);

                default:
                  return NULL;
                }

            case REG:
            case SUBREG:
              if (GET_CODE (x8) == REG
                  && REGNO (x8) == 24)
                {
                  res = split_30 (x1, insn);
                  if (res != NULL_RTX)
                    return res;
                }
              operands[1] = x8;
              switch (pattern264 (x1))
                {
                case 0:
                  if (!(
#line 3403 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed) && 
#line 3405 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
                    return NULL;
                  return gen_split_312 (insn, operands);

                case 1:
                  if (!(
#line 4197 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed) && 
#line 4199 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
                    return NULL;
                  return gen_split_356 (insn, operands);

                default:
                  return NULL;
                }

            case SIGN_EXTEND:
              if (REGNO (x7) != 26
                  || GET_MODE (x7) != E_HImode)
                return NULL;
              if (REGNO (x4) == 18)
                {
                  switch (pattern304 (x1))
                    {
                    case 0:
                      if ((
#line 3535 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed) && 
#line 3537 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
                        return gen_split_316 (insn, operands);
                      break;

                    case 1:
                      if ((
#line 3535 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed) && 
#line 3537 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
                        return gen_split_317 (insn, operands);
                      break;

                    case 2:
                      if ((
#line 4178 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed) && 
#line 4180 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
                        return gen_split_355 (insn, operands);
                      break;

                    case 3:
                      if ((
#line 3646 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed) && 
#line 3648 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
                        return gen_split_319 (insn, operands);
                      break;

                    case 4:
                      if ((
#line 3646 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed) && 
#line 3648 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
                        return gen_split_327 (insn, operands);
                      break;

                    case 5:
                      if ((
#line 3646 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed) && 
#line 3648 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
                        return gen_split_323 (insn, operands);
                      break;

                    case 6:
                      if ((
#line 3646 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed) && 
#line 3648 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
                        return gen_split_331 (insn, operands);
                      break;

                    case 7:
                      if ((
#line 3646 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed) && 
#line 3648 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
                        return gen_split_321 (insn, operands);
                      break;

                    case 8:
                      if ((
#line 3646 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed) && 
#line 3648 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
                        return gen_split_329 (insn, operands);
                      break;

                    case 9:
                      if ((
#line 3646 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed) && 
#line 3648 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
                        return gen_split_325 (insn, operands);
                      break;

                    case 10:
                      if ((
#line 3646 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed) && 
#line 3648 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
                        return gen_split_333 (insn, operands);
                      break;

                    default:
                      break;
                    }
                }
              x9 = XEXP (x8, 0);
              if (GET_CODE (x9) != REG
                  || pattern305 (x1) != 0
                  || !(
#line 675 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && AVR_HAVE_MUL) && 
#line 678 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
( reload_completed)))
                return NULL;
              return gen_split_1963 (insn, operands);

            case NOT:
              if (pattern244 (x1) != 0
                  || !(
#line 3594 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed) && 
#line 3596 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
                return NULL;
              return gen_split_318 (insn, operands);

            default:
              return NULL;
            }

        case UDIV:
          x8 = XEXP (x5, 0);
          if (GET_CODE (x8) != REG)
            return NULL;
          x10 = XEXP (x5, 1);
          if (GET_CODE (x10) != REG)
            return NULL;
          x11 = XEXP (x3, 0);
          if (GET_CODE (x11) != REG)
            return NULL;
          switch (REGNO (x8))
            {
            case 24:
              switch (pattern275 (x1))
                {
                case 0:
                  if (!
#line 3967 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
                    return NULL;
                  return gen_split_348 (insn, operands);

                case 1:
                  if (!
#line 610 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed))
                    return NULL;
                  return gen_split_1842 (insn, operands);

                case 2:
                  if (!
#line 610 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed))
                    return NULL;
                  return gen_split_1844 (insn, operands);

                default:
                  return NULL;
                }

            case 26:
              switch (pattern278 (x1))
                {
                case 0:
                  if (!
#line 562 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed))
                    return NULL;
                  return gen_split_1834 (insn, operands);

                case 1:
                  if (!
#line 562 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed))
                    return NULL;
                  return gen_split_1836 (insn, operands);

                case 2:
                  if (!
#line 562 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed))
                    return NULL;
                  return gen_split_1838 (insn, operands);

                case 3:
                  if (!
#line 562 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed))
                    return NULL;
                  return gen_split_1840 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        case XOR:
          switch (pattern184 (x1))
            {
            case 0:
              if (!
#line 4915 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(optimize
   && reload_completed))
                return NULL;
              return gen_split_387 (insn, operands);

            case 1:
              if (!
#line 4915 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(optimize
   && reload_completed))
                return NULL;
              return gen_split_390 (insn, operands);

            case 2:
              if (!
#line 4915 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(optimize
   && reload_completed))
                return NULL;
              return gen_split_393 (insn, operands);

            default:
              return NULL;
            }

        case IOR:
          switch (pattern184 (x1))
            {
            case 0:
              if (!
#line 4915 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(optimize
   && reload_completed))
                return NULL;
              return gen_split_388 (insn, operands);

            case 1:
              if (!
#line 4915 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(optimize
   && reload_completed))
                return NULL;
              return gen_split_391 (insn, operands);

            case 2:
              if (!
#line 4915 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(optimize
   && reload_completed))
                return NULL;
              return gen_split_394 (insn, operands);

            default:
              return NULL;
            }

        case AND:
          switch (pattern184 (x1))
            {
            case 0:
              if (!
#line 4915 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(optimize
   && reload_completed))
                return NULL;
              return gen_split_389 (insn, operands);

            case 1:
              if (!
#line 4915 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(optimize
   && reload_completed))
                return NULL;
              return gen_split_392 (insn, operands);

            case 2:
              if (!
#line 4915 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(optimize
   && reload_completed))
                return NULL;
              return gen_split_395 (insn, operands);

            default:
              return NULL;
            }

        case LSHIFTRT:
          switch (pattern186 (x1))
            {
            case 0:
              if (!
#line 5620 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2r (operands[2])))
                return NULL;
              return gen_split_468 (insn, operands);

            case 1:
              if (!
#line 5620 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4r (operands[2])))
                return NULL;
              return gen_split_471 (insn, operands);

            case 2:
              if (!
#line 5620 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C3r (operands[2])))
                return NULL;
              return gen_split_474 (insn, operands);

            case 3:
              if (!
#line 5620 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2r (operands[2])))
                return NULL;
              return gen_split_477 (insn, operands);

            case 4:
              if (!
#line 5620 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2r (operands[2])))
                return NULL;
              return gen_split_480 (insn, operands);

            case 5:
              if (!
#line 5620 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2r (operands[2])))
                return NULL;
              return gen_split_483 (insn, operands);

            case 6:
              if (!
#line 5620 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2r (operands[2])))
                return NULL;
              return gen_split_486 (insn, operands);

            case 7:
              if (!
#line 5620 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4r (operands[2])))
                return NULL;
              return gen_split_489 (insn, operands);

            case 8:
              if (!
#line 5620 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4r (operands[2])))
                return NULL;
              return gen_split_492 (insn, operands);

            case 9:
              if (!
#line 5620 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4r (operands[2])))
                return NULL;
              return gen_split_495 (insn, operands);

            case 10:
              if (!
#line 5620 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4r (operands[2])))
                return NULL;
              return gen_split_498 (insn, operands);

            default:
              return NULL;
            }

        case ASHIFTRT:
          switch (pattern186 (x1))
            {
            case 0:
              if (!
#line 5620 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2a (operands[2])))
                return NULL;
              return gen_split_469 (insn, operands);

            case 1:
              if (!
#line 5620 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4a (operands[2])))
                return NULL;
              return gen_split_472 (insn, operands);

            case 2:
              if (!
#line 5620 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C3a (operands[2])))
                return NULL;
              return gen_split_475 (insn, operands);

            case 3:
              if (!
#line 5620 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2a (operands[2])))
                return NULL;
              return gen_split_478 (insn, operands);

            case 4:
              if (!
#line 5620 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2a (operands[2])))
                return NULL;
              return gen_split_481 (insn, operands);

            case 5:
              if (!
#line 5620 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2a (operands[2])))
                return NULL;
              return gen_split_484 (insn, operands);

            case 6:
              if (!
#line 5620 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2a (operands[2])))
                return NULL;
              return gen_split_487 (insn, operands);

            case 7:
              if (!
#line 5620 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4a (operands[2])))
                return NULL;
              return gen_split_490 (insn, operands);

            case 8:
              if (!
#line 5620 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4a (operands[2])))
                return NULL;
              return gen_split_493 (insn, operands);

            case 9:
              if (!
#line 5620 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4a (operands[2])))
                return NULL;
              return gen_split_496 (insn, operands);

            case 10:
              if (!
#line 5620 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4a (operands[2])))
                return NULL;
              return gen_split_499 (insn, operands);

            default:
              return NULL;
            }

        case ASHIFT:
          switch (pattern186 (x1))
            {
            case 0:
              if (!
#line 5620 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2l (operands[2])))
                return NULL;
              return gen_split_470 (insn, operands);

            case 1:
              if (!
#line 5620 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4l (operands[2])))
                return NULL;
              return gen_split_473 (insn, operands);

            case 2:
              if (!
#line 5620 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C3l (operands[2])))
                return NULL;
              return gen_split_476 (insn, operands);

            case 3:
              if (!
#line 5620 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2l (operands[2])))
                return NULL;
              return gen_split_479 (insn, operands);

            case 4:
              if (!
#line 5620 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2l (operands[2])))
                return NULL;
              return gen_split_482 (insn, operands);

            case 5:
              if (!
#line 5620 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2l (operands[2])))
                return NULL;
              return gen_split_485 (insn, operands);

            case 6:
              if (!
#line 5620 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C2l (operands[2])))
                return NULL;
              return gen_split_488 (insn, operands);

            case 7:
              if (!
#line 5620 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4l (operands[2])))
                return NULL;
              return gen_split_491 (insn, operands);

            case 8:
              if (!
#line 5620 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4l (operands[2])))
                return NULL;
              return gen_split_494 (insn, operands);

            case 9:
              if (!
#line 5620 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4l (operands[2])))
                return NULL;
              return gen_split_497 (insn, operands);

            case 10:
              if (!
#line 5620 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_split_bit_shift
   && n_avr_fuse_add_executed >= 1
   && satisfies_constraint_C4l (operands[2])))
                return NULL;
              return gen_split_500 (insn, operands);

            default:
              return NULL;
            }

        case TRUNCATE:
          if (pattern107 (x3, 
24, 
E_HImode) != 0)
            return NULL;
          x6 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x6) != CLOBBER)
            return NULL;
          x7 = XEXP (x6, 0);
          if (GET_CODE (x7) != REG
              || pattern309 (x1, 
E_QImode, 
26, 
22) != 0)
            return NULL;
          x8 = XEXP (x5, 0);
          switch (pattern353 (x8))
            {
            case 0:
              if (!
#line 9475 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
                return NULL;
              return gen_split_649 (insn, operands);

            case 1:
              if (!
#line 9547 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
                return NULL;
              return gen_split_651 (insn, operands);

            default:
              return NULL;
            }

        case DIV:
          x8 = XEXP (x5, 0);
          if (GET_CODE (x8) != REG)
            return NULL;
          x10 = XEXP (x5, 1);
          if (GET_CODE (x10) != REG)
            return NULL;
          x11 = XEXP (x3, 0);
          if (GET_CODE (x11) != REG)
            return NULL;
          x6 = XVECEXP (x1, 0, 1);
          if (pattern100 (x6, 
26, 
E_HImode) != 0)
            return NULL;
          switch (REGNO (x8))
            {
            case 26:
              if (REGNO (x10) != 22
                  || REGNO (x11) != 24)
                return NULL;
              switch (pattern276 (x1, 
E_QImode, 
21))
                {
                case 0:
                  if (!
#line 562 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed))
                    return NULL;
                  return gen_split_1835 (insn, operands);

                case 1:
                  if (!
#line 562 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed))
                    return NULL;
                  return gen_split_1837 (insn, operands);

                case 2:
                  if (!
#line 562 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed))
                    return NULL;
                  return gen_split_1839 (insn, operands);

                case 3:
                  if (!
#line 562 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed))
                    return NULL;
                  return gen_split_1841 (insn, operands);

                default:
                  return NULL;
                }

            case 24:
              if (REGNO (x10) != 18
                  || REGNO (x11) != 22)
                return NULL;
              switch (pattern273 (x1))
                {
                case 0:
                  if (!
#line 610 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed))
                    return NULL;
                  return gen_split_1843 (insn, operands);

                case 1:
                  if (!
#line 610 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed))
                    return NULL;
                  return gen_split_1845 (insn, operands);

                default:
                  return NULL;
                }

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case UNSPEC_VOLATILE:
      if (XVECLEN (x3, 0) != 2
          || XINT (x3, 1) != 10)
        return NULL;
      x12 = XVECEXP (x3, 0, 1);
      if (GET_CODE (x12) != CONST_INT)
        return NULL;
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != SET)
        return NULL;
      x13 = XEXP (x6, 1);
      if (pattern103 (x13) != 0)
        return NULL;
      x14 = XVECEXP (x3, 0, 0);
      operands[0] = x14;
      switch (pattern245 (x1))
        {
        case 0:
          if (!
#line 8747 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_624 (insn, operands);

        case 1:
          if (!
#line 8779 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_625 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
