/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern2 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x6 = XEXP (x4, 0);
  operands[1] = x6;
  x7 = XEXP (x2, 1);
  operands[2] = x7;
  if (!const_int_operand (operands[2], E_QImode))
    return -1;
  x8 = XEXP (x1, 1);
  operands[3] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode
          || GET_MODE (x2) != E_HImode
          || GET_MODE (x3) != E_HImode
          || GET_MODE (x4) != E_QImode
          || !register_operand (operands[1], E_QImode)
          || !register_operand (operands[3], E_HImode))
        return -1;
      return 0;

    case E_PSImode:
      if (!register_operand (operands[0], E_PSImode)
          || GET_MODE (x1) != E_PSImode
          || GET_MODE (x2) != E_PSImode
          || GET_MODE (x3) != E_PSImode)
        return -1;
      res = pattern0 (x4);
      if (res >= 0)
        return res + 1; /* [1, 2] */
      return -1;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || GET_MODE (x2) != E_SImode
          || GET_MODE (x3) != E_SImode)
        return -1;
      res = pattern1 (x4);
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    default:
      return -1;
    }
}

int
pattern22 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 24)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 24)
    return -1;
  switch (GET_MODE (x4))
    {
    case E_HImode:
      if (GET_MODE (x2) != E_HImode
          || GET_MODE (x3) != E_HImode)
        return -1;
      return 0;

    case E_QImode:
      if (GET_MODE (x2) != E_QImode
          || GET_MODE (x3) != E_QImode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern27 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 3);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 26
      || GET_MODE (x3) != E_HImode)
    return -1;
  x4 = XVECEXP (x1, 0, 4);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 30
      || GET_MODE (x5) != E_HImode)
    return -1;
  x6 = XVECEXP (x1, 0, 5);
  if (GET_CODE (x6) != CLOBBER)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 0
      || GET_MODE (x7) != E_QImode)
    return -1;
  x8 = XVECEXP (x1, 0, 6);
  if (GET_CODE (x8) != CLOBBER)
    return -1;
  return 0;
}

int
pattern31 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      return 0;

    case AND:
      x5 = XEXP (x4, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x6 = XEXP (x1, 0);
      operands[0] = x6;
      x7 = XEXP (x4, 0);
      operands[1] = x7;
      x8 = XEXP (x2, 1);
      operands[2] = x8;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (!register_operand (operands[0], E_HImode)
              || GET_MODE (x2) != E_HImode
              || GET_MODE (x3) != E_HImode
              || GET_MODE (x4) != E_QImode
              || !register_operand (operands[1], E_QImode)
              || !nonmemory_operand (operands[2], E_HImode))
            return -1;
          return 1;

        case E_PSImode:
          if (!register_operand (operands[0], E_PSImode)
              || GET_MODE (x2) != E_PSImode
              || GET_MODE (x3) != E_PSImode
              || !nonmemory_operand (operands[2], E_PSImode))
            return -1;
          switch (GET_MODE (x4))
            {
            case E_QImode:
              if (!register_operand (operands[1], E_QImode))
                return -1;
              return 2;

            case E_HImode:
              if (!register_operand (operands[1], E_HImode))
                return -1;
              return 3;

            default:
              return -1;
            }

        case E_SImode:
          if (!register_operand (operands[0], E_SImode)
              || GET_MODE (x2) != E_SImode
              || GET_MODE (x3) != E_SImode
              || !nonmemory_operand (operands[2], E_SImode))
            return -1;
          res = pattern30 (x4);
          if (res >= 0)
            return res + 4; /* [4, 6] */
          return -1;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern53 (rtx x1, int *pnum_clobbers, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !register_operand (operands[0], E_PSImode)
      || GET_MODE (x1) != E_PSImode
      || !register_operand (operands[1], E_PSImode)
      || !nonmemory_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern58 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + -2])
    return -1;
  x5 = XEXP (x3, 1);
  if (GET_CODE (x5) != AND
      || GET_MODE (x5) != E_QImode)
    return -1;
  x6 = XEXP (x5, 1);
  if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 7])
    return -1;
  x7 = XEXP (x1, 0);
  operands[0] = x7;
  if (!register_operand (operands[0], E_QImode)
      || GET_MODE (x2) != E_QImode)
    return -1;
  x8 = XEXP (x5, 0);
  operands[1] = x8;
  if (!register_operand (operands[1], E_QImode))
    return -1;
  return 0;
}

int
pattern64 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_UQQmode:
      return pattern61 (x1, 
E_UQQmode); /* [-1, 0] */

    case E_UHQmode:
      if (pattern61 (x1, 
E_UHQmode) != 0)
        return -1;
      return 1;

    case E_UHAmode:
      if (pattern61 (x1, 
E_UHAmode) != 0)
        return -1;
      return 2;

    case E_USAmode:
      if (pattern61 (x1, 
E_USAmode) != 0)
        return -1;
      return 3;

    case E_USQmode:
      if (pattern61 (x1, 
E_USQmode) != 0)
        return -1;
      return 4;

    default:
      return -1;
    }
}

int
pattern71 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  operands[0] = x3;
  x4 = XEXP (x1, 0);
  switch (GET_MODE (x4))
    {
    case E_DImode:
      if (GET_MODE (x2) != E_DImode)
        return -1;
      x5 = XEXP (x2, 0);
      if (GET_MODE (x5) != E_DImode
          || !const_operand (operands[0], E_DImode))
        return -1;
      return 0;

    case E_DQmode:
      if (GET_MODE (x2) != E_DQmode)
        return -1;
      x5 = XEXP (x2, 0);
      if (GET_MODE (x5) != E_DQmode
          || !const_operand (operands[0], E_DQmode))
        return -1;
      return 1;

    case E_UDQmode:
      if (GET_MODE (x2) != E_UDQmode)
        return -1;
      x5 = XEXP (x2, 0);
      if (GET_MODE (x5) != E_UDQmode
          || !const_operand (operands[0], E_UDQmode))
        return -1;
      return 2;

    case E_DAmode:
      if (GET_MODE (x2) != E_DAmode)
        return -1;
      x5 = XEXP (x2, 0);
      if (GET_MODE (x5) != E_DAmode
          || !const_operand (operands[0], E_DAmode))
        return -1;
      return 3;

    case E_UDAmode:
      if (GET_MODE (x2) != E_UDAmode)
        return -1;
      x5 = XEXP (x2, 0);
      if (GET_MODE (x5) != E_UDAmode
          || !const_operand (operands[0], E_UDAmode))
        return -1;
      return 4;

    case E_TAmode:
      if (GET_MODE (x2) != E_TAmode)
        return -1;
      x5 = XEXP (x2, 0);
      if (GET_MODE (x5) != E_TAmode
          || !const_operand (operands[0], E_TAmode))
        return -1;
      return 5;

    case E_UTAmode:
      if (GET_MODE (x2) != E_UTAmode)
        return -1;
      x5 = XEXP (x2, 0);
      if (GET_MODE (x5) != E_UTAmode
          || !const_operand (operands[0], E_UTAmode))
        return -1;
      return 6;

    default:
      return -1;
    }
}

int
pattern84 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !register_operand (operands[1], i1)
      || !nonmemory_operand (operands[2], i1)
      || !register_operand (operands[3], i1))
    return -1;
  return 0;
}

int
pattern89 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (maybe_ne (SUBREG_BYTE (x3), 0)
      || GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != ASHIFTRT)
    return -1;
  x5 = XEXP (x1, 0);
  operands[0] = x5;
  if (!register_operand (operands[0], E_QImode)
      || GET_MODE (x2) != E_QImode)
    return -1;
  x6 = XEXP (x4, 0);
  operands[1] = x6;
  x7 = XEXP (x4, 1);
  operands[2] = x7;
  switch (GET_MODE (x4))
    {
    case E_QImode:
      if (!register_operand (operands[1], E_QImode)
          || !const7_operand (operands[2], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[1], E_HImode)
          || !const15_operand (operands[2], E_QImode))
        return -1;
      return 1;

    case E_PSImode:
      if (!register_operand (operands[1], E_PSImode)
          || !const23_operand (operands[2], E_QImode))
        return -1;
      return 2;

    case E_SImode:
      if (!register_operand (operands[1], E_SImode)
          || !const31_operand (operands[2], E_QImode))
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern97 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != E_QImode)
    return -1;
  x5 = XEXP (x4, 1);
  if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x6 = XEXP (x3, 1);
  if (GET_CODE (x6) != UNSPEC
      || XVECLEN (x6, 0) != 1
      || XINT (x6, 1) != 3
      || GET_MODE (x6) != E_QImode)
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x7) != USE
      || !register_operand (operands[0], E_QImode)
      || GET_MODE (x3) != E_QImode)
    return -1;
  x8 = XEXP (x4, 2);
  operands[2] = x8;
  if (!const_0_to_7_operand (operands[2], E_QImode))
    return -1;
  x9 = XVECEXP (x6, 0, 0);
  operands[3] = x9;
  if (!register_operand (operands[3], E_QImode))
    return -1;
  x10 = XEXP (x7, 0);
  operands[4] = x10;
  if (!nonmemory_operand (operands[4], E_QImode))
    return -1;
  x11 = XEXP (x4, 0);
  switch (GET_CODE (x11))
    {
    case REG:
    case SUBREG:
      operands[1] = x11;
      if (!register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case NOT:
      if (GET_MODE (x11) != E_QImode)
        return -1;
      x12 = XEXP (x11, 0);
      operands[1] = x12;
      if (!register_operand (operands[1], E_QImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern113 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !const_int_operand (operands[2], E_QImode)
      || !scratch_operand (operands[3], E_QImode))
    return -1;
  return 0;
}

int
pattern119 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (XVECLEN (x3, 0) != 1
      || XINT (x3, 1) != 2
      || GET_MODE (x3) != E_HImode)
    return -1;
  x4 = XEXP (x2, 0);
  if (GET_CODE (x4) != PC)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x5) != USE)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != LABEL_REF)
    return -1;
  return 0;
}

int
pattern125 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], E_QImode)
      || !register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern128 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  switch (GET_CODE (x4))
    {
    case REG:
    case SUBREG:
      operands[1] = x4;
      if (!register_operand (operands[1], E_QImode)
          || !register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode
          || GET_MODE (x2) != E_HImode
          || GET_MODE (x3) != E_HImode)
        return -1;
      x5 = XEXP (x1, 1);
      if (!register_operand (x5, E_HImode))
        return -1;
      x6 = XEXP (x2, 1);
      switch (GET_CODE (x6))
        {
        case ZERO_EXTEND:
          if (GET_MODE (x6) != E_HImode)
            return -1;
          x7 = XEXP (x6, 0);
          operands[2] = x7;
          if (!register_operand (operands[2], E_QImode))
            return -1;
          operands[3] = x5;
          return 0;

        case SIGN_EXTEND:
          if (GET_MODE (x6) != E_HImode)
            return -1;
          x7 = XEXP (x6, 0);
          operands[2] = x7;
          if (!register_operand (operands[2], E_QImode))
            return -1;
          operands[3] = x5;
          return 1;

        case CONST_INT:
          return 2;

        default:
          return -1;
        }

    case AND:
      x8 = XEXP (x4, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x9 = XEXP (x4, 0);
      operands[1] = x9;
      x6 = XEXP (x2, 1);
      operands[2] = x6;
      x5 = XEXP (x1, 1);
      operands[3] = x5;
      res = pattern85 (x1);
      if (res >= 0)
        return res + 3; /* [3, 8] */
      return -1;

    default:
      return -1;
    }
}

int
pattern137 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_QImode)
    return -1;
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x4 = XEXP (x2, 0);
  operands[0] = x4;
  if (!register_operand (operands[0], E_QImode))
    return -1;
  x5 = XEXP (x2, 2);
  operands[1] = x5;
  if (!const_0_to_7_operand (operands[1], E_QImode))
    return -1;
  x6 = XEXP (x1, 1);
  if (GET_MODE (x6) != E_QImode)
    return -1;
  x7 = XEXP (x6, 0);
  operands[2] = x7;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  x8 = XEXP (x6, 2);
  operands[3] = x8;
  if (!const_0_to_7_operand (operands[3], E_QImode))
    return -1;
  return 0;
}

int
pattern144 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  switch (GET_MODE (x2))
    {
    case E_QQmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_QQmode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_QQmode)
        return -1;
      x5 = XEXP (x3, 1);
      if (GET_MODE (x5) != E_QQmode)
        return -1;
      return 0;

    case E_UQQmode:
      x3 = XEXP (x1, 1);
      if (GET_MODE (x3) != E_UQQmode)
        return -1;
      x4 = XEXP (x3, 0);
      if (GET_MODE (x4) != E_UQQmode)
        return -1;
      x5 = XEXP (x3, 1);
      if (GET_MODE (x5) != E_UQQmode)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern152 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[1], E_QImode)
      || !register_operand (operands[0], E_QImode)
      || GET_MODE (x1) != E_QImode)
    return -1;
  x2 = XEXP (x1, 1);
  operands[2] = x2;
  if (!nonmemory_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern155 (rtx x1, unsigned int i1, machine_mode i2, machine_mode i3, unsigned int i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i4
      || GET_MODE (x3) != i3)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != i1
      || GET_MODE (x5) != i2)
    return -1;
  return 0;
}

int
pattern159 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (x1))
    {
    case E_QImode:
      if (!memory_operand (operands[0], E_QImode))
        return -1;
      return 0;

    case E_QQmode:
      if (!memory_operand (operands[0], E_QQmode))
        return -1;
      return 1;

    case E_UQQmode:
      if (!memory_operand (operands[0], E_UQQmode))
        return -1;
      return 2;

    case E_HImode:
      if (!memory_operand (operands[0], E_HImode))
        return -1;
      return 3;

    case E_HQmode:
      if (!memory_operand (operands[0], E_HQmode))
        return -1;
      return 4;

    case E_UHQmode:
      if (!memory_operand (operands[0], E_UHQmode))
        return -1;
      return 5;

    case E_HAmode:
      if (!memory_operand (operands[0], E_HAmode))
        return -1;
      return 6;

    case E_UHAmode:
      if (!memory_operand (operands[0], E_UHAmode))
        return -1;
      return 7;

    case E_SImode:
      if (!memory_operand (operands[0], E_SImode))
        return -1;
      return 8;

    case E_SQmode:
      if (!memory_operand (operands[0], E_SQmode))
        return -1;
      return 9;

    case E_USQmode:
      if (!memory_operand (operands[0], E_USQmode))
        return -1;
      return 10;

    case E_SAmode:
      if (!memory_operand (operands[0], E_SAmode))
        return -1;
      return 11;

    case E_USAmode:
      if (!memory_operand (operands[0], E_USAmode))
        return -1;
      return 12;

    case E_SFmode:
      if (!memory_operand (operands[0], E_SFmode))
        return -1;
      return 13;

    case E_PSImode:
      if (!memory_operand (operands[0], E_PSImode))
        return -1;
      return 14;

    default:
      return -1;
    }
}

int
pattern175 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  if (XINT (x2, 1) != 1
      || GET_MODE (x2) != E_QImode)
    return -1;
  x3 = XVECEXP (x2, 0, 0);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 1);
  if (GET_CODE (x5) != PLUS
      || GET_MODE (x5) != E_HImode)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG
      || REGNO (x6) != 28
      || GET_MODE (x6) != E_HImode)
    return -1;
  x7 = XEXP (x4, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 28
      || GET_MODE (x7) != E_HImode)
    return -1;
  x8 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x8) != SET)
    return -1;
  x9 = XEXP (x8, 1);
  if (GET_CODE (x9) != PLUS
      || GET_MODE (x9) != E_HImode)
    return -1;
  x10 = XEXP (x9, 0);
  if (GET_CODE (x10) != REG
      || REGNO (x10) != 28
      || GET_MODE (x10) != E_HImode)
    return -1;
  x11 = XEXP (x8, 0);
  if (GET_CODE (x11) != REG
      || REGNO (x11) != 32
      || GET_MODE (x11) != E_HImode)
    return -1;
  return 0;
}

int
pattern186 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 2);
  x4 = XEXP (x3, 0);
  if (REGNO (x4) != 36
      || GET_MODE (x4) != E_CCmode)
    return -1;
  x5 = XVECEXP (x1, 0, 0);
  x6 = XEXP (x5, 0);
  operands[0] = x6;
  x7 = XEXP (x5, 1);
  x8 = XEXP (x7, 0);
  operands[1] = x8;
  x9 = XEXP (x7, 1);
  operands[2] = x9;
  if (!const_int_operand (operands[2], E_QImode))
    return -1;
  x10 = XEXP (x2, 0);
  operands[3] = x10;
  if (!scratch_or_dreg_operand (operands[3], E_QImode))
    return -1;
  return pattern185 (x7); /* [-1, 10] */
}

int
pattern192 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !register_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern194 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_HImode)
      || GET_MODE (x1) != E_HImode)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_HImode)
    return -1;
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], E_QImode))
    return -1;
  x4 = XEXP (x1, 1);
  if (GET_MODE (x4) != E_HImode)
    return -1;
  x5 = XEXP (x4, 0);
  operands[2] = x5;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern199 (rtx x1, machine_mode i1, unsigned int i2, unsigned int i3, machine_mode i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i4)
    return -1;
  x5 = XEXP (x2, 1);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != i3
      || GET_MODE (x5) != i1
      || pattern198 (x1, 
i1, 
i2) != 0)
    return -1;
  return 0;
}

int
pattern204 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  if (REGNO (x4) != 18)
    return -1;
  x5 = XEXP (x2, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 18)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 36
      || GET_MODE (x7) != E_CCmode)
    return -1;
  return 0;
}

int
pattern211 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_HImode
      || !register_operand (operands[0], E_HImode)
      || GET_MODE (x1) != E_HImode
      || !register_operand (operands[3], E_HImode)
      || GET_MODE (x2) != E_HImode)
    return -1;
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_QImode))
    return -1;
  x5 = XEXP (x2, 1);
  if (GET_MODE (x5) != E_HImode)
    return -1;
  return 0;
}

int
pattern219 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 36
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XEXP (x5, 1);
  x8 = XEXP (x7, 0);
  operands[2] = x8;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x5) != E_HImode
          || !register_operand (operands[1], E_HImode)
          || GET_MODE (x7) != E_HImode
          || !register_operand (operands[2], E_QImode))
        return -1;
      return 0;

    case E_PSImode:
      if (!register_operand (operands[0], E_PSImode)
          || GET_MODE (x5) != E_PSImode
          || !register_operand (operands[1], E_PSImode)
          || GET_MODE (x7) != E_PSImode)
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_QImode:
          if (!register_operand (operands[2], E_QImode))
            return -1;
          return 1;

        case E_HImode:
          if (!register_operand (operands[2], E_HImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x5) != E_SImode
          || !register_operand (operands[1], E_SImode)
          || GET_MODE (x7) != E_SImode)
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_QImode:
          if (!register_operand (operands[2], E_QImode))
            return -1;
          return 3;

        case E_HImode:
          if (!register_operand (operands[2], E_HImode))
            return -1;
          return 4;

        case E_PSImode:
          if (!register_operand (operands[2], E_PSImode))
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern239 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != 18)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 18)
    return -1;
  x5 = XEXP (x2, 1);
  switch (GET_CODE (x5))
    {
    case REG:
      if (REGNO (x5) != 10)
        return -1;
      switch (GET_MODE (x4))
        {
        case E_UDQmode:
          if (GET_MODE (x2) != E_UDQmode
              || GET_MODE (x3) != E_UDQmode
              || GET_MODE (x5) != E_UDQmode)
            return -1;
          return 0;

        case E_UDAmode:
          if (GET_MODE (x2) != E_UDAmode
              || GET_MODE (x3) != E_UDAmode
              || GET_MODE (x5) != E_UDAmode)
            return -1;
          return 1;

        case E_UTAmode:
          if (GET_MODE (x2) != E_UTAmode
              || GET_MODE (x3) != E_UTAmode
              || GET_MODE (x5) != E_UTAmode)
            return -1;
          return 2;

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
      operands[0] = x5;
      switch (GET_MODE (x4))
        {
        case E_UDQmode:
          if (GET_MODE (x2) != E_UDQmode
              || GET_MODE (x3) != E_UDQmode
              || !const_operand (operands[0], E_UDQmode))
            return -1;
          return 3;

        case E_UDAmode:
          if (GET_MODE (x2) != E_UDAmode
              || GET_MODE (x3) != E_UDAmode
              || !const_operand (operands[0], E_UDAmode))
            return -1;
          return 4;

        case E_UTAmode:
          if (GET_MODE (x2) != E_UTAmode
              || GET_MODE (x3) != E_UTAmode
              || !const_operand (operands[0], E_UTAmode))
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern252 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  operands[3] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      return pattern251 (x5, 
E_HImode); /* [-1, 0] */

    case E_SImode:
      if (!register_operand (operands[0], E_SImode))
        return -1;
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (GET_MODE (x5) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      switch (GET_MODE (operands[3]))
        {
        case E_HImode:
          if (!scratch_operand (operands[3], E_HImode))
            return -1;
          return 1;

        case E_QImode:
          if (!scratch_operand (operands[3], E_QImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_PSImode:
      x4 = XVECEXP (x1, 0, 0);
      x5 = XEXP (x4, 1);
      if (pattern251 (x5, 
E_PSImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern262 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 36
      || GET_MODE (x3) != E_CCmode
      || !register_operand (operands[0], i1))
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != i1
      || !register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern269 (machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!pseudo_register_operand (operands[1], i1))
    return -1;
  switch (GET_MODE (operands[2]))
    {
    case E_QImode:
      if (!pseudo_register_operand (operands[2], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!pseudo_register_operand (operands[2], E_HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern275 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  switch (REGNO (x4))
    {
    case 22:
      if (GET_MODE (x4) != E_QImode)
        return -1;
      x5 = XEXP (x2, 0);
      if (REGNO (x5) != 24
          || GET_MODE (x5) != E_QImode)
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != SET)
        return -1;
      x7 = XEXP (x6, 1);
      if (GET_CODE (x7) != UMOD
          || GET_MODE (x7) != E_QImode)
        return -1;
      x8 = XEXP (x7, 0);
      if (GET_CODE (x8) != REG
          || REGNO (x8) != 24
          || GET_MODE (x8) != E_QImode)
        return -1;
      x9 = XEXP (x7, 1);
      if (GET_CODE (x9) != REG
          || REGNO (x9) != 22
          || GET_MODE (x9) != E_QImode)
        return -1;
      x10 = XEXP (x6, 0);
      if (GET_CODE (x10) != REG
          || REGNO (x10) != 25
          || GET_MODE (x10) != E_QImode)
        return -1;
      x11 = XVECEXP (x1, 0, 2);
      x12 = XEXP (x11, 0);
      if (REGNO (x12) != 23
          || GET_MODE (x12) != E_QImode
          || GET_MODE (x3) != E_QImode)
        return -1;
      x13 = XEXP (x3, 0);
      if (GET_MODE (x13) != E_QImode)
        return -1;
      return 0;

    case 18:
      x5 = XEXP (x2, 0);
      if (REGNO (x5) != 22)
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x6) != CLOBBER)
        return -1;
      x10 = XEXP (x6, 0);
      if (GET_CODE (x10) != REG)
        return -1;
      res = pattern274 (x1);
      if (res >= 0)
        return res + 1; /* [1, 2] */
      return -1;

    default:
      return -1;
    }
}

int
pattern292 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XVECEXP (x3, 0, 0);
  switch (REGNO (x4))
    {
    case 22:
      x5 = XEXP (x2, 0);
      if (REGNO (x5) != 24)
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      x7 = XEXP (x6, 0);
      if (REGNO (x7) != 22)
        return -1;
      switch (GET_MODE (x5))
        {
        case E_QQmode:
          if (GET_MODE (x3) != E_QQmode
              || GET_MODE (x4) != E_QQmode
              || GET_MODE (x7) != E_QQmode)
            return -1;
          return 0;

        case E_UQQmode:
          if (GET_MODE (x3) != E_UQQmode
              || GET_MODE (x4) != E_UQQmode
              || GET_MODE (x7) != E_UQQmode)
            return -1;
          return 1;

        case E_HQmode:
          if (GET_MODE (x3) != E_HQmode
              || GET_MODE (x4) != E_HQmode
              || GET_MODE (x7) != E_HQmode)
            return -1;
          return 2;

        case E_UHQmode:
          if (GET_MODE (x3) != E_UHQmode
              || GET_MODE (x4) != E_UHQmode
              || GET_MODE (x7) != E_UHQmode)
            return -1;
          return 3;

        case E_HAmode:
          if (GET_MODE (x3) != E_HAmode
              || GET_MODE (x4) != E_HAmode
              || GET_MODE (x7) != E_HAmode)
            return -1;
          return 4;

        case E_UHAmode:
          if (GET_MODE (x3) != E_UHAmode
              || GET_MODE (x4) != E_UHAmode
              || GET_MODE (x7) != E_UHAmode)
            return -1;
          return 5;

        default:
          return -1;
        }

    case 18:
      x5 = XEXP (x2, 0);
      if (REGNO (x5) != 22)
        return -1;
      x6 = XVECEXP (x1, 0, 1);
      x7 = XEXP (x6, 0);
      if (REGNO (x7) != 18)
        return -1;
      switch (GET_MODE (x5))
        {
        case E_SQmode:
          if (GET_MODE (x3) != E_SQmode
              || GET_MODE (x4) != E_SQmode
              || GET_MODE (x7) != E_SQmode)
            return -1;
          return 6;

        case E_USQmode:
          if (GET_MODE (x3) != E_USQmode
              || GET_MODE (x4) != E_USQmode
              || GET_MODE (x7) != E_USQmode)
            return -1;
          return 7;

        case E_SAmode:
          if (GET_MODE (x3) != E_SAmode
              || GET_MODE (x4) != E_SAmode
              || GET_MODE (x7) != E_SAmode)
            return -1;
          return 8;

        case E_USAmode:
          if (GET_MODE (x3) != E_USAmode
              || GET_MODE (x4) != E_USAmode
              || GET_MODE (x7) != E_USAmode)
            return -1;
          return 9;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern324 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != 22)
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 26
      || GET_MODE (x5) != E_HImode)
    return -1;
  x6 = XVECEXP (x1, 0, 2);
  x7 = XEXP (x6, 0);
  if (REGNO (x7) != 30
      || GET_MODE (x7) != E_HImode)
    return -1;
  x8 = XVECEXP (x1, 0, 3);
  x9 = XEXP (x8, 0);
  if (REGNO (x9) != 36
      || GET_MODE (x9) != E_CCmode)
    return -1;
  return pattern272 (x2); /* [-1, 1] */
}

int
pattern332 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  operands[3] = x5;
  if (!register_operand (operands[3], E_QImode))
    return -1;
  x6 = XEXP (x4, 1);
  operands[4] = x6;
  if (!const_1_to_3_operand (operands[4], E_QImode))
    return -1;
  x7 = XVECEXP (x1, 0, 1);
  x8 = XEXP (x7, 0);
  operands[0] = x8;
  if (!register_operand (operands[0], E_QImode))
    return -1;
  x9 = XEXP (x7, 1);
  x10 = XEXP (x9, 0);
  operands[1] = x10;
  if (!register_operand (operands[1], E_QImode))
    return -1;
  x11 = XEXP (x9, 1);
  operands[2] = x11;
  if (!const_1_to_3_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern337 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_MODE (x4) != E_QQmode)
    return -1;
  x5 = XEXP (x2, 0);
  if (REGNO (x5) != 23
      || GET_MODE (x5) != E_QQmode)
    return -1;
  x6 = XVECEXP (x1, 0, 2);
  x7 = XEXP (x6, 0);
  if (REGNO (x7) != 24
      || GET_MODE (x7) != E_HImode
      || GET_MODE (x3) != E_QQmode)
    return -1;
  x8 = XEXP (x3, 0);
  if (GET_MODE (x8) != E_QQmode)
    return -1;
  x9 = XVECEXP (x1, 0, 1);
  x10 = XEXP (x9, 0);
  if (GET_MODE (x10) != E_QImode)
    return -1;
  return 0;
}

int
pattern342 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x3, 1);
  operands[2] = x5;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  operands[3] = x7;
  return pattern341 (x1); /* [-1, 2] */
}

int
pattern349 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (!ordered_comparison_operator (x2, E_VOIDmode))
    return -1;
  operands[0] = x2;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 36
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XEXP (x2, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
    return -1;
  x5 = XEXP (x1, 1);
  x6 = XEXP (x5, 0);
  operands[4] = x6;
  return 0;
}

int
pattern355 (rtx x1, machine_mode i1, machine_mode i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 2);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i2)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  if (GET_MODE (x5) != i1)
    return -1;
  x6 = XEXP (x4, 1);
  if (GET_MODE (x6) != i1)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x6, 1);
  if (GET_MODE (x8) != i1)
    return -1;
  x9 = XVECEXP (x1, 0, 1);
  x10 = XEXP (x9, 0);
  if (GET_MODE (x10) != i1)
    return -1;
  return 0;
}

int
pattern362 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 1);
  if (GET_MODE (x5) != E_HImode)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 36
      || GET_MODE (x7) != E_CCmode)
    return -1;
  x8 = XEXP (x5, 0);
  operands[2] = x8;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern368 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (REGNO (x4) != 18)
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 1);
  x7 = XEXP (x6, 0);
  if (REGNO (x7) != 22)
    return -1;
  x8 = XEXP (x6, 1);
  if (REGNO (x8) != 18)
    return -1;
  x9 = XEXP (x2, 0);
  switch (REGNO (x9))
    {
    case 22:
      if (GET_MODE (x9) != E_PSImode)
        return -1;
      x10 = XEXP (x5, 0);
      if (REGNO (x10) != 18
          || GET_MODE (x10) != E_PSImode)
        return -1;
      x11 = XVECEXP (x1, 0, 2);
      x12 = XEXP (x11, 0);
      if (REGNO (x12) != 21
          || GET_MODE (x12) != E_QImode)
        return -1;
      x13 = XVECEXP (x1, 0, 3);
      x14 = XEXP (x13, 0);
      if (REGNO (x14) != 25
          || GET_MODE (x14) != E_QImode
          || pattern367 (x1, 
E_PSImode, 
E_QImode, 
26) != 0)
        return -1;
      return 0;

    case 18:
      if (GET_MODE (x9) != E_SImode)
        return -1;
      x10 = XEXP (x5, 0);
      if (REGNO (x10) != 22
          || GET_MODE (x10) != E_SImode)
        return -1;
      x11 = XVECEXP (x1, 0, 2);
      x12 = XEXP (x11, 0);
      if (REGNO (x12) != 26
          || GET_MODE (x12) != E_HImode)
        return -1;
      x13 = XVECEXP (x1, 0, 3);
      x14 = XEXP (x13, 0);
      if (REGNO (x14) != 30
          || GET_MODE (x14) != E_HImode
          || pattern367 (x1, 
E_SImode, 
E_CCmode, 
36) != 0)
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern386 (rtx x1, machine_mode i1, unsigned int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (GET_CODE (x1) != CLOBBER)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != REG
      || REGNO (x2) != i2
      || GET_MODE (x2) != i1)
    return -1;
  return 0;
}

int
pattern390 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode
          || GET_MODE (x2) != E_HImode
          || !register_operand (operands[1], E_QImode))
        return -1;
      x4 = PATTERN (peep2_next_insn (2));
      x5 = XEXP (x4, 1);
      x6 = XEXP (x5, 0);
      return pattern388 (x6, 
E_HImode); /* [-1, 5] */

    case E_PSImode:
      if (!register_operand (operands[0], E_PSImode)
          || GET_MODE (x1) != E_PSImode
          || GET_MODE (x2) != E_PSImode
          || !const0_operand (operands[3], E_PSImode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          x4 = PATTERN (peep2_next_insn (2));
          x5 = XEXP (x4, 1);
          x6 = XEXP (x5, 0);
          res = pattern389 (x6, 
E_QImode);
          if (res >= 0)
            return res + 6; /* [6, 11] */
          return -1;

        case E_HImode:
          x4 = PATTERN (peep2_next_insn (2));
          x5 = XEXP (x4, 1);
          x6 = XEXP (x5, 0);
          res = pattern389 (x6, 
E_HImode);
          if (res >= 0)
            return res + 12; /* [12, 17] */
          return -1;

        default:
          return -1;
        }

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || GET_MODE (x2) != E_SImode
          || !const0_operand (operands[3], E_SImode))
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          x4 = PATTERN (peep2_next_insn (2));
          x5 = XEXP (x4, 1);
          x6 = XEXP (x5, 0);
          res = pattern389 (x6, 
E_QImode);
          if (res >= 0)
            return res + 18; /* [18, 23] */
          return -1;

        case E_HImode:
          x4 = PATTERN (peep2_next_insn (2));
          x5 = XEXP (x4, 1);
          x6 = XEXP (x5, 0);
          res = pattern389 (x6, 
E_HImode);
          if (res >= 0)
            return res + 24; /* [24, 29] */
          return -1;

        case E_PSImode:
          x4 = PATTERN (peep2_next_insn (2));
          x5 = XEXP (x4, 1);
          x6 = XEXP (x5, 0);
          res = pattern389 (x6, 
E_PSImode);
          if (res >= 0)
            return res + 30; /* [30, 35] */
          return -1;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_9 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 1);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (pattern192 (x3, 
E_QImode) != 0)
        return -1;
      if (
#line 2205 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
        return 300; /* *mulqi3_enh_split */
      if (pnum_clobbers == NULL
          || !
#line 2218 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 301; /* *mulqi3_enh */

    case E_HImode:
      if (pattern192 (x3, 
E_HImode) != 0)
        return -1;
      if (
#line 3273 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
        return 537; /* *mulhi3_enh_split */
      if (pnum_clobbers == NULL
          || !
#line 3286 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 538; /* *mulhi3_enh */

    case E_SImode:
      if (pattern193 (x3, pnum_clobbers, 
E_SImode) != 0)
        return -1;
      if (pseudo_register_or_const_int_operand (operands[2], E_SImode)
          && 
#line 3403 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
        {
          *pnum_clobbers = 2;
          return 541; /* *mulsi3 */
        }
      if (!pseudo_register_operand (operands[2], E_SImode)
          || !
#line 3439 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! AVR_HAVE_MUL
   && ! AVR_TINY
   && ! reload_completed))
        return -1;
      *pnum_clobbers = 3;
      return 542; /* *mulsi3_pr118012 */

    case E_PSImode:
      if (pattern193 (x3, pnum_clobbers, 
E_PSImode) != 0
          || !pseudo_register_or_const_int_operand (operands[2], E_PSImode)
          || !
#line 4197 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && !reload_completed))
        return -1;
      *pnum_clobbers = 2;
      return 601; /* *mulpsi3 */

    case E_QQmode:
      if (pattern192 (x3, 
E_QQmode) != 0)
        return -1;
      if (
#line 296 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL))
        return 3076; /* mulqq3_enh */
      if (pnum_clobbers == NULL
          || !
#line 309 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3077; /* *mulqq3_enh */

    case E_UQQmode:
      if (pattern192 (x3, 
E_UQQmode) != 0)
        return -1;
      if (
#line 317 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL))
        return 3078; /* muluqq3_enh */
      if (pnum_clobbers == NULL
          || !
#line 330 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(AVR_HAVE_MUL && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 3079; /* *muluqq3_enh */

    default:
      return -1;
    }
}

 int
recog_10 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG)
    return -1;
  x5 = XEXP (x2, 1);
  if (GET_CODE (x5) != ZERO_EXTEND)
    return -1;
  x6 = XEXP (x5, 0);
  if (GET_CODE (x6) != REG)
    return -1;
  x7 = XEXP (x1, 0);
  if (GET_CODE (x7) != REG)
    return -1;
  switch (REGNO (x4))
    {
    case 22:
      if (GET_MODE (x4) != E_QImode
          || REGNO (x6) != 24
          || pattern295 (x1, 
E_HImode, 
24, 
E_QImode) != 0)
        return -1;
      if (
#line 2437 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(!AVR_HAVE_MUL))
        {
          *pnum_clobbers = 2;
          return 476; /* *umulqihi3.call_split */
        }
      if (!
#line 2454 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(!AVR_HAVE_MUL && reload_completed))
        return -1;
      *pnum_clobbers = 3;
      return 477; /* *umulqihi3.call */

    case 18:
      if (GET_MODE (x4) != E_SImode
          || REGNO (x6) != 22
          || pattern295 (x1, 
E_DImode, 
18, 
E_SImode) != 0)
        return -1;
      if (
#line 675 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && AVR_HAVE_MUL))
        {
          *pnum_clobbers = 2;
          return 3361; /* umulsidi3_insn */
        }
      if (!
#line 693 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && AVR_HAVE_MUL
   && reload_completed))
        return -1;
      *pnum_clobbers = 3;
      return 3363; /* *umulsidi3_insn */

    default:
      return -1;
    }
}

 int
recog_13 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_HImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_HImode)
    return -1;
  x4 = XEXP (x2, 1);
  switch (pattern255 (x4, pnum_clobbers))
    {
    case 0:
      if (s8_operand (operands[2], E_HImode)
          && 
#line 2994 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
        {
          *pnum_clobbers = 1;
          return 521; /* *mulsqihi3.sconst */
        }
      if (u8_operand (operands[2], E_HImode)
          && 
#line 3030 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
        {
          *pnum_clobbers = 1;
          return 524; /* *mulsqihi3.uconst */
        }
      if (!o8_operand (operands[2], E_HImode)
          || !
#line 3048 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
        return -1;
      *pnum_clobbers = 1;
      return 525; /* *mulsqihi3.oconst */

    case 1:
      if (
#line 3149 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
        return 531; /* mulsqihi3 */
      if (pnum_clobbers == NULL
          || !
#line 3162 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 532; /* *mulsqihi3 */

    default:
      return -1;
    }
}

 int
recog_16 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 1);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (pattern52 (x3, 
E_QImode) != 0)
        return -1;
      return 661; /* *ashlqi3_split */

    case E_QQmode:
      if (pattern52 (x3, 
E_QQmode) != 0)
        return -1;
      return 662; /* *ashlqq3_split */

    case E_UQQmode:
      if (pattern52 (x3, 
E_UQQmode) != 0)
        return -1;
      return 663; /* *ashluqq3_split */

    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x3) != E_HImode
          || !register_operand (operands[1], E_HImode))
        return -1;
      if (nop_general_operand (operands[2], E_QImode))
        return 667; /* ashlhi3 */
      if (pnum_clobbers == NULL
          || !const_int_operand (operands[2], E_QImode)
          || !
#line 5572 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 2;
      return 692; /* *ashlhi3_const */

    case E_HQmode:
      if (!register_operand (operands[0], E_HQmode)
          || GET_MODE (x3) != E_HQmode
          || !register_operand (operands[1], E_HQmode))
        return -1;
      if (nop_general_operand (operands[2], E_QImode))
        return 668; /* ashlhq3 */
      if (pnum_clobbers == NULL
          || !const_int_operand (operands[2], E_QImode)
          || !
#line 5572 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 2;
      return 693; /* *ashlhq3_const */

    case E_UHQmode:
      if (!register_operand (operands[0], E_UHQmode)
          || GET_MODE (x3) != E_UHQmode
          || !register_operand (operands[1], E_UHQmode))
        return -1;
      if (nop_general_operand (operands[2], E_QImode))
        return 669; /* ashluhq3 */
      if (pnum_clobbers == NULL
          || !const_int_operand (operands[2], E_QImode)
          || !
#line 5572 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 2;
      return 694; /* *ashluhq3_const */

    case E_HAmode:
      if (!register_operand (operands[0], E_HAmode)
          || GET_MODE (x3) != E_HAmode
          || !register_operand (operands[1], E_HAmode))
        return -1;
      if (nop_general_operand (operands[2], E_QImode))
        return 670; /* ashlha3 */
      if (pnum_clobbers == NULL
          || !const_int_operand (operands[2], E_QImode)
          || !
#line 5572 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 2;
      return 695; /* *ashlha3_const */

    case E_UHAmode:
      if (!register_operand (operands[0], E_UHAmode)
          || GET_MODE (x3) != E_UHAmode
          || !register_operand (operands[1], E_UHAmode))
        return -1;
      if (nop_general_operand (operands[2], E_QImode))
        return 671; /* ashluha3 */
      if (pnum_clobbers == NULL
          || !const_int_operand (operands[2], E_QImode)
          || !
#line 5572 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 2;
      return 696; /* *ashluha3_const */

    case E_SImode:
      if (pattern52 (x3, 
E_SImode) != 0)
        return -1;
      return 682; /* ashlsi3 */

    case E_SQmode:
      if (pattern52 (x3, 
E_SQmode) != 0)
        return -1;
      return 683; /* ashlsq3 */

    case E_USQmode:
      if (pattern52 (x3, 
E_USQmode) != 0)
        return -1;
      return 684; /* ashlusq3 */

    case E_SAmode:
      if (pattern52 (x3, 
E_SAmode) != 0)
        return -1;
      return 685; /* ashlsa3 */

    case E_USAmode:
      if (pattern52 (x3, 
E_USAmode) != 0)
        return -1;
      return 686; /* ashlusa3 */

    case E_PSImode:
      if (pattern53 (x3, pnum_clobbers, 
E_QImode) != 0)
        return -1;
      *pnum_clobbers = 1;
      return 702; /* *ashlpsi3_split */

    default:
      return -1;
    }
}

 int
recog_20 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  switch (pattern90 (x1))
    {
    case 0:
      x2 = XEXP (x1, 1);
      x3 = XEXP (x2, 0);
      x4 = XEXP (x3, 0);
      operands[1] = x4;
      operands[0] = x3;
      switch (pattern258 (x2))
        {
        case 0:
          switch (GET_MODE (operands[1]))
            {
            case E_QImode:
              if (register_operand (operands[1], E_QImode)
                  && nonmemory_operand (operands[2], E_QImode))
                return 878; /* cbranchqi4_insn */
              break;

            case E_QQmode:
              if (register_operand (operands[1], E_QQmode)
                  && nonmemory_operand (operands[2], E_QQmode))
                return 879; /* cbranchqq4_insn */
              break;

            case E_UQQmode:
              if (register_operand (operands[1], E_UQQmode)
                  && nonmemory_operand (operands[2], E_UQQmode))
                return 880; /* cbranchuqq4_insn */
              break;

            case E_SImode:
              if (pnum_clobbers != NULL
                  && register_operand (operands[1], E_SImode)
                  && nonmemory_operand (operands[2], E_SImode))
                {
                  *pnum_clobbers = 1;
                  return 881; /* cbranchsi4_insn */
                }
              break;

            case E_SQmode:
              if (pnum_clobbers != NULL
                  && register_operand (operands[1], E_SQmode)
                  && nonmemory_operand (operands[2], E_SQmode))
                {
                  *pnum_clobbers = 1;
                  return 882; /* cbranchsq4_insn */
                }
              break;

            case E_USQmode:
              if (pnum_clobbers != NULL
                  && register_operand (operands[1], E_USQmode)
                  && nonmemory_operand (operands[2], E_USQmode))
                {
                  *pnum_clobbers = 1;
                  return 883; /* cbranchusq4_insn */
                }
              break;

            case E_SAmode:
              if (pnum_clobbers != NULL
                  && register_operand (operands[1], E_SAmode)
                  && nonmemory_operand (operands[2], E_SAmode))
                {
                  *pnum_clobbers = 1;
                  return 884; /* cbranchsa4_insn */
                }
              break;

            case E_USAmode:
              if (pnum_clobbers != NULL
                  && register_operand (operands[1], E_USAmode)
                  && nonmemory_operand (operands[2], E_USAmode))
                {
                  *pnum_clobbers = 1;
                  return 885; /* cbranchusa4_insn */
                }
              break;

            case E_PSImode:
              if (pnum_clobbers != NULL
                  && register_operand (operands[1], E_PSImode)
                  && nonmemory_operand (operands[2], E_PSImode))
                {
                  *pnum_clobbers = 1;
                  return 886; /* cbranchpsi4_insn */
                }
              break;

            case E_HImode:
              if (pnum_clobbers != NULL
                  && register_operand (operands[1], E_HImode)
                  && nonmemory_operand (operands[2], E_HImode))
                {
                  *pnum_clobbers = 1;
                  return 887; /* cbranchhi4_insn */
                }
              break;

            case E_HQmode:
              if (pnum_clobbers != NULL
                  && register_operand (operands[1], E_HQmode)
                  && nonmemory_operand (operands[2], E_HQmode))
                {
                  *pnum_clobbers = 1;
                  return 888; /* cbranchhq4_insn */
                }
              break;

            case E_UHQmode:
              if (pnum_clobbers != NULL
                  && register_operand (operands[1], E_UHQmode)
                  && nonmemory_operand (operands[2], E_UHQmode))
                {
                  *pnum_clobbers = 1;
                  return 889; /* cbranchuhq4_insn */
                }
              break;

            case E_HAmode:
              if (pnum_clobbers != NULL
                  && register_operand (operands[1], E_HAmode)
                  && nonmemory_operand (operands[2], E_HAmode))
                {
                  *pnum_clobbers = 1;
                  return 890; /* cbranchha4_insn */
                }
              break;

            case E_UHAmode:
              if (pnum_clobbers != NULL
                  && register_operand (operands[1], E_UHAmode)
                  && nonmemory_operand (operands[2], E_UHAmode))
                {
                  *pnum_clobbers = 1;
                  return 891; /* cbranchuha4_insn */
                }
              break;

            default:
              break;
            }
          break;

        case 1:
          if (
#line 7127 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(optimize
   && 2 > 1))
            return 904; /* *cbranchhi.sign_extendqi.0 */
          break;

        case 2:
          if (
#line 7127 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(optimize
   && 3 > 1))
            return 906; /* *cbranchpsi.sign_extendqi.0 */
          break;

        case 3:
          if (
#line 7127 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(optimize
   && 3 > 2))
            return 910; /* *cbranchpsi.sign_extendhi.0 */
          break;

        case 4:
          if (
#line 7127 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(optimize
   && 4 > 1))
            return 908; /* *cbranchsi.sign_extendqi.0 */
          break;

        case 5:
          if (
#line 7127 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(optimize
   && 4 > 2))
            return 912; /* *cbranchsi.sign_extendhi.0 */
          break;

        case 6:
          if (
#line 7127 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(optimize
   && 4 > 3))
            return 914; /* *cbranchsi.sign_extendpsi.0 */
          break;

        case 7:
          if (
#line 7127 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(optimize
   && 2 > 1))
            return 905; /* *cbranchhi.zero_extendqi.0 */
          break;

        case 8:
          if (
#line 7127 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(optimize
   && 3 > 1))
            return 907; /* *cbranchpsi.zero_extendqi.0 */
          break;

        case 9:
          if (
#line 7127 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(optimize
   && 3 > 2))
            return 911; /* *cbranchpsi.zero_extendhi.0 */
          break;

        case 10:
          if (
#line 7127 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(optimize
   && 4 > 1))
            return 909; /* *cbranchsi.zero_extendqi.0 */
          break;

        case 11:
          if (
#line 7127 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(optimize
   && 4 > 2))
            return 913; /* *cbranchsi.zero_extendhi.0 */
          break;

        case 12:
          if (
#line 7127 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(optimize
   && 4 > 3))
            return 915; /* *cbranchsi.zero_extendpsi.0 */
          break;

        default:
          break;
        }
      if (GET_CODE (x4) != REG)
        return -1;
      switch (REGNO (x4))
        {
        case 36:
          x5 = XEXP (x3, 1);
          if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
            return -1;
          operands[1] = x3;
          x6 = XEXP (x2, 1);
          x7 = XEXP (x6, 0);
          operands[0] = x7;
          switch (GET_MODE (x4))
            {
            case E_CCmode:
              if (!
#line 7785 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
                return -1;
              return 966; /* branch */

            case E_CCNmode:
              if (!
#line 7785 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
                return -1;
              return 967; /* branch_N */

            case E_CCZNmode:
              if (!
#line 7785 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
                return -1;
              return 968; /* branch_ZN */

            default:
              return -1;
            }

        case 18:
          operands[0] = x3;
          x5 = XEXP (x3, 1);
          switch (GET_CODE (x5))
            {
            case REG:
              if (REGNO (x5) != 10)
                return -1;
              x6 = XEXP (x2, 1);
              x7 = XEXP (x6, 0);
              operands[1] = x7;
              switch (pattern329 (x3))
                {
                case 0:
                  if (!
#line 500 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
                    return -1;
                  return 3274; /* cbranch_di2_split */

                case 1:
                  if (!
#line 500 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
                    return -1;
                  return 3275; /* cbranch_dq2_split */

                case 2:
                  if (!
#line 500 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
                    return -1;
                  return 3276; /* cbranch_udq2_split */

                case 3:
                  if (!
#line 500 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
                    return -1;
                  return 3277; /* cbranch_da2_split */

                case 4:
                  if (!
#line 500 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
                    return -1;
                  return 3278; /* cbranch_uda2_split */

                case 5:
                  if (!
#line 500 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
                    return -1;
                  return 3279; /* cbranch_ta2_split */

                case 6:
                  if (!
#line 500 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
                    return -1;
                  return 3280; /* cbranch_uta2_split */

                default:
                  return -1;
                }

            case SIGN_EXTEND:
              if (pattern296 (x3) != 0)
                return -1;
              x6 = XEXP (x2, 1);
              x7 = XEXP (x6, 0);
              operands[1] = x7;
              if (!
#line 529 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode))
                return -1;
              return 3288; /* cbranch_const8_di2_split */

            case CONST_INT:
            case CONST_FIXED:
            case CONST_DOUBLE:
              if (pnum_clobbers == NULL)
                return -1;
              operands[1] = x5;
              x6 = XEXP (x2, 1);
              x7 = XEXP (x6, 0);
              operands[2] = x7;
              switch (GET_MODE (x4))
                {
                case E_DImode:
                  if (!const_operand (operands[1], E_DImode)
                      || !
#line 555 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[1], VOIDmode)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3290; /* cbranch_const_di2_split */

                case E_DQmode:
                  if (!const_operand (operands[1], E_DQmode)
                      || !
#line 555 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[1], VOIDmode)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3291; /* cbranch_const_dq2_split */

                case E_UDQmode:
                  if (!const_operand (operands[1], E_UDQmode)
                      || !
#line 555 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[1], VOIDmode)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3292; /* cbranch_const_udq2_split */

                case E_DAmode:
                  if (!const_operand (operands[1], E_DAmode)
                      || !
#line 555 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[1], VOIDmode)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3293; /* cbranch_const_da2_split */

                case E_UDAmode:
                  if (!const_operand (operands[1], E_UDAmode)
                      || !
#line 555 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[1], VOIDmode)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3294; /* cbranch_const_uda2_split */

                case E_TAmode:
                  if (!const_operand (operands[1], E_TAmode)
                      || !
#line 555 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[1], VOIDmode)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3295; /* cbranch_const_ta2_split */

                case E_UTAmode:
                  if (!const_operand (operands[1], E_UTAmode)
                      || !
#line 555 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode
   && !s8_operand (operands[1], VOIDmode)))
                    return -1;
                  *pnum_clobbers = 1;
                  return 3296; /* cbranch_const_uta2_split */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 1:
      x2 = XEXP (x1, 1);
      x3 = XEXP (x2, 0);
      operands[0] = x3;
      switch (pattern230 (x2))
        {
        case 0:
          if (!
#line 7096 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(optimize
   && 2 > 1))
            return -1;
          return 892; /* *cbranchhi.sign_extendqi.0 */

        case 1:
          if (!
#line 7096 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(optimize
   && 3 > 1))
            return -1;
          return 894; /* *cbranchpsi.sign_extendqi.0 */

        case 2:
          if (!
#line 7096 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(optimize
   && 3 > 2))
            return -1;
          return 898; /* *cbranchpsi.sign_extendhi.0 */

        case 3:
          if (!
#line 7096 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(optimize
   && 4 > 1))
            return -1;
          return 896; /* *cbranchsi.sign_extendqi.0 */

        case 4:
          if (!
#line 7096 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(optimize
   && 4 > 2))
            return -1;
          return 900; /* *cbranchsi.sign_extendhi.0 */

        case 5:
          if (!
#line 7096 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(optimize
   && 4 > 3))
            return -1;
          return 902; /* *cbranchsi.sign_extendpsi.0 */

        default:
          return -1;
        }

    case 2:
      x2 = XEXP (x1, 1);
      x3 = XEXP (x2, 0);
      operands[0] = x3;
      switch (pattern230 (x2))
        {
        case 0:
          if (!
#line 7096 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(optimize
   && 2 > 1))
            return -1;
          return 893; /* *cbranchhi.zero_extendqi.0 */

        case 1:
          if (!
#line 7096 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(optimize
   && 3 > 1))
            return -1;
          return 895; /* *cbranchpsi.zero_extendqi.0 */

        case 2:
          if (!
#line 7096 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(optimize
   && 3 > 2))
            return -1;
          return 899; /* *cbranchpsi.zero_extendhi.0 */

        case 3:
          if (!
#line 7096 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(optimize
   && 4 > 1))
            return -1;
          return 897; /* *cbranchsi.zero_extendqi.0 */

        case 4:
          if (!
#line 7096 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(optimize
   && 4 > 2))
            return -1;
          return 901; /* *cbranchsi.zero_extendhi.0 */

        case 5:
          if (!
#line 7096 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(optimize
   && 4 > 3))
            return -1;
          return 903; /* *cbranchsi.zero_extendpsi.0 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_32 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  switch (pattern17 (x1))
    {
    case 0:
      x2 = XEXP (x1, 1);
      x3 = XEXP (x2, 0);
      operands[1] = x3;
      switch (pattern88 (x1))
        {
        case 0:
          return 785; /* negqi2 */

        case 1:
          return 789; /* neghi2 */

        case 2:
          return 791; /* negpsi2 */

        case 3:
          return 793; /* negsi2 */

        case 4:
          return 796; /* negsf2 */

        default:
          break;
        }
      switch (GET_CODE (x3))
        {
        case REG:
          res = recog_19 (x1, insn, pnum_clobbers);
          if (res >= 0)
            return res;
          break;

        case SUBREG:
          switch (pattern89 (x1))
            {
            case 0:
              if (
#line 10547 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(! reload_completed))
                return 1177; /* *neg.ashiftrtqi.msb */
              break;

            case 1:
              if (
#line 10547 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(! reload_completed))
                return 1178; /* *neg.ashiftrthi.msb */
              break;

            case 2:
              if (
#line 10547 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(! reload_completed))
                return 1179; /* *neg.ashiftrtpsi.msb */
              break;

            case 3:
              if (
#line 10547 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(! reload_completed))
                return 1180; /* *neg.ashiftrtsi.msb */
              break;

            default:
              break;
            }
          break;

        default:
          break;
        }
      if (pnum_clobbers == NULL)
        return -1;
      operands[1] = x3;
      if (!register_operand (operands[1], E_SImode))
        return -1;
      x4 = XEXP (x1, 0);
      operands[0] = x4;
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x2) != E_SImode
          || !
#line 6320 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      *pnum_clobbers = 1;
      return 795; /* *negsi2 */

    case 1:
      return 787; /* *negqihi2_split */

    case 2:
      if (!
#line 10675 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed))
        return -1;
      return 1248; /* *neg.zextr-to-sextr.hi.qi */

    case 3:
      if (!
#line 10675 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed))
        return -1;
      return 1249; /* *neg.zextr-to-sextr.hi.hi */

    case 4:
      if (!
#line 10675 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed))
        return -1;
      return 1250; /* *neg.zextr-to-sextr.hi.psi */

    case 5:
      if (!
#line 10675 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 2 > 1
   && ! reload_completed))
        return -1;
      return 1251; /* *neg.zextr-to-sextr.hi.si */

    case 6:
      if (!
#line 10675 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed))
        return -1;
      return 1252; /* *neg.zextr-to-sextr.psi.qi */

    case 7:
      if (!
#line 10675 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed))
        return -1;
      return 1253; /* *neg.zextr-to-sextr.psi.hi */

    case 8:
      if (!
#line 10675 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed))
        return -1;
      return 1254; /* *neg.zextr-to-sextr.psi.psi */

    case 9:
      if (!
#line 10675 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 1
   && ! reload_completed))
        return -1;
      return 1255; /* *neg.zextr-to-sextr.psi.si */

    case 10:
      if (!
#line 10675 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed))
        return -1;
      return 1260; /* *neg.zextr-to-sextr.psi.qi */

    case 11:
      if (!
#line 10675 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed))
        return -1;
      return 1261; /* *neg.zextr-to-sextr.psi.hi */

    case 12:
      if (!
#line 10675 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed))
        return -1;
      return 1262; /* *neg.zextr-to-sextr.psi.psi */

    case 13:
      if (!
#line 10675 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 3 > 2
   && ! reload_completed))
        return -1;
      return 1263; /* *neg.zextr-to-sextr.psi.si */

    case 14:
      if (!
#line 10675 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed))
        return -1;
      return 1256; /* *neg.zextr-to-sextr.si.qi */

    case 15:
      if (!
#line 10675 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed))
        return -1;
      return 1257; /* *neg.zextr-to-sextr.si.hi */

    case 16:
      if (!
#line 10675 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed))
        return -1;
      return 1258; /* *neg.zextr-to-sextr.si.psi */

    case 17:
      if (!
#line 10675 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 1
   && ! reload_completed))
        return -1;
      return 1259; /* *neg.zextr-to-sextr.si.si */

    case 18:
      if (!
#line 10675 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed))
        return -1;
      return 1264; /* *neg.zextr-to-sextr.si.qi */

    case 19:
      if (!
#line 10675 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed))
        return -1;
      return 1265; /* *neg.zextr-to-sextr.si.hi */

    case 20:
      if (!
#line 10675 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed))
        return -1;
      return 1266; /* *neg.zextr-to-sextr.si.psi */

    case 21:
      if (!
#line 10675 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 2
   && ! reload_completed))
        return -1;
      return 1267; /* *neg.zextr-to-sextr.si.si */

    case 22:
      if (!
#line 10675 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed))
        return -1;
      return 1268; /* *neg.zextr-to-sextr.si.qi */

    case 23:
      if (!
#line 10675 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed))
        return -1;
      return 1269; /* *neg.zextr-to-sextr.si.hi */

    case 24:
      if (!
#line 10675 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed))
        return -1;
      return 1270; /* *neg.zextr-to-sextr.si.psi */

    case 25:
      if (!
#line 10675 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && 4 > 3
   && ! reload_completed))
        return -1;
      return 1271; /* *neg.zextr-to-sextr.si.si */

    default:
      return -1;
    }
}

 int
recog_45 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  switch (GET_CODE (x4))
    {
    case ZERO_EXTEND:
      x5 = XVECEXP (x1, 0, 1);
      x6 = XEXP (x5, 0);
      if (GET_CODE (x6) != REG
          || REGNO (x6) != 36
          || GET_MODE (x6) != E_CCmode)
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (pattern301 (x3) != 0
              || GET_MODE (x4) != E_HImode)
            return -1;
          x7 = XEXP (x4, 0);
          operands[2] = x7;
          if (!register_operand (operands[2], E_QImode)
              || !
#line 2478 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
            return -1;
          return 481; /* umulqihi3 */

        case E_PSImode:
          if (!register_operand (operands[0], E_PSImode)
              || GET_MODE (x3) != E_PSImode)
            return -1;
          x8 = XEXP (x3, 0);
          if (GET_MODE (x8) != E_PSImode
              || GET_MODE (x4) != E_PSImode)
            return -1;
          x9 = XEXP (x8, 0);
          switch (GET_MODE (x9))
            {
            case E_QImode:
              operands[1] = x9;
              if (!register_operand (operands[1], E_QImode))
                return -1;
              x7 = XEXP (x4, 0);
              operands[2] = x7;
              if (!register_operand (operands[2], E_HImode)
                  || !
#line 4121 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              return 597; /* *umulqihipsi3 */

            case E_HImode:
              operands[2] = x9;
              if (!register_operand (operands[2], E_HImode))
                return -1;
              x7 = XEXP (x4, 0);
              operands[1] = x7;
              if (!register_operand (operands[1], E_QImode)
                  || !
#line 4148 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              return 599; /* *umulhiqipsi3 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case SIGN_EXTEND:
      if (GET_MODE (x4) != E_HImode)
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      x6 = XEXP (x5, 0);
      if (GET_CODE (x6) != REG
          || REGNO (x6) != 36
          || GET_MODE (x6) != E_CCmode
          || !register_operand (operands[0], E_HImode)
          || GET_MODE (x3) != E_HImode)
        return -1;
      x8 = XEXP (x3, 0);
      if (GET_MODE (x8) != E_HImode)
        return -1;
      x9 = XEXP (x8, 0);
      operands[1] = x9;
      if (!register_operand (operands[1], E_QImode))
        return -1;
      x7 = XEXP (x4, 0);
      operands[2] = x7;
      if (!register_operand (operands[2], E_QImode)
          || !
#line 2501 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
        return -1;
      return 483; /* *usmulqihi3 */

    case CONST_INT:
      operands[2] = x4;
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x3) != E_HImode)
        return -1;
      x8 = XEXP (x3, 0);
      if (GET_MODE (x8) != E_HImode)
        return -1;
      x9 = XEXP (x8, 0);
      operands[1] = x9;
      if (!register_operand (operands[1], E_QImode))
        return -1;
      x5 = XVECEXP (x1, 0, 1);
      x6 = XEXP (x5, 0);
      operands[3] = x6;
      if (!scratch_operand (operands[3], E_QImode))
        return -1;
      if (u8_operand (operands[2], E_HImode)
          && 
#line 2994 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
        return 522; /* *muluqihi3.uconst */
      if (!s8_operand (operands[2], E_HImode)
          || !
#line 3012 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
        return -1;
      return 523; /* *muluqihi3.sconst */

    case REG:
    case SUBREG:
      if (pattern223 (x1) != 0
          || pattern301 (x3) != 0
          || !
#line 3187 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
        return -1;
      return 534; /* *muluqihi3 */

    default:
      return -1;
    }
}

 int
recog_52 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x5 = XVECEXP (x1, 0, 0);
  x6 = XEXP (x5, 0);
  if (GET_MODE (x6) != E_CCNmode)
    return -1;
  x7 = XEXP (x5, 1);
  if (GET_MODE (x7) != E_CCNmode)
    return -1;
  x8 = XEXP (x7, 0);
  x9 = XEXP (x8, 0);
  operands[2] = x9;
  switch (GET_MODE (x8))
    {
    case E_HImode:
      if (pattern366 (x3, 
E_HImode) != 0
          || !
#line 7537 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 937; /* *ashift.for.ccn.hi */

    case E_PSImode:
      if (pattern366 (x3, 
E_PSImode) != 0
          || !
#line 7537 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 938; /* *ashift.for.ccn.psi */

    case E_SImode:
      if (pattern366 (x3, 
E_SImode) != 0
          || !
#line 7537 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 939; /* *ashift.for.ccn.si */

    default:
      return -1;
    }
}

 int
recog_55 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (pattern102 (x1))
    {
    case 0:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UQQmode != QQmode
   && reload_completed))
        return -1;
      return 1876; /* *fractuqqqq2 */

    case 1:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HQmode != QQmode
   && reload_completed))
        return -1;
      return 1877; /* *fracthqqq2 */

    case 2:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UHQmode != QQmode
   && reload_completed))
        return -1;
      return 1878; /* *fractuhqqq2 */

    case 3:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HAmode != QQmode
   && reload_completed))
        return -1;
      return 1879; /* *fracthaqq2 */

    case 4:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UHAmode != QQmode
   && reload_completed))
        return -1;
      return 1880; /* *fractuhaqq2 */

    case 5:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SQmode != QQmode
   && reload_completed))
        return -1;
      return 1881; /* *fractsqqq2 */

    case 6:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(USQmode != QQmode
   && reload_completed))
        return -1;
      return 1882; /* *fractusqqq2 */

    case 7:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SAmode != QQmode
   && reload_completed))
        return -1;
      return 1883; /* *fractsaqq2 */

    case 8:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(USAmode != QQmode
   && reload_completed))
        return -1;
      return 1884; /* *fractusaqq2 */

    case 9:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DQmode != QQmode
   && reload_completed))
        return -1;
      return 1885; /* *fractdqqq2 */

    case 10:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UDQmode != QQmode
   && reload_completed))
        return -1;
      return 1886; /* *fractudqqq2 */

    case 11:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DAmode != QQmode
   && reload_completed))
        return -1;
      return 1887; /* *fractdaqq2 */

    case 12:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UDAmode != QQmode
   && reload_completed))
        return -1;
      return 1888; /* *fractudaqq2 */

    case 13:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(TAmode != QQmode
   && reload_completed))
        return -1;
      return 1889; /* *fracttaqq2 */

    case 14:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UTAmode != QQmode
   && reload_completed))
        return -1;
      return 1890; /* *fractutaqq2 */

    case 15:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(QImode != QQmode
   && reload_completed))
        return -1;
      return 1891; /* *fractqiqq2 */

    case 16:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HImode != QQmode
   && reload_completed))
        return -1;
      return 1892; /* *fracthiqq2 */

    case 17:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SImode != QQmode
   && reload_completed))
        return -1;
      return 1893; /* *fractsiqq2 */

    case 18:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DImode != QQmode
   && reload_completed))
        return -1;
      return 1894; /* *fractdiqq2 */

    case 19:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(QQmode != UQQmode
   && reload_completed))
        return -1;
      return 1895; /* *fractqquqq2 */

    case 20:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HQmode != UQQmode
   && reload_completed))
        return -1;
      return 1896; /* *fracthquqq2 */

    case 21:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UHQmode != UQQmode
   && reload_completed))
        return -1;
      return 1897; /* *fractuhquqq2 */

    case 22:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HAmode != UQQmode
   && reload_completed))
        return -1;
      return 1898; /* *fracthauqq2 */

    case 23:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UHAmode != UQQmode
   && reload_completed))
        return -1;
      return 1899; /* *fractuhauqq2 */

    case 24:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SQmode != UQQmode
   && reload_completed))
        return -1;
      return 1900; /* *fractsquqq2 */

    case 25:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(USQmode != UQQmode
   && reload_completed))
        return -1;
      return 1901; /* *fractusquqq2 */

    case 26:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SAmode != UQQmode
   && reload_completed))
        return -1;
      return 1902; /* *fractsauqq2 */

    case 27:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(USAmode != UQQmode
   && reload_completed))
        return -1;
      return 1903; /* *fractusauqq2 */

    case 28:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DQmode != UQQmode
   && reload_completed))
        return -1;
      return 1904; /* *fractdquqq2 */

    case 29:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UDQmode != UQQmode
   && reload_completed))
        return -1;
      return 1905; /* *fractudquqq2 */

    case 30:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DAmode != UQQmode
   && reload_completed))
        return -1;
      return 1906; /* *fractdauqq2 */

    case 31:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UDAmode != UQQmode
   && reload_completed))
        return -1;
      return 1907; /* *fractudauqq2 */

    case 32:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(TAmode != UQQmode
   && reload_completed))
        return -1;
      return 1908; /* *fracttauqq2 */

    case 33:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UTAmode != UQQmode
   && reload_completed))
        return -1;
      return 1909; /* *fractutauqq2 */

    case 34:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(QImode != UQQmode
   && reload_completed))
        return -1;
      return 1910; /* *fractqiuqq2 */

    case 35:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HImode != UQQmode
   && reload_completed))
        return -1;
      return 1911; /* *fracthiuqq2 */

    case 36:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SImode != UQQmode
   && reload_completed))
        return -1;
      return 1912; /* *fractsiuqq2 */

    case 37:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DImode != UQQmode
   && reload_completed))
        return -1;
      return 1913; /* *fractdiuqq2 */

    case 38:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(QQmode != HQmode
   && reload_completed))
        return -1;
      return 1914; /* *fractqqhq2 */

    case 39:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UQQmode != HQmode
   && reload_completed))
        return -1;
      return 1915; /* *fractuqqhq2 */

    case 40:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UHQmode != HQmode
   && reload_completed))
        return -1;
      return 1916; /* *fractuhqhq2 */

    case 41:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HAmode != HQmode
   && reload_completed))
        return -1;
      return 1917; /* *fracthahq2 */

    case 42:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UHAmode != HQmode
   && reload_completed))
        return -1;
      return 1918; /* *fractuhahq2 */

    case 43:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SQmode != HQmode
   && reload_completed))
        return -1;
      return 1919; /* *fractsqhq2 */

    case 44:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(USQmode != HQmode
   && reload_completed))
        return -1;
      return 1920; /* *fractusqhq2 */

    case 45:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SAmode != HQmode
   && reload_completed))
        return -1;
      return 1921; /* *fractsahq2 */

    case 46:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(USAmode != HQmode
   && reload_completed))
        return -1;
      return 1922; /* *fractusahq2 */

    case 47:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DQmode != HQmode
   && reload_completed))
        return -1;
      return 1923; /* *fractdqhq2 */

    case 48:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UDQmode != HQmode
   && reload_completed))
        return -1;
      return 1924; /* *fractudqhq2 */

    case 49:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DAmode != HQmode
   && reload_completed))
        return -1;
      return 1925; /* *fractdahq2 */

    case 50:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UDAmode != HQmode
   && reload_completed))
        return -1;
      return 1926; /* *fractudahq2 */

    case 51:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(TAmode != HQmode
   && reload_completed))
        return -1;
      return 1927; /* *fracttahq2 */

    case 52:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UTAmode != HQmode
   && reload_completed))
        return -1;
      return 1928; /* *fractutahq2 */

    case 53:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(QImode != HQmode
   && reload_completed))
        return -1;
      return 1929; /* *fractqihq2 */

    case 54:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HImode != HQmode
   && reload_completed))
        return -1;
      return 1930; /* *fracthihq2 */

    case 55:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SImode != HQmode
   && reload_completed))
        return -1;
      return 1931; /* *fractsihq2 */

    case 56:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DImode != HQmode
   && reload_completed))
        return -1;
      return 1932; /* *fractdihq2 */

    case 57:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(QQmode != UHQmode
   && reload_completed))
        return -1;
      return 1933; /* *fractqquhq2 */

    case 58:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UQQmode != UHQmode
   && reload_completed))
        return -1;
      return 1934; /* *fractuqquhq2 */

    case 59:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HQmode != UHQmode
   && reload_completed))
        return -1;
      return 1935; /* *fracthquhq2 */

    case 60:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HAmode != UHQmode
   && reload_completed))
        return -1;
      return 1936; /* *fracthauhq2 */

    case 61:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UHAmode != UHQmode
   && reload_completed))
        return -1;
      return 1937; /* *fractuhauhq2 */

    case 62:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SQmode != UHQmode
   && reload_completed))
        return -1;
      return 1938; /* *fractsquhq2 */

    case 63:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(USQmode != UHQmode
   && reload_completed))
        return -1;
      return 1939; /* *fractusquhq2 */

    case 64:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SAmode != UHQmode
   && reload_completed))
        return -1;
      return 1940; /* *fractsauhq2 */

    case 65:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(USAmode != UHQmode
   && reload_completed))
        return -1;
      return 1941; /* *fractusauhq2 */

    case 66:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DQmode != UHQmode
   && reload_completed))
        return -1;
      return 1942; /* *fractdquhq2 */

    case 67:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UDQmode != UHQmode
   && reload_completed))
        return -1;
      return 1943; /* *fractudquhq2 */

    case 68:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DAmode != UHQmode
   && reload_completed))
        return -1;
      return 1944; /* *fractdauhq2 */

    case 69:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UDAmode != UHQmode
   && reload_completed))
        return -1;
      return 1945; /* *fractudauhq2 */

    case 70:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(TAmode != UHQmode
   && reload_completed))
        return -1;
      return 1946; /* *fracttauhq2 */

    case 71:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UTAmode != UHQmode
   && reload_completed))
        return -1;
      return 1947; /* *fractutauhq2 */

    case 72:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(QImode != UHQmode
   && reload_completed))
        return -1;
      return 1948; /* *fractqiuhq2 */

    case 73:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HImode != UHQmode
   && reload_completed))
        return -1;
      return 1949; /* *fracthiuhq2 */

    case 74:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SImode != UHQmode
   && reload_completed))
        return -1;
      return 1950; /* *fractsiuhq2 */

    case 75:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DImode != UHQmode
   && reload_completed))
        return -1;
      return 1951; /* *fractdiuhq2 */

    case 76:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(QQmode != HAmode
   && reload_completed))
        return -1;
      return 1952; /* *fractqqha2 */

    case 77:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UQQmode != HAmode
   && reload_completed))
        return -1;
      return 1953; /* *fractuqqha2 */

    case 78:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HQmode != HAmode
   && reload_completed))
        return -1;
      return 1954; /* *fracthqha2 */

    case 79:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UHQmode != HAmode
   && reload_completed))
        return -1;
      return 1955; /* *fractuhqha2 */

    case 80:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UHAmode != HAmode
   && reload_completed))
        return -1;
      return 1956; /* *fractuhaha2 */

    case 81:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SQmode != HAmode
   && reload_completed))
        return -1;
      return 1957; /* *fractsqha2 */

    case 82:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(USQmode != HAmode
   && reload_completed))
        return -1;
      return 1958; /* *fractusqha2 */

    case 83:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SAmode != HAmode
   && reload_completed))
        return -1;
      return 1959; /* *fractsaha2 */

    case 84:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(USAmode != HAmode
   && reload_completed))
        return -1;
      return 1960; /* *fractusaha2 */

    case 85:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DQmode != HAmode
   && reload_completed))
        return -1;
      return 1961; /* *fractdqha2 */

    case 86:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UDQmode != HAmode
   && reload_completed))
        return -1;
      return 1962; /* *fractudqha2 */

    case 87:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DAmode != HAmode
   && reload_completed))
        return -1;
      return 1963; /* *fractdaha2 */

    case 88:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UDAmode != HAmode
   && reload_completed))
        return -1;
      return 1964; /* *fractudaha2 */

    case 89:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(TAmode != HAmode
   && reload_completed))
        return -1;
      return 1965; /* *fracttaha2 */

    case 90:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UTAmode != HAmode
   && reload_completed))
        return -1;
      return 1966; /* *fractutaha2 */

    case 91:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(QImode != HAmode
   && reload_completed))
        return -1;
      return 1967; /* *fractqiha2 */

    case 92:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HImode != HAmode
   && reload_completed))
        return -1;
      return 1968; /* *fracthiha2 */

    case 93:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SImode != HAmode
   && reload_completed))
        return -1;
      return 1969; /* *fractsiha2 */

    case 94:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DImode != HAmode
   && reload_completed))
        return -1;
      return 1970; /* *fractdiha2 */

    case 95:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(QQmode != UHAmode
   && reload_completed))
        return -1;
      return 1971; /* *fractqquha2 */

    case 96:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UQQmode != UHAmode
   && reload_completed))
        return -1;
      return 1972; /* *fractuqquha2 */

    case 97:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HQmode != UHAmode
   && reload_completed))
        return -1;
      return 1973; /* *fracthquha2 */

    case 98:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UHQmode != UHAmode
   && reload_completed))
        return -1;
      return 1974; /* *fractuhquha2 */

    case 99:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HAmode != UHAmode
   && reload_completed))
        return -1;
      return 1975; /* *fracthauha2 */

    case 100:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SQmode != UHAmode
   && reload_completed))
        return -1;
      return 1976; /* *fractsquha2 */

    case 101:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(USQmode != UHAmode
   && reload_completed))
        return -1;
      return 1977; /* *fractusquha2 */

    case 102:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SAmode != UHAmode
   && reload_completed))
        return -1;
      return 1978; /* *fractsauha2 */

    case 103:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(USAmode != UHAmode
   && reload_completed))
        return -1;
      return 1979; /* *fractusauha2 */

    case 104:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DQmode != UHAmode
   && reload_completed))
        return -1;
      return 1980; /* *fractdquha2 */

    case 105:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UDQmode != UHAmode
   && reload_completed))
        return -1;
      return 1981; /* *fractudquha2 */

    case 106:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DAmode != UHAmode
   && reload_completed))
        return -1;
      return 1982; /* *fractdauha2 */

    case 107:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UDAmode != UHAmode
   && reload_completed))
        return -1;
      return 1983; /* *fractudauha2 */

    case 108:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(TAmode != UHAmode
   && reload_completed))
        return -1;
      return 1984; /* *fracttauha2 */

    case 109:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UTAmode != UHAmode
   && reload_completed))
        return -1;
      return 1985; /* *fractutauha2 */

    case 110:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(QImode != UHAmode
   && reload_completed))
        return -1;
      return 1986; /* *fractqiuha2 */

    case 111:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HImode != UHAmode
   && reload_completed))
        return -1;
      return 1987; /* *fracthiuha2 */

    case 112:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SImode != UHAmode
   && reload_completed))
        return -1;
      return 1988; /* *fractsiuha2 */

    case 113:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DImode != UHAmode
   && reload_completed))
        return -1;
      return 1989; /* *fractdiuha2 */

    case 114:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(QQmode != SQmode
   && reload_completed))
        return -1;
      return 1990; /* *fractqqsq2 */

    case 115:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UQQmode != SQmode
   && reload_completed))
        return -1;
      return 1991; /* *fractuqqsq2 */

    case 116:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HQmode != SQmode
   && reload_completed))
        return -1;
      return 1992; /* *fracthqsq2 */

    case 117:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UHQmode != SQmode
   && reload_completed))
        return -1;
      return 1993; /* *fractuhqsq2 */

    case 118:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HAmode != SQmode
   && reload_completed))
        return -1;
      return 1994; /* *fracthasq2 */

    case 119:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UHAmode != SQmode
   && reload_completed))
        return -1;
      return 1995; /* *fractuhasq2 */

    case 120:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(USQmode != SQmode
   && reload_completed))
        return -1;
      return 1996; /* *fractusqsq2 */

    case 121:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SAmode != SQmode
   && reload_completed))
        return -1;
      return 1997; /* *fractsasq2 */

    case 122:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(USAmode != SQmode
   && reload_completed))
        return -1;
      return 1998; /* *fractusasq2 */

    case 123:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DQmode != SQmode
   && reload_completed))
        return -1;
      return 1999; /* *fractdqsq2 */

    case 124:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UDQmode != SQmode
   && reload_completed))
        return -1;
      return 2000; /* *fractudqsq2 */

    case 125:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DAmode != SQmode
   && reload_completed))
        return -1;
      return 2001; /* *fractdasq2 */

    case 126:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UDAmode != SQmode
   && reload_completed))
        return -1;
      return 2002; /* *fractudasq2 */

    case 127:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(TAmode != SQmode
   && reload_completed))
        return -1;
      return 2003; /* *fracttasq2 */

    case 128:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UTAmode != SQmode
   && reload_completed))
        return -1;
      return 2004; /* *fractutasq2 */

    case 129:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(QImode != SQmode
   && reload_completed))
        return -1;
      return 2005; /* *fractqisq2 */

    case 130:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HImode != SQmode
   && reload_completed))
        return -1;
      return 2006; /* *fracthisq2 */

    case 131:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SImode != SQmode
   && reload_completed))
        return -1;
      return 2007; /* *fractsisq2 */

    case 132:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DImode != SQmode
   && reload_completed))
        return -1;
      return 2008; /* *fractdisq2 */

    case 133:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(QQmode != USQmode
   && reload_completed))
        return -1;
      return 2009; /* *fractqqusq2 */

    case 134:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UQQmode != USQmode
   && reload_completed))
        return -1;
      return 2010; /* *fractuqqusq2 */

    case 135:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HQmode != USQmode
   && reload_completed))
        return -1;
      return 2011; /* *fracthqusq2 */

    case 136:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UHQmode != USQmode
   && reload_completed))
        return -1;
      return 2012; /* *fractuhqusq2 */

    case 137:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HAmode != USQmode
   && reload_completed))
        return -1;
      return 2013; /* *fracthausq2 */

    case 138:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UHAmode != USQmode
   && reload_completed))
        return -1;
      return 2014; /* *fractuhausq2 */

    case 139:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SQmode != USQmode
   && reload_completed))
        return -1;
      return 2015; /* *fractsqusq2 */

    case 140:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SAmode != USQmode
   && reload_completed))
        return -1;
      return 2016; /* *fractsausq2 */

    case 141:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(USAmode != USQmode
   && reload_completed))
        return -1;
      return 2017; /* *fractusausq2 */

    case 142:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DQmode != USQmode
   && reload_completed))
        return -1;
      return 2018; /* *fractdqusq2 */

    case 143:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UDQmode != USQmode
   && reload_completed))
        return -1;
      return 2019; /* *fractudqusq2 */

    case 144:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DAmode != USQmode
   && reload_completed))
        return -1;
      return 2020; /* *fractdausq2 */

    case 145:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UDAmode != USQmode
   && reload_completed))
        return -1;
      return 2021; /* *fractudausq2 */

    case 146:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(TAmode != USQmode
   && reload_completed))
        return -1;
      return 2022; /* *fracttausq2 */

    case 147:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UTAmode != USQmode
   && reload_completed))
        return -1;
      return 2023; /* *fractutausq2 */

    case 148:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(QImode != USQmode
   && reload_completed))
        return -1;
      return 2024; /* *fractqiusq2 */

    case 149:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HImode != USQmode
   && reload_completed))
        return -1;
      return 2025; /* *fracthiusq2 */

    case 150:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SImode != USQmode
   && reload_completed))
        return -1;
      return 2026; /* *fractsiusq2 */

    case 151:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DImode != USQmode
   && reload_completed))
        return -1;
      return 2027; /* *fractdiusq2 */

    case 152:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(QQmode != SAmode
   && reload_completed))
        return -1;
      return 2028; /* *fractqqsa2 */

    case 153:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UQQmode != SAmode
   && reload_completed))
        return -1;
      return 2029; /* *fractuqqsa2 */

    case 154:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HQmode != SAmode
   && reload_completed))
        return -1;
      return 2030; /* *fracthqsa2 */

    case 155:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UHQmode != SAmode
   && reload_completed))
        return -1;
      return 2031; /* *fractuhqsa2 */

    case 156:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HAmode != SAmode
   && reload_completed))
        return -1;
      return 2032; /* *fracthasa2 */

    case 157:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UHAmode != SAmode
   && reload_completed))
        return -1;
      return 2033; /* *fractuhasa2 */

    case 158:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SQmode != SAmode
   && reload_completed))
        return -1;
      return 2034; /* *fractsqsa2 */

    case 159:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(USQmode != SAmode
   && reload_completed))
        return -1;
      return 2035; /* *fractusqsa2 */

    case 160:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(USAmode != SAmode
   && reload_completed))
        return -1;
      return 2036; /* *fractusasa2 */

    case 161:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DQmode != SAmode
   && reload_completed))
        return -1;
      return 2037; /* *fractdqsa2 */

    case 162:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UDQmode != SAmode
   && reload_completed))
        return -1;
      return 2038; /* *fractudqsa2 */

    case 163:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DAmode != SAmode
   && reload_completed))
        return -1;
      return 2039; /* *fractdasa2 */

    case 164:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UDAmode != SAmode
   && reload_completed))
        return -1;
      return 2040; /* *fractudasa2 */

    case 165:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(TAmode != SAmode
   && reload_completed))
        return -1;
      return 2041; /* *fracttasa2 */

    case 166:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UTAmode != SAmode
   && reload_completed))
        return -1;
      return 2042; /* *fractutasa2 */

    case 167:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(QImode != SAmode
   && reload_completed))
        return -1;
      return 2043; /* *fractqisa2 */

    case 168:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HImode != SAmode
   && reload_completed))
        return -1;
      return 2044; /* *fracthisa2 */

    case 169:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SImode != SAmode
   && reload_completed))
        return -1;
      return 2045; /* *fractsisa2 */

    case 170:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DImode != SAmode
   && reload_completed))
        return -1;
      return 2046; /* *fractdisa2 */

    case 171:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(QQmode != USAmode
   && reload_completed))
        return -1;
      return 2047; /* *fractqqusa2 */

    case 172:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UQQmode != USAmode
   && reload_completed))
        return -1;
      return 2048; /* *fractuqqusa2 */

    case 173:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HQmode != USAmode
   && reload_completed))
        return -1;
      return 2049; /* *fracthqusa2 */

    case 174:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UHQmode != USAmode
   && reload_completed))
        return -1;
      return 2050; /* *fractuhqusa2 */

    case 175:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HAmode != USAmode
   && reload_completed))
        return -1;
      return 2051; /* *fracthausa2 */

    case 176:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UHAmode != USAmode
   && reload_completed))
        return -1;
      return 2052; /* *fractuhausa2 */

    case 177:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SQmode != USAmode
   && reload_completed))
        return -1;
      return 2053; /* *fractsqusa2 */

    case 178:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(USQmode != USAmode
   && reload_completed))
        return -1;
      return 2054; /* *fractusqusa2 */

    case 179:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SAmode != USAmode
   && reload_completed))
        return -1;
      return 2055; /* *fractsausa2 */

    case 180:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DQmode != USAmode
   && reload_completed))
        return -1;
      return 2056; /* *fractdqusa2 */

    case 181:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UDQmode != USAmode
   && reload_completed))
        return -1;
      return 2057; /* *fractudqusa2 */

    case 182:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DAmode != USAmode
   && reload_completed))
        return -1;
      return 2058; /* *fractdausa2 */

    case 183:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UDAmode != USAmode
   && reload_completed))
        return -1;
      return 2059; /* *fractudausa2 */

    case 184:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(TAmode != USAmode
   && reload_completed))
        return -1;
      return 2060; /* *fracttausa2 */

    case 185:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UTAmode != USAmode
   && reload_completed))
        return -1;
      return 2061; /* *fractutausa2 */

    case 186:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(QImode != USAmode
   && reload_completed))
        return -1;
      return 2062; /* *fractqiusa2 */

    case 187:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HImode != USAmode
   && reload_completed))
        return -1;
      return 2063; /* *fracthiusa2 */

    case 188:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SImode != USAmode
   && reload_completed))
        return -1;
      return 2064; /* *fractsiusa2 */

    case 189:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DImode != USAmode
   && reload_completed))
        return -1;
      return 2065; /* *fractdiusa2 */

    case 190:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(QQmode != DQmode
   && reload_completed))
        return -1;
      return 2066; /* *fractqqdq2 */

    case 191:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UQQmode != DQmode
   && reload_completed))
        return -1;
      return 2067; /* *fractuqqdq2 */

    case 192:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HQmode != DQmode
   && reload_completed))
        return -1;
      return 2068; /* *fracthqdq2 */

    case 193:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UHQmode != DQmode
   && reload_completed))
        return -1;
      return 2069; /* *fractuhqdq2 */

    case 194:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HAmode != DQmode
   && reload_completed))
        return -1;
      return 2070; /* *fracthadq2 */

    case 195:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UHAmode != DQmode
   && reload_completed))
        return -1;
      return 2071; /* *fractuhadq2 */

    case 196:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SQmode != DQmode
   && reload_completed))
        return -1;
      return 2072; /* *fractsqdq2 */

    case 197:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(USQmode != DQmode
   && reload_completed))
        return -1;
      return 2073; /* *fractusqdq2 */

    case 198:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SAmode != DQmode
   && reload_completed))
        return -1;
      return 2074; /* *fractsadq2 */

    case 199:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(USAmode != DQmode
   && reload_completed))
        return -1;
      return 2075; /* *fractusadq2 */

    case 200:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UDQmode != DQmode
   && reload_completed))
        return -1;
      return 2076; /* *fractudqdq2 */

    case 201:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DAmode != DQmode
   && reload_completed))
        return -1;
      return 2077; /* *fractdadq2 */

    case 202:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UDAmode != DQmode
   && reload_completed))
        return -1;
      return 2078; /* *fractudadq2 */

    case 203:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(TAmode != DQmode
   && reload_completed))
        return -1;
      return 2079; /* *fracttadq2 */

    case 204:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UTAmode != DQmode
   && reload_completed))
        return -1;
      return 2080; /* *fractutadq2 */

    case 205:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(QImode != DQmode
   && reload_completed))
        return -1;
      return 2081; /* *fractqidq2 */

    case 206:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HImode != DQmode
   && reload_completed))
        return -1;
      return 2082; /* *fracthidq2 */

    case 207:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SImode != DQmode
   && reload_completed))
        return -1;
      return 2083; /* *fractsidq2 */

    case 208:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DImode != DQmode
   && reload_completed))
        return -1;
      return 2084; /* *fractdidq2 */

    case 209:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(QQmode != UDQmode
   && reload_completed))
        return -1;
      return 2085; /* *fractqqudq2 */

    case 210:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UQQmode != UDQmode
   && reload_completed))
        return -1;
      return 2086; /* *fractuqqudq2 */

    case 211:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HQmode != UDQmode
   && reload_completed))
        return -1;
      return 2087; /* *fracthqudq2 */

    case 212:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UHQmode != UDQmode
   && reload_completed))
        return -1;
      return 2088; /* *fractuhqudq2 */

    case 213:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HAmode != UDQmode
   && reload_completed))
        return -1;
      return 2089; /* *fracthaudq2 */

    case 214:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UHAmode != UDQmode
   && reload_completed))
        return -1;
      return 2090; /* *fractuhaudq2 */

    case 215:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SQmode != UDQmode
   && reload_completed))
        return -1;
      return 2091; /* *fractsqudq2 */

    case 216:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(USQmode != UDQmode
   && reload_completed))
        return -1;
      return 2092; /* *fractusqudq2 */

    case 217:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SAmode != UDQmode
   && reload_completed))
        return -1;
      return 2093; /* *fractsaudq2 */

    case 218:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(USAmode != UDQmode
   && reload_completed))
        return -1;
      return 2094; /* *fractusaudq2 */

    case 219:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DQmode != UDQmode
   && reload_completed))
        return -1;
      return 2095; /* *fractdqudq2 */

    case 220:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DAmode != UDQmode
   && reload_completed))
        return -1;
      return 2096; /* *fractdaudq2 */

    case 221:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UDAmode != UDQmode
   && reload_completed))
        return -1;
      return 2097; /* *fractudaudq2 */

    case 222:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(TAmode != UDQmode
   && reload_completed))
        return -1;
      return 2098; /* *fracttaudq2 */

    case 223:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UTAmode != UDQmode
   && reload_completed))
        return -1;
      return 2099; /* *fractutaudq2 */

    case 224:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(QImode != UDQmode
   && reload_completed))
        return -1;
      return 2100; /* *fractqiudq2 */

    case 225:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HImode != UDQmode
   && reload_completed))
        return -1;
      return 2101; /* *fracthiudq2 */

    case 226:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SImode != UDQmode
   && reload_completed))
        return -1;
      return 2102; /* *fractsiudq2 */

    case 227:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DImode != UDQmode
   && reload_completed))
        return -1;
      return 2103; /* *fractdiudq2 */

    case 228:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(QQmode != DAmode
   && reload_completed))
        return -1;
      return 2104; /* *fractqqda2 */

    case 229:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UQQmode != DAmode
   && reload_completed))
        return -1;
      return 2105; /* *fractuqqda2 */

    case 230:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HQmode != DAmode
   && reload_completed))
        return -1;
      return 2106; /* *fracthqda2 */

    case 231:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UHQmode != DAmode
   && reload_completed))
        return -1;
      return 2107; /* *fractuhqda2 */

    case 232:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HAmode != DAmode
   && reload_completed))
        return -1;
      return 2108; /* *fracthada2 */

    case 233:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UHAmode != DAmode
   && reload_completed))
        return -1;
      return 2109; /* *fractuhada2 */

    case 234:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SQmode != DAmode
   && reload_completed))
        return -1;
      return 2110; /* *fractsqda2 */

    case 235:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(USQmode != DAmode
   && reload_completed))
        return -1;
      return 2111; /* *fractusqda2 */

    case 236:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SAmode != DAmode
   && reload_completed))
        return -1;
      return 2112; /* *fractsada2 */

    case 237:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(USAmode != DAmode
   && reload_completed))
        return -1;
      return 2113; /* *fractusada2 */

    case 238:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DQmode != DAmode
   && reload_completed))
        return -1;
      return 2114; /* *fractdqda2 */

    case 239:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UDQmode != DAmode
   && reload_completed))
        return -1;
      return 2115; /* *fractudqda2 */

    case 240:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UDAmode != DAmode
   && reload_completed))
        return -1;
      return 2116; /* *fractudada2 */

    case 241:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(TAmode != DAmode
   && reload_completed))
        return -1;
      return 2117; /* *fracttada2 */

    case 242:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UTAmode != DAmode
   && reload_completed))
        return -1;
      return 2118; /* *fractutada2 */

    case 243:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(QImode != DAmode
   && reload_completed))
        return -1;
      return 2119; /* *fractqida2 */

    case 244:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HImode != DAmode
   && reload_completed))
        return -1;
      return 2120; /* *fracthida2 */

    case 245:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SImode != DAmode
   && reload_completed))
        return -1;
      return 2121; /* *fractsida2 */

    case 246:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DImode != DAmode
   && reload_completed))
        return -1;
      return 2122; /* *fractdida2 */

    case 247:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(QQmode != UDAmode
   && reload_completed))
        return -1;
      return 2123; /* *fractqquda2 */

    case 248:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UQQmode != UDAmode
   && reload_completed))
        return -1;
      return 2124; /* *fractuqquda2 */

    case 249:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HQmode != UDAmode
   && reload_completed))
        return -1;
      return 2125; /* *fracthquda2 */

    case 250:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UHQmode != UDAmode
   && reload_completed))
        return -1;
      return 2126; /* *fractuhquda2 */

    case 251:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HAmode != UDAmode
   && reload_completed))
        return -1;
      return 2127; /* *fracthauda2 */

    case 252:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UHAmode != UDAmode
   && reload_completed))
        return -1;
      return 2128; /* *fractuhauda2 */

    case 253:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SQmode != UDAmode
   && reload_completed))
        return -1;
      return 2129; /* *fractsquda2 */

    case 254:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(USQmode != UDAmode
   && reload_completed))
        return -1;
      return 2130; /* *fractusquda2 */

    case 255:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SAmode != UDAmode
   && reload_completed))
        return -1;
      return 2131; /* *fractsauda2 */

    case 256:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(USAmode != UDAmode
   && reload_completed))
        return -1;
      return 2132; /* *fractusauda2 */

    case 257:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DQmode != UDAmode
   && reload_completed))
        return -1;
      return 2133; /* *fractdquda2 */

    case 258:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UDQmode != UDAmode
   && reload_completed))
        return -1;
      return 2134; /* *fractudquda2 */

    case 259:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DAmode != UDAmode
   && reload_completed))
        return -1;
      return 2135; /* *fractdauda2 */

    case 260:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(TAmode != UDAmode
   && reload_completed))
        return -1;
      return 2136; /* *fracttauda2 */

    case 261:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UTAmode != UDAmode
   && reload_completed))
        return -1;
      return 2137; /* *fractutauda2 */

    case 262:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(QImode != UDAmode
   && reload_completed))
        return -1;
      return 2138; /* *fractqiuda2 */

    case 263:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HImode != UDAmode
   && reload_completed))
        return -1;
      return 2139; /* *fracthiuda2 */

    case 264:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SImode != UDAmode
   && reload_completed))
        return -1;
      return 2140; /* *fractsiuda2 */

    case 265:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DImode != UDAmode
   && reload_completed))
        return -1;
      return 2141; /* *fractdiuda2 */

    case 266:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(QQmode != TAmode
   && reload_completed))
        return -1;
      return 2142; /* *fractqqta2 */

    case 267:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UQQmode != TAmode
   && reload_completed))
        return -1;
      return 2143; /* *fractuqqta2 */

    case 268:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HQmode != TAmode
   && reload_completed))
        return -1;
      return 2144; /* *fracthqta2 */

    case 269:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UHQmode != TAmode
   && reload_completed))
        return -1;
      return 2145; /* *fractuhqta2 */

    case 270:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HAmode != TAmode
   && reload_completed))
        return -1;
      return 2146; /* *fracthata2 */

    case 271:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UHAmode != TAmode
   && reload_completed))
        return -1;
      return 2147; /* *fractuhata2 */

    case 272:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SQmode != TAmode
   && reload_completed))
        return -1;
      return 2148; /* *fractsqta2 */

    case 273:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(USQmode != TAmode
   && reload_completed))
        return -1;
      return 2149; /* *fractusqta2 */

    case 274:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SAmode != TAmode
   && reload_completed))
        return -1;
      return 2150; /* *fractsata2 */

    case 275:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(USAmode != TAmode
   && reload_completed))
        return -1;
      return 2151; /* *fractusata2 */

    case 276:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DQmode != TAmode
   && reload_completed))
        return -1;
      return 2152; /* *fractdqta2 */

    case 277:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UDQmode != TAmode
   && reload_completed))
        return -1;
      return 2153; /* *fractudqta2 */

    case 278:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DAmode != TAmode
   && reload_completed))
        return -1;
      return 2154; /* *fractdata2 */

    case 279:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UDAmode != TAmode
   && reload_completed))
        return -1;
      return 2155; /* *fractudata2 */

    case 280:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UTAmode != TAmode
   && reload_completed))
        return -1;
      return 2156; /* *fractutata2 */

    case 281:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(QImode != TAmode
   && reload_completed))
        return -1;
      return 2157; /* *fractqita2 */

    case 282:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HImode != TAmode
   && reload_completed))
        return -1;
      return 2158; /* *fracthita2 */

    case 283:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SImode != TAmode
   && reload_completed))
        return -1;
      return 2159; /* *fractsita2 */

    case 284:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DImode != TAmode
   && reload_completed))
        return -1;
      return 2160; /* *fractdita2 */

    case 285:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(QQmode != UTAmode
   && reload_completed))
        return -1;
      return 2161; /* *fractqquta2 */

    case 286:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UQQmode != UTAmode
   && reload_completed))
        return -1;
      return 2162; /* *fractuqquta2 */

    case 287:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HQmode != UTAmode
   && reload_completed))
        return -1;
      return 2163; /* *fracthquta2 */

    case 288:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UHQmode != UTAmode
   && reload_completed))
        return -1;
      return 2164; /* *fractuhquta2 */

    case 289:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HAmode != UTAmode
   && reload_completed))
        return -1;
      return 2165; /* *fracthauta2 */

    case 290:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UHAmode != UTAmode
   && reload_completed))
        return -1;
      return 2166; /* *fractuhauta2 */

    case 291:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SQmode != UTAmode
   && reload_completed))
        return -1;
      return 2167; /* *fractsquta2 */

    case 292:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(USQmode != UTAmode
   && reload_completed))
        return -1;
      return 2168; /* *fractusquta2 */

    case 293:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SAmode != UTAmode
   && reload_completed))
        return -1;
      return 2169; /* *fractsauta2 */

    case 294:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(USAmode != UTAmode
   && reload_completed))
        return -1;
      return 2170; /* *fractusauta2 */

    case 295:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DQmode != UTAmode
   && reload_completed))
        return -1;
      return 2171; /* *fractdquta2 */

    case 296:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UDQmode != UTAmode
   && reload_completed))
        return -1;
      return 2172; /* *fractudquta2 */

    case 297:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DAmode != UTAmode
   && reload_completed))
        return -1;
      return 2173; /* *fractdauta2 */

    case 298:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UDAmode != UTAmode
   && reload_completed))
        return -1;
      return 2174; /* *fractudauta2 */

    case 299:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(TAmode != UTAmode
   && reload_completed))
        return -1;
      return 2175; /* *fracttauta2 */

    case 300:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(QImode != UTAmode
   && reload_completed))
        return -1;
      return 2176; /* *fractqiuta2 */

    case 301:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HImode != UTAmode
   && reload_completed))
        return -1;
      return 2177; /* *fracthiuta2 */

    case 302:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SImode != UTAmode
   && reload_completed))
        return -1;
      return 2178; /* *fractsiuta2 */

    case 303:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DImode != UTAmode
   && reload_completed))
        return -1;
      return 2179; /* *fractdiuta2 */

    case 304:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(QQmode != QImode
   && reload_completed))
        return -1;
      return 2180; /* *fractqqqi2 */

    case 305:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UQQmode != QImode
   && reload_completed))
        return -1;
      return 2181; /* *fractuqqqi2 */

    case 306:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HQmode != QImode
   && reload_completed))
        return -1;
      return 2182; /* *fracthqqi2 */

    case 307:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UHQmode != QImode
   && reload_completed))
        return -1;
      return 2183; /* *fractuhqqi2 */

    case 308:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HAmode != QImode
   && reload_completed))
        return -1;
      return 2184; /* *fracthaqi2 */

    case 309:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UHAmode != QImode
   && reload_completed))
        return -1;
      return 2185; /* *fractuhaqi2 */

    case 310:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SQmode != QImode
   && reload_completed))
        return -1;
      return 2186; /* *fractsqqi2 */

    case 311:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(USQmode != QImode
   && reload_completed))
        return -1;
      return 2187; /* *fractusqqi2 */

    case 312:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SAmode != QImode
   && reload_completed))
        return -1;
      return 2188; /* *fractsaqi2 */

    case 313:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(USAmode != QImode
   && reload_completed))
        return -1;
      return 2189; /* *fractusaqi2 */

    case 314:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DQmode != QImode
   && reload_completed))
        return -1;
      return 2190; /* *fractdqqi2 */

    case 315:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UDQmode != QImode
   && reload_completed))
        return -1;
      return 2191; /* *fractudqqi2 */

    case 316:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DAmode != QImode
   && reload_completed))
        return -1;
      return 2192; /* *fractdaqi2 */

    case 317:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UDAmode != QImode
   && reload_completed))
        return -1;
      return 2193; /* *fractudaqi2 */

    case 318:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(TAmode != QImode
   && reload_completed))
        return -1;
      return 2194; /* *fracttaqi2 */

    case 319:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UTAmode != QImode
   && reload_completed))
        return -1;
      return 2195; /* *fractutaqi2 */

    case 320:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HImode != QImode
   && reload_completed))
        return -1;
      return 2196; /* *fracthiqi2 */

    case 321:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SImode != QImode
   && reload_completed))
        return -1;
      return 2197; /* *fractsiqi2 */

    case 322:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DImode != QImode
   && reload_completed))
        return -1;
      return 2198; /* *fractdiqi2 */

    case 323:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(QQmode != HImode
   && reload_completed))
        return -1;
      return 2199; /* *fractqqhi2 */

    case 324:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UQQmode != HImode
   && reload_completed))
        return -1;
      return 2200; /* *fractuqqhi2 */

    case 325:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HQmode != HImode
   && reload_completed))
        return -1;
      return 2201; /* *fracthqhi2 */

    case 326:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UHQmode != HImode
   && reload_completed))
        return -1;
      return 2202; /* *fractuhqhi2 */

    case 327:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HAmode != HImode
   && reload_completed))
        return -1;
      return 2203; /* *fracthahi2 */

    case 328:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UHAmode != HImode
   && reload_completed))
        return -1;
      return 2204; /* *fractuhahi2 */

    case 329:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SQmode != HImode
   && reload_completed))
        return -1;
      return 2205; /* *fractsqhi2 */

    case 330:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(USQmode != HImode
   && reload_completed))
        return -1;
      return 2206; /* *fractusqhi2 */

    case 331:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SAmode != HImode
   && reload_completed))
        return -1;
      return 2207; /* *fractsahi2 */

    case 332:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(USAmode != HImode
   && reload_completed))
        return -1;
      return 2208; /* *fractusahi2 */

    case 333:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DQmode != HImode
   && reload_completed))
        return -1;
      return 2209; /* *fractdqhi2 */

    case 334:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UDQmode != HImode
   && reload_completed))
        return -1;
      return 2210; /* *fractudqhi2 */

    case 335:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DAmode != HImode
   && reload_completed))
        return -1;
      return 2211; /* *fractdahi2 */

    case 336:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UDAmode != HImode
   && reload_completed))
        return -1;
      return 2212; /* *fractudahi2 */

    case 337:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(TAmode != HImode
   && reload_completed))
        return -1;
      return 2213; /* *fracttahi2 */

    case 338:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UTAmode != HImode
   && reload_completed))
        return -1;
      return 2214; /* *fractutahi2 */

    case 339:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(QImode != HImode
   && reload_completed))
        return -1;
      return 2215; /* *fractqihi2 */

    case 340:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SImode != HImode
   && reload_completed))
        return -1;
      return 2216; /* *fractsihi2 */

    case 341:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DImode != HImode
   && reload_completed))
        return -1;
      return 2217; /* *fractdihi2 */

    case 342:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(QQmode != SImode
   && reload_completed))
        return -1;
      return 2218; /* *fractqqsi2 */

    case 343:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UQQmode != SImode
   && reload_completed))
        return -1;
      return 2219; /* *fractuqqsi2 */

    case 344:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HQmode != SImode
   && reload_completed))
        return -1;
      return 2220; /* *fracthqsi2 */

    case 345:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UHQmode != SImode
   && reload_completed))
        return -1;
      return 2221; /* *fractuhqsi2 */

    case 346:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HAmode != SImode
   && reload_completed))
        return -1;
      return 2222; /* *fracthasi2 */

    case 347:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UHAmode != SImode
   && reload_completed))
        return -1;
      return 2223; /* *fractuhasi2 */

    case 348:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SQmode != SImode
   && reload_completed))
        return -1;
      return 2224; /* *fractsqsi2 */

    case 349:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(USQmode != SImode
   && reload_completed))
        return -1;
      return 2225; /* *fractusqsi2 */

    case 350:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SAmode != SImode
   && reload_completed))
        return -1;
      return 2226; /* *fractsasi2 */

    case 351:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(USAmode != SImode
   && reload_completed))
        return -1;
      return 2227; /* *fractusasi2 */

    case 352:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DQmode != SImode
   && reload_completed))
        return -1;
      return 2228; /* *fractdqsi2 */

    case 353:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UDQmode != SImode
   && reload_completed))
        return -1;
      return 2229; /* *fractudqsi2 */

    case 354:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DAmode != SImode
   && reload_completed))
        return -1;
      return 2230; /* *fractdasi2 */

    case 355:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UDAmode != SImode
   && reload_completed))
        return -1;
      return 2231; /* *fractudasi2 */

    case 356:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(TAmode != SImode
   && reload_completed))
        return -1;
      return 2232; /* *fracttasi2 */

    case 357:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UTAmode != SImode
   && reload_completed))
        return -1;
      return 2233; /* *fractutasi2 */

    case 358:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(QImode != SImode
   && reload_completed))
        return -1;
      return 2234; /* *fractqisi2 */

    case 359:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HImode != SImode
   && reload_completed))
        return -1;
      return 2235; /* *fracthisi2 */

    case 360:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DImode != SImode
   && reload_completed))
        return -1;
      return 2236; /* *fractdisi2 */

    case 361:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(QQmode != DImode
   && reload_completed))
        return -1;
      return 2237; /* *fractqqdi2 */

    case 362:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UQQmode != DImode
   && reload_completed))
        return -1;
      return 2238; /* *fractuqqdi2 */

    case 363:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HQmode != DImode
   && reload_completed))
        return -1;
      return 2239; /* *fracthqdi2 */

    case 364:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UHQmode != DImode
   && reload_completed))
        return -1;
      return 2240; /* *fractuhqdi2 */

    case 365:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HAmode != DImode
   && reload_completed))
        return -1;
      return 2241; /* *fracthadi2 */

    case 366:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UHAmode != DImode
   && reload_completed))
        return -1;
      return 2242; /* *fractuhadi2 */

    case 367:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SQmode != DImode
   && reload_completed))
        return -1;
      return 2243; /* *fractsqdi2 */

    case 368:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(USQmode != DImode
   && reload_completed))
        return -1;
      return 2244; /* *fractusqdi2 */

    case 369:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SAmode != DImode
   && reload_completed))
        return -1;
      return 2245; /* *fractsadi2 */

    case 370:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(USAmode != DImode
   && reload_completed))
        return -1;
      return 2246; /* *fractusadi2 */

    case 371:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DQmode != DImode
   && reload_completed))
        return -1;
      return 2247; /* *fractdqdi2 */

    case 372:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UDQmode != DImode
   && reload_completed))
        return -1;
      return 2248; /* *fractudqdi2 */

    case 373:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DAmode != DImode
   && reload_completed))
        return -1;
      return 2249; /* *fractdadi2 */

    case 374:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UDAmode != DImode
   && reload_completed))
        return -1;
      return 2250; /* *fractudadi2 */

    case 375:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(TAmode != DImode
   && reload_completed))
        return -1;
      return 2251; /* *fracttadi2 */

    case 376:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UTAmode != DImode
   && reload_completed))
        return -1;
      return 2252; /* *fractutadi2 */

    case 377:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(QImode != DImode
   && reload_completed))
        return -1;
      return 2253; /* *fractqidi2 */

    case 378:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HImode != DImode
   && reload_completed))
        return -1;
      return 2254; /* *fracthidi2 */

    case 379:
      if (!
#line 75 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SImode != DImode
   && reload_completed))
        return -1;
      return 2255; /* *fractsidi2 */

    default:
      return -1;
    }
}

 rtx_insn *
split_21 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case LSHIFTRT:
      if (GET_MODE (x3) != E_HImode)
        return NULL;
      x4 = XEXP (x3, 0);
      if (GET_CODE (x4) != MULT
          || GET_MODE (x4) != E_HImode)
        return NULL;
      x5 = XEXP (x3, 1);
      if (x5 != const_int_rtx[MAX_SAVED_CONST_INT + 8])
        return NULL;
      x6 = XEXP (x1, 0);
      operands[0] = x6;
      if (!register_operand (operands[0], E_QImode)
          || GET_MODE (x2) != E_QImode)
        return NULL;
      x7 = XEXP (x4, 0);
      if (GET_MODE (x7) != E_HImode)
        return NULL;
      x8 = XEXP (x4, 1);
      if (GET_MODE (x8) != E_HImode)
        return NULL;
      switch (GET_CODE (x7))
        {
        case SIGN_EXTEND:
          if (GET_CODE (x8) != SIGN_EXTEND)
            return NULL;
          x9 = XEXP (x7, 0);
          operands[1] = x9;
          if (!register_operand (operands[1], E_QImode))
            return NULL;
          x10 = XEXP (x8, 0);
          operands[2] = x10;
          if (!register_operand (operands[2], E_QImode)
              || !(
#line 2265 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 2267 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_164 (insn, operands);

        case ZERO_EXTEND:
          if (GET_CODE (x8) != ZERO_EXTEND)
            return NULL;
          x9 = XEXP (x7, 0);
          operands[1] = x9;
          if (!register_operand (operands[1], E_QImode))
            return NULL;
          x10 = XEXP (x8, 0);
          operands[2] = x10;
          if (!register_operand (operands[2], E_QImode)
              || !(
#line 2265 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 2267 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_165 (insn, operands);

        default:
          return NULL;
        }

    case PARITY:
      if (GET_MODE (x3) != E_SImode
          || pattern35 (x1, 
E_SImode, 
22) != 0
          || !
#line 9234 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_640 (insn, operands);

    case POPCOUNT:
      if (GET_MODE (x3) != E_SImode
          || pattern35 (x1, 
E_SImode, 
22) != 0
          || !
#line 9310 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_643 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_23 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (XVECLEN (x3, 0))
    {
    case 3:
      switch (pattern68 (x3))
        {
        case 0:
          if (!
#line 1548 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_98 (insn, operands);

        case 1:
          if (!
#line 8905 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_628 (insn, operands);

        case 2:
          if (!
#line 686 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1846 (insn, operands);

        case 3:
          if (!
#line 686 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1847 (insn, operands);

        case 4:
          if (!
#line 686 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1848 (insn, operands);

        case 5:
          if (!
#line 686 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1849 (insn, operands);

        case 6:
          if (!
#line 686 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1850 (insn, operands);

        case 7:
          if (!
#line 686 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1851 (insn, operands);

        case 8:
          if (!
#line 686 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1852 (insn, operands);

        case 9:
          if (!
#line 686 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1853 (insn, operands);

        case 10:
          if (!
#line 686 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1854 (insn, operands);

        case 11:
          if (!
#line 686 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1855 (insn, operands);

        default:
          return NULL;
        }

    case 2:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x3) != E_HImode)
        return NULL;
      x4 = XVECEXP (x3, 0, 0);
      operands[1] = x4;
      if (!register_operand (operands[1], E_QImode))
        return NULL;
      x5 = XVECEXP (x3, 0, 1);
      operands[2] = x5;
      if (!register_operand (operands[2], E_QImode))
        return NULL;
      switch (XINT (x3, 1))
        {
        case 4:
          if (!(
#line 9703 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 9705 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_653 (insn, operands);

        case 5:
          if (!(
#line 9775 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 9777 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_655 (insn, operands);

        case 6:
          if (!(
#line 9847 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL) && 
#line 9849 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_657 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}

 rtx_insn *
split_29 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx_insn *res ATTRIBUTE_UNUSED;
  if (pattern294 (x1) != 0)
    return NULL;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  switch (REGNO (x4))
    {
    case 24:
      x5 = XEXP (x3, 1);
      if (REGNO (x5) != 22)
        return NULL;
      x6 = XVECEXP (x1, 0, 1);
      x7 = XEXP (x6, 1);
      x8 = XEXP (x7, 0);
      if (REGNO (x8) != 24)
        return NULL;
      x9 = XEXP (x7, 1);
      if (REGNO (x9) != 22)
        return NULL;
      switch (pattern374 (x1))
        {
        case 0:
          if (!
#line 3923 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_346 (insn, operands);

        case 1:
          if (!
#line 4011 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_350 (insn, operands);

        default:
          return NULL;
        }

    case 22:
      if (pattern361 (x1, 
E_SImode, 
18, 
22) != 0
          || pattern356 (x1, 
E_HImode, 
26, 
E_SImode, 
22) != 0
          || pattern370 (x1, 
E_SImode, 
E_HImode, 
30) != 0
          || !
#line 4409 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_364 (insn, operands);

    default:
      return NULL;
    }
}

 rtx_insn *
split_33 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  rtx_insn *res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (GET_CODE (x2))
    {
    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case MEM:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      x3 = XEXP (x1, 0);
      switch (GET_CODE (x3))
        {
        case REG:
        case SUBREG:
        case MEM:
          res = split_1 (x1, insn);
          if (res != NULL_RTX)
            return res;
          break;

        case ZERO_EXTRACT:
          if (GET_MODE (x3) == E_QImode)
            {
              x4 = XEXP (x3, 1);
              if (x4 == const_int_rtx[MAX_SAVED_CONST_INT + 1])
                {
                  x5 = XEXP (x3, 0);
                  operands[0] = x5;
                  if (register_operand (operands[0], E_QImode))
                    {
                      x6 = XEXP (x3, 2);
                      operands[1] = x6;
                      if (const_0_to_7_operand (operands[1], E_QImode))
                        {
                          operands[2] = x2;
                          if (nonmemory_operand (operands[2], E_QImode)
                              && 
#line 10000 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
                            return gen_split_659 (insn, operands);
                        }
                    }
                }
            }
          break;

        default:
          break;
        }
      if (GET_CODE (x2) != SUBREG)
        return NULL;
      operands[0] = x3;
      if (GET_MODE (x2) != E_QImode)
        return NULL;
      switch (pattern123 (x2))
        {
        case 0:
          if (register_operand (operands[0], E_QImode))
            return gen_split_425 (insn, operands);
          if (!memory_operand (operands[0], E_QImode)
              || !(
#line 5405 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(!reload_completed) && 
#line 5407 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_427 (insn, operands);

        case 1:
          if (register_operand (operands[0], E_QImode))
            return gen_split_426 (insn, operands);
          if (!memory_operand (operands[0], E_QImode)
              || !(
#line 5405 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(!reload_completed) && 
#line 5407 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_428 (insn, operands);

        case 2:
          if (!(
#line 5423 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(!reload_completed) && 
#line 5425 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_429 (insn, operands);

        case 3:
          if (!
#line 8998 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_630 (insn, operands);

        case 4:
          if (!(
#line 10466 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(! reload_completed) && 
#line 10468 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_727 (insn, operands);

        case 5:
          if (!(
#line 10466 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(! reload_completed) && 
#line 10468 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_728 (insn, operands);

        case 6:
          if (!(
#line 10466 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(! reload_completed) && 
#line 10468 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( 1)))
            return NULL;
          return gen_split_729 (insn, operands);

        case 7:
          return gen_split_634 (insn, operands);

        default:
          return NULL;
        }

    case UNSPEC:
      return split_23 (x1, insn);

    case PLUS:
      return split_10 (x1, insn);

    case MINUS:
      switch (pattern14 (x1))
        {
        case 0:
          if (!
#line 1772 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_107 (insn, operands);

        case 1:
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          res = split_2 (x1, insn);
          if (res != NULL_RTX)
            return res;
          x7 = XEXP (x2, 0);
          if (GET_CODE (x7) != REG)
            return NULL;
          switch (pattern73 (x1))
            {
            case 0:
              if (!(
#line 211 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 213 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
( reload_completed)))
                return NULL;
              return gen_split_1881 (insn, operands);

            case 1:
              if (!(
#line 211 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 213 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
( reload_completed)))
                return NULL;
              return gen_split_1882 (insn, operands);

            case 2:
              if (!(
#line 211 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 213 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
( reload_completed)))
                return NULL;
              return gen_split_1883 (insn, operands);

            case 3:
              if (!(
#line 211 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 213 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
( reload_completed)))
                return NULL;
              return gen_split_1884 (insn, operands);

            case 4:
              if (!(
#line 211 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 213 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
( reload_completed)))
                return NULL;
              return gen_split_1885 (insn, operands);

            case 5:
              if (!(
#line 211 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 213 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
( reload_completed)))
                return NULL;
              return gen_split_1886 (insn, operands);

            case 6:
              if (!(
#line 211 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 213 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
( reload_completed)))
                return NULL;
              return gen_split_1887 (insn, operands);

            case 7:
              if (!(
#line 236 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 238 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
( reload_completed)))
                return NULL;
              return gen_split_1888 (insn, operands);

            case 8:
              if (!(
#line 236 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 238 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
( reload_completed)))
                return NULL;
              return gen_split_1889 (insn, operands);

            case 9:
              if (!(
#line 236 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 238 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
( reload_completed)))
                return NULL;
              return gen_split_1890 (insn, operands);

            case 10:
              if (!(
#line 236 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 238 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
( reload_completed)))
                return NULL;
              return gen_split_1891 (insn, operands);

            case 11:
              if (!(
#line 236 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 238 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
( reload_completed)))
                return NULL;
              return gen_split_1892 (insn, operands);

            case 12:
              if (!(
#line 236 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 238 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
( reload_completed)))
                return NULL;
              return gen_split_1893 (insn, operands);

            case 13:
              if (!(
#line 236 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 238 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
( reload_completed)))
                return NULL;
              return gen_split_1894 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case MULT:
      return split_13 (x1, insn);

    case TRUNCATE:
      return split_21 (x1, insn);

    case ASHIFT:
      return split_15 (x1, insn);

    case AND:
      return split_14 (x1, insn);

    case IOR:
      return split_11 (x1, insn);

    case XOR:
      return split_12 (x1, insn);

    case ROTATE:
      x7 = XEXP (x2, 0);
      switch (GET_CODE (x7))
        {
        case REG:
        case SUBREG:
          operands[1] = x7;
          res = split_6 (x1, insn);
          if (res != NULL_RTX)
            return res;
          if (GET_CODE (x7) != REG)
            return NULL;
          switch (pattern56 (x1))
            {
            case 0:
              if (!(
#line 629 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 631 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
( reload_completed)))
                return NULL;
              return gen_split_1938 (insn, operands);

            case 1:
              if (!(
#line 629 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 631 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
( reload_completed)))
                return NULL;
              return gen_split_1942 (insn, operands);

            case 2:
              if (!(
#line 629 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 631 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
( reload_completed)))
                return NULL;
              return gen_split_1946 (insn, operands);

            case 3:
              if (!(
#line 629 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 631 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
( reload_completed)))
                return NULL;
              return gen_split_1950 (insn, operands);

            case 4:
              if (!(
#line 629 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 631 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
( reload_completed)))
                return NULL;
              return gen_split_1954 (insn, operands);

            case 5:
              if (!(
#line 629 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 631 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
( reload_completed)))
                return NULL;
              return gen_split_1958 (insn, operands);

            case 6:
              if (!(
#line 629 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 631 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
( reload_completed)))
                return NULL;
              return gen_split_1962 (insn, operands);

            default:
              return NULL;
            }

        case CONST_INT:
          if (XWINT (x7, 0) != -2L
              || pattern74 (x1) != 0
              || !
#line 9041 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_632 (insn, operands);

        default:
          return NULL;
        }

    case ZERO_EXTEND:
      return split_19 (x1, insn);

    case ASHIFTRT:
      return split_22 (x1, insn);

    case LSHIFTRT:
      return split_17 (x1, insn);

    case ABS:
      switch (pattern15 (x1))
        {
        case 0:
          if (!
#line 6180 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_538 (insn, operands);

        case 1:
          if (!
#line 6200 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_539 (insn, operands);

        default:
          return NULL;
        }

    case NEG:
      return split_16 (x1, insn);

    case NOT:
      x7 = XEXP (x2, 0);
      switch (GET_CODE (x7))
        {
        case REG:
        case SUBREG:
          switch (pattern57 (x1))
            {
            case 0:
              if (!
#line 6357 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
                return NULL;
              return gen_split_546 (insn, operands);

            case 1:
              if (!
#line 6375 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
                return NULL;
              return gen_split_547 (insn, operands);

            case 2:
              if (!
#line 6394 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
                return NULL;
              return gen_split_548 (insn, operands);

            case 3:
              if (!
#line 6412 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
                return NULL;
              return gen_split_549 (insn, operands);

            case 4:
              x3 = XEXP (x1, 0);
              x5 = XEXP (x3, 0);
              operands[0] = x5;
              if (!register_operand (operands[0], E_QImode))
                return NULL;
              x6 = XEXP (x3, 2);
              operands[1] = x6;
              if (!const_0_to_7_operand (operands[1], E_QImode)
                  || GET_MODE (x2) != E_QImode)
                return NULL;
              operands[2] = x7;
              if (!register_operand (operands[2], E_QImode)
                  || !
#line 10101 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
                return NULL;
              return gen_split_663 (insn, operands);

            default:
              return NULL;
            }

        case ROTATE:
          if (pattern58 (x1) != 0
              || !
#line 9028 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_631 (insn, operands);

        case LSHIFTRT:
          if (pattern59 (x1) != 0
              || !
#line 10070 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_660 (insn, operands);

        case ASHIFTRT:
          if (pattern59 (x1) != 0
              || !
#line 10070 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_661 (insn, operands);

        default:
          return NULL;
        }

    case SIGN_EXTEND:
      switch (pattern20 (x1))
        {
        case 0:
          if (!
#line 6443 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_550 (insn, operands);

        case 1:
          if (!
#line 6464 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_551 (insn, operands);

        case 2:
          if (!
#line 6506 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_553 (insn, operands);

        case 3:
          if (!
#line 6485 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_552 (insn, operands);

        case 4:
          if (!
#line 6527 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_554 (insn, operands);

        case 5:
          if (!
#line 6548 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_555 (insn, operands);

        default:
          return NULL;
        }

    case IF_THEN_ELSE:
      return split_18 (x1, insn);

    case PARITY:
      if (GET_MODE (x2) != E_HImode
          || pattern60 (x1, 
24, 
E_HImode) != 0
          || !
#line 9198 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_638 (insn, operands);

    case POPCOUNT:
      switch (pattern22 (x1))
        {
        case 0:
          if (!
#line 9292 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_642 (insn, operands);

        case 1:
          if (!
#line 9328 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
            return NULL;
          return gen_split_644 (insn, operands);

        default:
          return NULL;
        }

    case BSWAP:
      if (GET_MODE (x2) != E_SImode
          || pattern60 (x1, 
22, 
E_SImode) != 0
          || !
#line 9596 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
        return NULL;
      return gen_split_652 (insn, operands);

    case GE:
      if (GET_MODE (x2) != E_QImode)
        return NULL;
      x8 = XEXP (x2, 1);
      if (x8 == const_int_rtx[MAX_SAVED_CONST_INT + 0]
          && pattern95 (x1) == 0
          && 
#line 10117 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
        return gen_split_664 (insn, operands);
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern96 (x2))
        {
        case 0:
          if (!
#line 10526 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return NULL;
          return gen_split_743 (insn, operands);

        case 1:
          if (!
#line 10526 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return NULL;
          return gen_split_744 (insn, operands);

        case 2:
          if (!
#line 10526 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return NULL;
          return gen_split_745 (insn, operands);

        case 3:
          if (!
#line 10526 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return NULL;
          return gen_split_746 (insn, operands);

        default:
          return NULL;
        }

    case SIGN_EXTRACT:
      x8 = XEXP (x2, 1);
      if (x8 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return NULL;
      x7 = XEXP (x2, 0);
      switch (GET_CODE (x7))
        {
        case XOR:
          if (pattern92 (x1) != 0
              || !(
#line 10133 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(INTVAL (operands[4]) & (1 << INTVAL (operands[3]))) && 
#line 10135 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed)))
            return NULL;
          return gen_split_665 (insn, operands);

        case REG:
        case SUBREG:
          operands[1] = x7;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          switch (pattern180 (x2))
            {
            case 0:
              if (!
#line 10649 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
                return NULL;
              return gen_split_774 (insn, operands);

            case 1:
              if (!
#line 10649 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
                return NULL;
              return gen_split_778 (insn, operands);

            case 2:
              if (!
#line 10649 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
                return NULL;
              return gen_split_782 (insn, operands);

            case 3:
              if (!
#line 10649 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
                return NULL;
              return gen_split_786 (insn, operands);

            case 4:
              if (!
#line 10649 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
                return NULL;
              return gen_split_775 (insn, operands);

            case 5:
              if (!
#line 10649 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
                return NULL;
              return gen_split_779 (insn, operands);

            case 6:
              if (!
#line 10649 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
                return NULL;
              return gen_split_783 (insn, operands);

            case 7:
              if (!
#line 10649 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
                return NULL;
              return gen_split_787 (insn, operands);

            case 8:
              if (!
#line 10649 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
                return NULL;
              return gen_split_776 (insn, operands);

            case 9:
              if (!
#line 10649 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
                return NULL;
              return gen_split_780 (insn, operands);

            case 10:
              if (!
#line 10649 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
                return NULL;
              return gen_split_784 (insn, operands);

            case 11:
              if (!
#line 10649 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
                return NULL;
              return gen_split_788 (insn, operands);

            case 12:
              if (!
#line 10649 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
                return NULL;
              return gen_split_777 (insn, operands);

            case 13:
              if (!
#line 10649 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
                return NULL;
              return gen_split_781 (insn, operands);

            case 14:
              if (!
#line 10649 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
                return NULL;
              return gen_split_785 (insn, operands);

            case 15:
              if (!
#line 10649 "../../gcc-15.1.0/gcc/config/avr/avr.md"
( reload_completed))
                return NULL;
              return gen_split_789 (insn, operands);

            default:
              return NULL;
            }

        default:
          return NULL;
        }

    case ZERO_EXTRACT:
      return split_20 (x1, insn);

    case FRACT_CONVERT:
      return split_9 (x1, insn);

    case UNSIGNED_FRACT_CONVERT:
      return split_8 (x1, insn);

    case SS_PLUS:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern62 (x2))
        {
        case 0:
          if (
#line 126 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed))
            return gen_split_1791 (insn, operands);
          break;

        case 1:
          if (
#line 126 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed))
            return gen_split_1793 (insn, operands);
          break;

        case 2:
          if (
#line 126 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed))
            return gen_split_1795 (insn, operands);
          break;

        case 3:
          if (
#line 126 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed))
            return gen_split_1797 (insn, operands);
          break;

        case 4:
          if (
#line 126 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed))
            return gen_split_1799 (insn, operands);
          break;

        default:
          break;
        }
      x7 = XEXP (x2, 0);
      if (GET_CODE (x7) != REG)
        return NULL;
      switch (pattern63 (x1))
        {
        case 0:
          if (!(
#line 288 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 290 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1895 (insn, operands);

        case 1:
          if (!(
#line 288 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 290 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1897 (insn, operands);

        case 2:
          if (!(
#line 288 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 290 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1899 (insn, operands);

        case 3:
          if (!(
#line 309 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 311 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1901 (insn, operands);

        case 4:
          if (!(
#line 309 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 311 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1903 (insn, operands);

        case 5:
          if (!(
#line 309 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 311 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1905 (insn, operands);

        default:
          return NULL;
        }

    case SS_MINUS:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern62 (x2))
        {
        case 0:
          if (
#line 126 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed))
            return gen_split_1792 (insn, operands);
          break;

        case 1:
          if (
#line 126 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed))
            return gen_split_1794 (insn, operands);
          break;

        case 2:
          if (
#line 126 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed))
            return gen_split_1796 (insn, operands);
          break;

        case 3:
          if (
#line 126 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed))
            return gen_split_1798 (insn, operands);
          break;

        case 4:
          if (
#line 126 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed))
            return gen_split_1800 (insn, operands);
          break;

        default:
          break;
        }
      x7 = XEXP (x2, 0);
      if (GET_CODE (x7) != REG)
        return NULL;
      switch (pattern63 (x1))
        {
        case 0:
          if (!(
#line 288 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 290 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1896 (insn, operands);

        case 1:
          if (!(
#line 288 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 290 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1898 (insn, operands);

        case 2:
          if (!(
#line 288 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 290 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1900 (insn, operands);

        case 3:
          if (!(
#line 309 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 311 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1902 (insn, operands);

        case 4:
          if (!(
#line 309 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 311 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1904 (insn, operands);

        case 5:
          if (!(
#line 309 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 311 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1906 (insn, operands);

        default:
          return NULL;
        }

    case US_PLUS:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern64 (x2))
        {
        case 0:
          if (
#line 151 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed))
            return gen_split_1801 (insn, operands);
          break;

        case 1:
          if (
#line 151 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed))
            return gen_split_1803 (insn, operands);
          break;

        case 2:
          if (
#line 151 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed))
            return gen_split_1805 (insn, operands);
          break;

        case 3:
          if (
#line 151 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed))
            return gen_split_1807 (insn, operands);
          break;

        case 4:
          if (
#line 151 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed))
            return gen_split_1809 (insn, operands);
          break;

        default:
          break;
        }
      x7 = XEXP (x2, 0);
      if (GET_CODE (x7) != REG)
        return NULL;
      switch (pattern65 (x1))
        {
        case 0:
          if (!(
#line 361 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 363 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1907 (insn, operands);

        case 1:
          if (!(
#line 361 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 363 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1909 (insn, operands);

        case 2:
          if (!(
#line 361 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 363 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1911 (insn, operands);

        case 3:
          if (!(
#line 382 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 384 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1913 (insn, operands);

        case 4:
          if (!(
#line 382 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 384 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1915 (insn, operands);

        case 5:
          if (!(
#line 382 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 384 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1917 (insn, operands);

        default:
          return NULL;
        }

    case US_MINUS:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern64 (x2))
        {
        case 0:
          if (
#line 151 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed))
            return gen_split_1802 (insn, operands);
          break;

        case 1:
          if (
#line 151 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed))
            return gen_split_1804 (insn, operands);
          break;

        case 2:
          if (
#line 151 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed))
            return gen_split_1806 (insn, operands);
          break;

        case 3:
          if (
#line 151 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed))
            return gen_split_1808 (insn, operands);
          break;

        case 4:
          if (
#line 151 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed))
            return gen_split_1810 (insn, operands);
          break;

        default:
          break;
        }
      x7 = XEXP (x2, 0);
      if (GET_CODE (x7) != REG)
        return NULL;
      switch (pattern65 (x1))
        {
        case 0:
          if (!(
#line 361 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 363 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1908 (insn, operands);

        case 1:
          if (!(
#line 361 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 363 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1910 (insn, operands);

        case 2:
          if (!(
#line 361 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 363 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1912 (insn, operands);

        case 3:
          if (!(
#line 382 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 384 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1914 (insn, operands);

        case 4:
          if (!(
#line 382 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 384 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1916 (insn, operands);

        case 5:
          if (!(
#line 382 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode) && 
#line 384 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
( reload_completed)))
            return NULL;
          return gen_split_1918 (insn, operands);

        default:
          return NULL;
        }

    case SS_NEG:
      if (GET_MODE (x2) == E_QQmode)
        {
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (register_operand (operands[0], E_QQmode))
            {
              x7 = XEXP (x2, 0);
              operands[1] = x7;
              if (register_operand (operands[1], E_QQmode)
                  && 
#line 191 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed))
                return gen_split_1811 (insn, operands);
            }
        }
      x7 = XEXP (x2, 0);
      if (GET_CODE (x7) != REG)
        return NULL;
      switch (pattern66 (x1))
        {
        case 0:
          if (!
#line 243 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1814 (insn, operands);

        case 1:
          if (!
#line 243 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1816 (insn, operands);

        case 2:
          if (!
#line 263 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1818 (insn, operands);

        case 3:
          if (!
#line 263 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1820 (insn, operands);

        default:
          return NULL;
        }

    case SS_ABS:
      if (GET_MODE (x2) == E_QQmode)
        {
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (register_operand (operands[0], E_QQmode))
            {
              x7 = XEXP (x2, 0);
              operands[1] = x7;
              if (register_operand (operands[1], E_QQmode)
                  && 
#line 209 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed))
                return gen_split_1812 (insn, operands);
            }
        }
      x7 = XEXP (x2, 0);
      if (GET_CODE (x7) != REG)
        return NULL;
      switch (pattern66 (x1))
        {
        case 0:
          if (!
#line 243 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1813 (insn, operands);

        case 1:
          if (!
#line 243 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1815 (insn, operands);

        case 2:
          if (!
#line 263 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1817 (insn, operands);

        case 3:
          if (!
#line 263 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed))
            return NULL;
          return gen_split_1819 (insn, operands);

        default:
          return NULL;
        }

    default:
      return NULL;
    }
}
