/* Generated automatically by the program `genrecog' from the target
   machine description file.  */

#define IN_TARGET_CODE 1

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "backend.h"
#include "predict.h"
#include "rtl.h"
#include "memmodel.h"
#include "tm_p.h"
#include "emit-rtl.h"
#include "insn-config.h"
#include "recog.h"
#include "output.h"
#include "flags.h"
#include "df.h"
#include "resource.h"
#include "diagnostic-core.h"
#include "reload.h"
#include "regs.h"
#include "tm-constrs.h"
#include "insn-recog.h"


/* `recog' contains a decision tree that recognizes whether the rtx
   X0 is a valid instruction.

   recog returns -1 if the rtx is not valid.  If the rtx is valid, recog
   returns a nonnegative number which is the insn code number for the
   pattern that matched.  This is the same as the order in the machine
   description of the entry that matched.  This number can be used as an
   index into `insn_data' and other tables.
   The third parameter to recog is an optional pointer to an int.  If
   present, recog will accept a pattern if it matches except for missing
   CLOBBER expressions at the end.  In that case, the value pointed to by
   the optional pointer will be set to the number of CLOBBERs that need
   to be added (it should be initialized to zero by the caller).  If it   is set nonzero, the caller should allocate a PARALLEL of the
   appropriate size, copy the initial entries, and call add_clobbers
   (found in insn-emit.cc) to fill in the CLOBBERs.

   The function split_insns returns 0 if the rtl could not
   be split or the split rtl as an INSN list if it can be.

   The function peephole2_insns returns 0 if the rtl could not
   be matched. If there was a match, the new rtl is returned in an INSN list,
   and LAST_INSN will point to the last recognized insn in the old sequence.
*/




int
pattern7 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1
      || !register_operand (operands[2], i1))
    return -1;
  return pattern6 (); /* [-1, 3] */
}

int
pattern10 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1)
    return -1;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1
      || !nonmemory_operand (operands[3], i1)
      || !register_operand (operands[4], i1))
    return -1;
  return pattern9 (); /* [-1, 3] */
}

int
pattern16 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  if (!register_operand (operands[0], E_HImode)
      || GET_MODE (x2) != E_HImode)
    return -1;
  x5 = XEXP (x3, 0);
  operands[1] = x5;
  if (!register_operand (operands[1], E_QImode))
    return -1;
  return 0;
}

int
pattern19 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], E_SImode)
      || GET_MODE (x1) != E_SImode)
    return -1;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!combine_pseudo_register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!combine_pseudo_register_operand (operands[1], E_HImode))
        return -1;
      return 1;

    case E_PSImode:
      if (!combine_pseudo_register_operand (operands[1], E_PSImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern26 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL)
    return -1;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_CODE (x4) != REG)
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_CODE (x5) != REG)
    return -1;
  switch (REGNO (x3))
    {
    case 25:
      if (REGNO (x4) != 22
          || REGNO (x5) != 24)
        return -1;
      switch (GET_MODE (x5))
        {
        case E_QQmode:
          if (GET_MODE (x2) != E_QQmode
              || GET_MODE (x3) != E_QQmode
              || GET_MODE (x4) != E_QQmode)
            return -1;
          return 0;

        case E_UQQmode:
          if (GET_MODE (x2) != E_UQQmode
              || GET_MODE (x3) != E_UQQmode
              || GET_MODE (x4) != E_UQQmode)
            return -1;
          return 1;

        default:
          return -1;
        }

    case 26:
      res = pattern24 (x1, 
22);
      if (res >= 0)
        return res + 2; /* [2, 5] */
      return -1;

    case 24:
      if (REGNO (x4) != 18)
        return -1;
      res = pattern25 (x1, 
22);
      if (res >= 0)
        return res + 6; /* [6, 7] */
      return -1;

    default:
      return -1;
    }
}

int
pattern35 (rtx x1, machine_mode i1, unsigned int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != i2
      || GET_MODE (x4) != i1
      || pattern34 (x1, 
E_HImode, 
24) != 0)
    return -1;
  return 0;
}

int
pattern39 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case REG:
    case SUBREG:
      operands[1] = x5;
      if (!register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case AND:
      x6 = XEXP (x5, 1);
      if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      res = pattern38 (x3);
      if (res >= 0)
        return res + 1; /* [1, 6] */
      return -1;

    default:
      return -1;
    }
}

int
pattern47 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  x5 = XEXP (x2, 1);
  operands[3] = x5;
  return pattern46 (x1); /* [-1, 5] */
}

int
pattern50 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x2) != E_HImode
          || !combine_pseudo_register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_PSImode:
      res = pattern18 (x2);
      if (res >= 0)
        return res + 1; /* [1, 2] */
      return -1;

    case E_SImode:
      res = pattern19 (x2);
      if (res >= 0)
        return res + 3; /* [3, 5] */
      return -1;

    case E_DImode:
      if (!register_operand (operands[0], E_DImode)
          || GET_MODE (x2) != E_DImode)
        return -1;
      switch (GET_MODE (operands[1]))
        {
        case E_QImode:
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 6;

        case E_HImode:
          if (!register_operand (operands[1], E_HImode))
            return -1;
          return 7;

        case E_SImode:
          if (!register_operand (operands[1], E_SImode))
            return -1;
          return 8;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern62 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  switch (GET_MODE (operands[0]))
    {
    case E_QQmode:
      return pattern61 (x1, 
E_QQmode); /* [-1, 0] */

    case E_HQmode:
      if (pattern61 (x1, 
E_HQmode) != 0)
        return -1;
      return 1;

    case E_HAmode:
      if (pattern61 (x1, 
E_HAmode) != 0)
        return -1;
      return 2;

    case E_SAmode:
      if (pattern61 (x1, 
E_SAmode) != 0)
        return -1;
      return 3;

    case E_SQmode:
      if (pattern61 (x1, 
E_SQmode) != 0)
        return -1;
      return 4;

    default:
      return -1;
    }
}

int
pattern69 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != E_HImode)
    return -1;
  x4 = XEXP (x1, 0);
  operands[0] = x4;
  if (!register_operand (operands[0], E_HImode)
      || GET_MODE (x2) != E_HImode)
    return -1;
  x5 = XEXP (x2, 0);
  operands[1] = x5;
  if (!register_operand (operands[1], E_HImode))
    return -1;
  x6 = XEXP (x3, 0);
  operands[2] = x6;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern73 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != 18)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 18)
    return -1;
  x5 = XEXP (x2, 1);
  switch (GET_CODE (x5))
    {
    case REG:
      return pattern70 (x1); /* [-1, 6] */

    case CONST_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
      res = pattern71 (x1);
      if (res >= 0)
        return res + 7; /* [7, 13] */
      return -1;

    default:
      return -1;
    }
}

int
pattern75 (rtx x1, int *pnum_clobbers)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  x4 = XEXP (x3, 1);
  operands[2] = x4;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern61 (x3, 
E_QImode); /* [-1, 0] */

    case E_HImode:
      if (pnum_clobbers == NULL
          || pattern61 (x3, 
E_HImode) != 0)
        return -1;
      return 1;

    case E_PSImode:
      if (pattern53 (x3, pnum_clobbers, 
E_PSImode) != 0)
        return -1;
      return 2;

    case E_SImode:
      if (pnum_clobbers == NULL
          || pattern61 (x3, 
E_SImode) != 0)
        return -1;
      return 3;

    default:
      return -1;
    }
}

int
pattern83 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[1] = x3;
      x4 = XEXP (x2, 1);
      if (GET_CODE (x4) != CONST_INT)
        return -1;
      return 0;

    case ZERO_EXTEND:
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[1] = x5;
          x4 = XEXP (x2, 1);
          if (GET_CODE (x4) != CONST_INT)
            return -1;
          return 1;

        case AND:
          res = pattern2 (x1);
          if (res >= 0)
            return res + 2; /* [2, 7] */
          return -1;

        default:
          return -1;
        }

    case SIGN_EXTEND:
      x5 = XEXP (x3, 0);
      switch (GET_CODE (x5))
        {
        case REG:
        case SUBREG:
          operands[1] = x5;
          if (!register_operand (operands[1], E_QImode))
            return -1;
          x4 = XEXP (x2, 1);
          if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 8]
              || !register_operand (operands[0], E_HImode)
              || GET_MODE (x1) != E_HImode
              || GET_MODE (x2) != E_HImode
              || GET_MODE (x3) != E_HImode)
            return -1;
          x6 = XEXP (x1, 1);
          res = pattern82 (x6);
          if (res >= 0)
            return res + 8; /* [8, 9] */
          return -1;

        case AND:
          res = pattern2 (x1);
          if (res >= 0)
            return res + 10; /* [10, 15] */
          return -1;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern95 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) != ZERO_EXTRACT
      || GET_MODE (x2) != E_QImode)
    return -1;
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  x4 = XEXP (x2, 0);
  operands[0] = x4;
  if (!register_operand (operands[0], E_QImode))
    return -1;
  x5 = XEXP (x2, 2);
  operands[1] = x5;
  if (!const_0_to_7_operand (operands[1], E_QImode))
    return -1;
  x6 = XEXP (x1, 1);
  x7 = XEXP (x6, 0);
  operands[2] = x7;
  if (!register_operand (operands[2], E_QImode))
    return -1;
  return 0;
}

int
pattern101 (rtx x1, unsigned int i1, machine_mode i2, machine_mode i3, unsigned int i4)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  if (GET_MODE (x3) != i3)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != i4
      || GET_MODE (x4) != i3)
    return -1;
  x5 = XEXP (x2, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != i4
      || GET_MODE (x5) != i3)
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  return pattern100 (x6, 
i1, 
i2); /* [-1, 0] */
}

int
pattern108 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !nonmemory_operand (operands[2], i1))
    return -1;
  return 0;
}

int
pattern114 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1)
      || !const_int_operand (operands[2], E_QImode)
      || !scratch_or_dreg_operand (operands[3], E_QImode))
    return -1;
  return 0;
}

int
pattern120 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_MODE (x2) != E_QImode)
    return -1;
  x3 = XEXP (x2, 1);
  if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
    return -1;
  return pattern41 (x1); /* [-1, 1] */
}

int
pattern123 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8;
  int res ATTRIBUTE_UNUSED;
  switch (SUBREG_BYTE (x1))
    {
    case 0:
      x2 = XEXP (x1, 0);
      switch (GET_CODE (x2))
        {
        case ASHIFT:
          if (GET_MODE (x2) != E_HImode)
            return -1;
          x3 = XEXP (x2, 1);
          operands[2] = x3;
          if (!register_operand (operands[2], E_QImode))
            return -1;
          x4 = XEXP (x2, 0);
          switch (GET_CODE (x4))
            {
            case SIGN_EXTEND:
              if (GET_MODE (x4) != E_HImode)
                return -1;
              x5 = XEXP (x4, 0);
              operands[1] = x5;
              if (!register_operand (operands[1], E_QImode))
                return -1;
              return 0;

            case ZERO_EXTEND:
              if (GET_MODE (x4) != E_HImode)
                return -1;
              x5 = XEXP (x4, 0);
              operands[1] = x5;
              if (!register_operand (operands[1], E_QImode))
                return -1;
              return 1;

            case REG:
            case SUBREG:
              operands[1] = x4;
              if (!register_operand (operands[1], E_HImode)
                  || !nonimmediate_operand (operands[0], E_QImode))
                return -1;
              return 2;

            default:
              return -1;
            }

        case ASHIFTRT:
          if (GET_MODE (x2) != E_HImode)
            return -1;
          x4 = XEXP (x2, 0);
          if (GET_CODE (x4) != CONST_INT
              || XWINT (x4, 0) != 128L)
            return -1;
          x3 = XEXP (x2, 1);
          if (GET_CODE (x3) != AND
              || GET_MODE (x3) != E_QImode)
            return -1;
          x6 = XEXP (x3, 1);
          if (x6 != const_int_rtx[MAX_SAVED_CONST_INT + 7]
              || !register_operand (operands[0], E_QImode))
            return -1;
          x7 = XEXP (x3, 0);
          operands[1] = x7;
          if (!register_operand (operands[1], E_QImode))
            return -1;
          return 3;

        case ZERO_EXTRACT:
          x3 = XEXP (x2, 1);
          if (x3 != const_int_rtx[MAX_SAVED_CONST_INT + 1]
              || !register_operand (operands[0], E_QImode))
            return -1;
          x4 = XEXP (x2, 0);
          operands[1] = x4;
          x8 = XEXP (x2, 2);
          operands[2] = x8;
          switch (GET_MODE (x2))
            {
            case E_HImode:
              if (!register_operand (operands[1], E_HImode)
                  || !const_0_to_15_operand (operands[2], E_QImode))
                return -1;
              return 4;

            case E_PSImode:
              if (!register_operand (operands[1], E_PSImode)
                  || !const_0_to_23_operand (operands[2], E_QImode))
                return -1;
              return 5;

            case E_SImode:
              if (!register_operand (operands[1], E_SImode)
                  || !const_0_to_31_operand (operands[2], E_QImode))
                return -1;
              return 6;

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 2:
      x2 = XEXP (x1, 0);
      if (GET_CODE (x2) != LO_SUM
          || GET_MODE (x2) != E_PSImode
          || !register_operand (operands[0], E_QImode))
        return -1;
      x4 = XEXP (x2, 0);
      operands[1] = x4;
      if (!nonmemory_operand (operands[1], E_QImode))
        return -1;
      x3 = XEXP (x2, 1);
      operands[2] = x3;
      if (!register_operand (operands[2], E_HImode))
        return -1;
      return 7;

    default:
      return -1;
    }
}

int
pattern150 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != 22)
    return -1;
  x4 = XEXP (x2, 1);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 18)
    return -1;
  x5 = XEXP (x1, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != 22)
    return -1;
  return 0;
}

int
pattern153 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (!nop_general_operand (operands[2], E_QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      if (!register_operand (operands[0], E_QImode)
          || GET_MODE (x1) != E_QImode
          || !register_operand (operands[1], E_QImode))
        return -1;
      return 0;

    case E_QQmode:
      if (!register_operand (operands[0], E_QQmode)
          || GET_MODE (x1) != E_QQmode
          || !register_operand (operands[1], E_QQmode))
        return -1;
      return 1;

    case E_UQQmode:
      if (!register_operand (operands[0], E_UQQmode)
          || GET_MODE (x1) != E_UQQmode
          || !register_operand (operands[1], E_UQQmode))
        return -1;
      return 2;

    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode
          || !register_operand (operands[1], E_HImode))
        return -1;
      return 3;

    case E_HQmode:
      if (!register_operand (operands[0], E_HQmode)
          || GET_MODE (x1) != E_HQmode
          || !register_operand (operands[1], E_HQmode))
        return -1;
      return 4;

    case E_UHQmode:
      if (!register_operand (operands[0], E_UHQmode)
          || GET_MODE (x1) != E_UHQmode
          || !register_operand (operands[1], E_UHQmode))
        return -1;
      return 5;

    case E_HAmode:
      if (!register_operand (operands[0], E_HAmode)
          || GET_MODE (x1) != E_HAmode
          || !register_operand (operands[1], E_HAmode))
        return -1;
      return 6;

    case E_UHAmode:
      if (!register_operand (operands[0], E_UHAmode)
          || GET_MODE (x1) != E_UHAmode
          || !register_operand (operands[1], E_UHAmode))
        return -1;
      return 7;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 8;

    case E_SQmode:
      if (!register_operand (operands[0], E_SQmode)
          || GET_MODE (x1) != E_SQmode
          || !register_operand (operands[1], E_SQmode))
        return -1;
      return 9;

    case E_USQmode:
      if (!register_operand (operands[0], E_USQmode)
          || GET_MODE (x1) != E_USQmode
          || !register_operand (operands[1], E_USQmode))
        return -1;
      return 10;

    case E_SAmode:
      if (!register_operand (operands[0], E_SAmode)
          || GET_MODE (x1) != E_SAmode
          || !register_operand (operands[1], E_SAmode))
        return -1;
      return 11;

    case E_USAmode:
      if (!register_operand (operands[0], E_USAmode)
          || GET_MODE (x1) != E_USAmode
          || !register_operand (operands[1], E_USAmode))
        return -1;
      return 12;

    default:
      return -1;
    }
}

int
pattern180 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 2);
  operands[2] = x2;
  if (!const0_operand (operands[2], E_QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_QImode:
      return pattern179 (x1, 
E_QImode); /* [-1, 3] */

    case E_HImode:
      res = pattern179 (x1, 
E_HImode);
      if (res >= 0)
        return res + 4; /* [4, 7] */
      return -1;

    case E_PSImode:
      res = pattern179 (x1, 
E_PSImode);
      if (res >= 0)
        return res + 8; /* [8, 11] */
      return -1;

    case E_SImode:
      res = pattern179 (x1, 
E_SImode);
      if (res >= 0)
        return res + 12; /* [12, 15] */
      return -1;

    default:
      return -1;
    }
}

int
pattern187 (rtx x1, machine_mode i1, unsigned int i2, unsigned int i3)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 3);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != i3
      || GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XVECEXP (x1, 0, 4);
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG
      || REGNO (x5) != i2
      || GET_MODE (x5) != i1)
    return -1;
  return 0;
}

int
pattern190 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  operands[1] = x3;
  if (!register_operand (operands[1], E_QImode)
      || !register_operand (operands[0], E_QImode)
      || GET_MODE (x1) != E_QImode
      || !register_operand (operands[3], E_QImode)
      || GET_MODE (x2) != E_QImode)
    return -1;
  x4 = XEXP (x2, 1);
  operands[2] = x4;
  return 0;
}

int
pattern193 (rtx x1, int *pnum_clobbers, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !pseudo_register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !pseudo_register_operand (operands[1], i1))
    return -1;
  return 0;
}

int
pattern198 (rtx x1, machine_mode i1, unsigned int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (REGNO (x2) != i2
      || GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  return 0;
}

int
pattern202 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode
          || !register_operand (operands[1], E_HImode))
        return -1;
      return 0;

    case E_PSImode:
      if (!register_operand (operands[0], E_PSImode)
          || GET_MODE (x1) != E_PSImode
          || !register_operand (operands[1], E_PSImode))
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern209 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 36
      || GET_MODE (x3) != E_CCmode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 0);
  operands[0] = x5;
  if (!register_operand (operands[0], i1))
    return -1;
  return 0;
}

int
pattern215 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[1] = x2;
  x3 = XEXP (x1, 1);
  operands[2] = x3;
  switch (GET_MODE (x1))
    {
    case E_HImode:
      if (!register_operand (operands[1], E_HImode)
          || !const_0_to_15_operand (operands[2], E_QImode))
        return -1;
      return 0;

    case E_PSImode:
      if (!register_operand (operands[1], E_PSImode)
          || !const_0_to_23_operand (operands[2], E_QImode))
        return -1;
      return 1;

    case E_SImode:
      if (!register_operand (operands[1], E_SImode)
          || !const_0_to_31_operand (operands[2], E_QImode))
        return -1;
      return 2;

    default:
      return -1;
    }
}

int
pattern226 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != SET)
    return -1;
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  if (GET_CODE (x4) != CLOBBER)
    return -1;
  x5 = XEXP (x4, 0);
  if (GET_CODE (x5) != REG)
    return -1;
  x6 = XVECEXP (x1, 0, 3);
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG)
    return -1;
  x8 = XVECEXP (x1, 0, 4);
  x9 = XEXP (x8, 0);
  if (GET_CODE (x9) != REG)
    return -1;
  return 0;
}

int
pattern232 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  x3 = XEXP (x2, 0);
  if (GET_MODE (x3) != E_HImode
      || !register_operand (operands[0], E_HImode)
      || GET_MODE (x1) != E_HImode
      || GET_MODE (x2) != E_HImode)
    return -1;
  x4 = XEXP (x3, 0);
  operands[1] = x4;
  if (!register_operand (operands[1], E_QImode)
      || !register_operand (operands[3], E_HImode))
    return -1;
  return 0;
}

int
pattern237 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != 18)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_CODE (x4) != REG
      || REGNO (x4) != 18)
    return -1;
  x5 = XEXP (x2, 1);
  switch (GET_CODE (x5))
    {
    case REG:
      if (REGNO (x5) != 10)
        return -1;
      switch (GET_MODE (x4))
        {
        case E_DQmode:
          if (GET_MODE (x2) != E_DQmode
              || GET_MODE (x3) != E_DQmode
              || GET_MODE (x5) != E_DQmode)
            return -1;
          return 0;

        case E_DAmode:
          if (GET_MODE (x2) != E_DAmode
              || GET_MODE (x3) != E_DAmode
              || GET_MODE (x5) != E_DAmode)
            return -1;
          return 1;

        case E_TAmode:
          if (GET_MODE (x2) != E_TAmode
              || GET_MODE (x3) != E_TAmode
              || GET_MODE (x5) != E_TAmode)
            return -1;
          return 2;

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
      operands[0] = x5;
      switch (GET_MODE (x4))
        {
        case E_DQmode:
          if (GET_MODE (x2) != E_DQmode
              || GET_MODE (x3) != E_DQmode
              || !const_operand (operands[0], E_DQmode))
            return -1;
          return 3;

        case E_DAmode:
          if (GET_MODE (x2) != E_DAmode
              || GET_MODE (x3) != E_DAmode
              || !const_operand (operands[0], E_DAmode))
            return -1;
          return 4;

        case E_TAmode:
          if (GET_MODE (x2) != E_TAmode
              || GET_MODE (x3) != E_TAmode
              || !const_operand (operands[0], E_TAmode))
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern247 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XVECEXP (x2, 0, 0);
  operands[0] = x3;
  if (!const_int_operand (operands[0], E_SImode))
    return -1;
  x4 = XVECEXP (x1, 0, 1);
  x5 = XEXP (x4, 0);
  operands[1] = x5;
  x6 = XVECEXP (x1, 0, 2);
  x7 = XEXP (x6, 0);
  operands[2] = x7;
  if (!scratch_operand (operands[2], E_QImode))
    return -1;
  x8 = XVECEXP (x1, 0, 3);
  x9 = XEXP (x8, 0);
  operands[3] = x9;
  if (!scratch_operand (operands[3], E_QImode))
    return -1;
  x10 = XVECEXP (x1, 0, 4);
  x11 = XEXP (x10, 0);
  operands[4] = x11;
  if (!scratch_operand (operands[4], E_QImode))
    return -1;
  x12 = XEXP (x4, 1);
  x13 = XVECEXP (x12, 0, 0);
  if (!rtx_equal_p (x13, operands[1]))
    return -1;
  return 0;
}

int
pattern257 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  operands[2] = x2;
  switch (GET_MODE (operands[1]))
    {
    case E_HImode:
      if (!register_operand (operands[1], E_HImode)
          || GET_MODE (x1) != E_HImode
          || !register_operand (operands[2], E_QImode))
        return -1;
      return 0;

    case E_PSImode:
      if (!register_operand (operands[1], E_PSImode)
          || GET_MODE (x1) != E_PSImode)
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_QImode:
          if (!register_operand (operands[2], E_QImode))
            return -1;
          return 1;

        case E_HImode:
          if (!register_operand (operands[2], E_HImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_SImode:
      if (!register_operand (operands[1], E_SImode)
          || GET_MODE (x1) != E_SImode)
        return -1;
      switch (GET_MODE (operands[2]))
        {
        case E_QImode:
          if (!register_operand (operands[2], E_QImode))
            return -1;
          return 3;

        case E_HImode:
          if (!register_operand (operands[2], E_HImode))
            return -1;
          return 4;

        case E_PSImode:
          if (!register_operand (operands[2], E_PSImode))
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern271 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (REGNO (x3) != 26
      || GET_MODE (x3) != E_HImode)
    return -1;
  x4 = XVECEXP (x1, 0, 2);
  x5 = XEXP (x4, 0);
  if (REGNO (x5) != 18
      || GET_MODE (x5) != E_DImode)
    return -1;
  x6 = XVECEXP (x1, 0, 0);
  x7 = XEXP (x6, 0);
  operands[0] = x7;
  if (!pseudo_register_operand (operands[0], E_SImode))
    return -1;
  x8 = XEXP (x6, 1);
  if (GET_MODE (x8) != E_SImode)
    return -1;
  x9 = XEXP (x8, 0);
  x10 = XEXP (x9, 0);
  operands[1] = x10;
  x11 = XEXP (x8, 1);
  switch (GET_CODE (x11))
    {
    case CONST_INT:
    case REG:
    case SUBREG:
      operands[2] = x11;
      return pattern268 (); /* [-1, 1] */

    case SIGN_EXTEND:
      if (GET_MODE (x11) != E_SImode)
        return -1;
      x12 = XEXP (x11, 0);
      res = pattern270 (x12);
      if (res >= 0)
        return res + 2; /* [2, 5] */
      return -1;

    case ZERO_EXTEND:
      if (GET_MODE (x11) != E_SImode)
        return -1;
      x12 = XEXP (x11, 0);
      res = pattern270 (x12);
      if (res >= 0)
        return res + 6; /* [6, 9] */
      return -1;

    default:
      return -1;
    }
}

int
pattern288 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 0);
  x4 = XEXP (x3, 0);
  operands[0] = x4;
  if (!register_operand (operands[0], E_HImode))
    return -1;
  x5 = XVECEXP (x1, 0, 1);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XVECEXP (x1, 0, 2);
  x8 = XEXP (x7, 0);
  operands[2] = x8;
  if (!const_int_operand (operands[2], E_HImode))
    return -1;
  x9 = XVECEXP (x1, 0, 3);
  x10 = XEXP (x9, 0);
  operands[3] = x10;
  if (!scratch_operand (operands[3], E_HImode))
    return -1;
  x11 = XVECEXP (x1, 0, 4);
  x12 = XEXP (x11, 0);
  operands[4] = x12;
  switch (GET_MODE (operands[1]))
    {
    case E_QImode:
      if (!register_operand (operands[1], E_QImode)
          || !scratch_operand (operands[4], E_QImode))
        return -1;
      return 0;

    case E_HImode:
      if (!register_operand (operands[1], E_HImode)
          || !scratch_operand (operands[4], E_HImode))
        return -1;
      return 1;

    default:
      return -1;
    }
}

int
pattern296 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  if (GET_MODE (x2) != E_DImode)
    return -1;
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != REG
      || REGNO (x3) != 26
      || GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XEXP (x1, 0);
  if (GET_MODE (x4) != E_DImode)
    return -1;
  return 0;
}

int
pattern299 (rtx x1, machine_mode i1, unsigned int i2)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (REGNO (x2) != i2
      || GET_MODE (x2) != i1)
    return -1;
  x3 = XEXP (x1, 1);
  if (GET_MODE (x3) != i1)
    return -1;
  x4 = XEXP (x3, 0);
  if (GET_MODE (x4) != i1)
    return -1;
  return 0;
}

int
pattern305 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 0);
  if (REGNO (x5) != 18
      || GET_MODE (x5) != E_SImode)
    return -1;
  x6 = XEXP (x3, 1);
  if (GET_CODE (x6) != SIGN_EXTEND
      || GET_MODE (x6) != E_DImode)
    return -1;
  x7 = XEXP (x6, 0);
  if (GET_CODE (x7) != REG
      || REGNO (x7) != 22
      || GET_MODE (x7) != E_SImode)
    return -1;
  x8 = XEXP (x2, 0);
  if (GET_CODE (x8) != REG
      || REGNO (x8) != 18
      || GET_MODE (x8) != E_DImode)
    return -1;
  x9 = XVECEXP (x1, 0, 2);
  x10 = XEXP (x9, 0);
  if (REGNO (x10) != 30
      || GET_MODE (x10) != E_HImode
      || GET_MODE (x3) != E_DImode
      || GET_MODE (x4) != E_DImode)
    return -1;
  return 0;
}

int
pattern317 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  int res ATTRIBUTE_UNUSED;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      if (!register_operand (operands[0], E_HImode)
          || GET_MODE (x1) != E_HImode
          || !register_operand (operands[1], E_HImode))
        return -1;
      return 0;

    case E_HQmode:
      if (!register_operand (operands[0], E_HQmode)
          || GET_MODE (x1) != E_HQmode
          || !register_operand (operands[1], E_HQmode))
        return -1;
      return 1;

    case E_UHQmode:
      if (!register_operand (operands[0], E_UHQmode)
          || GET_MODE (x1) != E_UHQmode
          || !register_operand (operands[1], E_UHQmode))
        return -1;
      return 2;

    case E_HAmode:
      if (!register_operand (operands[0], E_HAmode)
          || GET_MODE (x1) != E_HAmode
          || !register_operand (operands[1], E_HAmode))
        return -1;
      return 3;

    case E_UHAmode:
      if (!register_operand (operands[0], E_UHAmode)
          || GET_MODE (x1) != E_UHAmode
          || !register_operand (operands[1], E_UHAmode))
        return -1;
      return 4;

    case E_SImode:
      if (!register_operand (operands[0], E_SImode)
          || GET_MODE (x1) != E_SImode
          || !register_operand (operands[1], E_SImode))
        return -1;
      return 5;

    case E_SQmode:
      if (!register_operand (operands[0], E_SQmode)
          || GET_MODE (x1) != E_SQmode
          || !register_operand (operands[1], E_SQmode))
        return -1;
      return 6;

    case E_USQmode:
      if (!register_operand (operands[0], E_USQmode)
          || GET_MODE (x1) != E_USQmode
          || !register_operand (operands[1], E_USQmode))
        return -1;
      return 7;

    case E_SAmode:
      if (!register_operand (operands[0], E_SAmode)
          || GET_MODE (x1) != E_SAmode
          || !register_operand (operands[1], E_SAmode))
        return -1;
      return 8;

    case E_USAmode:
      if (!register_operand (operands[0], E_USAmode)
          || GET_MODE (x1) != E_USAmode
          || !register_operand (operands[1], E_USAmode))
        return -1;
      return 9;

    default:
      return -1;
    }
}

int
pattern339 (rtx x1, int *pnum_clobbers, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  if (pnum_clobbers == NULL
      || !register_operand (operands[3], i1))
    return -1;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  x5 = XEXP (x4, 1);
  operands[1] = x5;
  if (!const_int_operand (operands[1], i1)
      || !register_operand (operands[0], i1))
    return -1;
  x6 = XVECEXP (x1, 0, 1);
  x7 = XEXP (x6, 1);
  if (GET_MODE (x7) != i1)
    return -1;
  x8 = XEXP (x7, 0);
  operands[4] = x8;
  if (!register_operand (operands[4], i1))
    return -1;
  x9 = XEXP (x7, 1);
  operands[5] = x9;
  if (!const_int_operand (operands[5], i1))
    return -1;
  return 0;
}

int
pattern344 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  if (GET_CODE (x3) != i1)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 0);
  operands[1] = x6;
  x7 = XEXP (x5, 1);
  operands[2] = x7;
  return pattern341 (x1); /* [-1, 2] */
}

int
pattern351 (rtx x1, rtx_code i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  if (GET_CODE (x4) != i1)
    return -1;
  x5 = XVECEXP (x1, 0, 0);
  x6 = XEXP (x5, 1);
  x7 = XEXP (x6, 0);
  x8 = XEXP (x7, 1);
  x9 = XEXP (x8, 0);
  operands[4] = x9;
  x10 = XEXP (x4, 0);
  operands[2] = x10;
  switch (GET_MODE (x7))
    {
    case E_HImode:
      if (!register_operand (operands[3], E_HImode)
          || GET_MODE (x8) != E_HImode
          || !register_operand (operands[4], E_QImode)
          || !register_operand (operands[0], E_HImode)
          || GET_MODE (x3) != E_HImode
          || !register_operand (operands[1], E_HImode)
          || GET_MODE (x4) != E_HImode
          || !register_operand (operands[2], E_QImode))
        return -1;
      return 0;

    case E_PSImode:
      if (!register_operand (operands[3], E_PSImode)
          || GET_MODE (x8) != E_PSImode
          || !register_operand (operands[0], E_PSImode)
          || GET_MODE (x3) != E_PSImode
          || !register_operand (operands[1], E_PSImode)
          || GET_MODE (x4) != E_PSImode)
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_QImode:
          if (!register_operand (operands[4], E_QImode)
              || !register_operand (operands[2], E_QImode))
            return -1;
          return 1;

        case E_HImode:
          if (!register_operand (operands[4], E_HImode)
              || !register_operand (operands[2], E_HImode))
            return -1;
          return 2;

        default:
          return -1;
        }

    case E_SImode:
      if (!register_operand (operands[3], E_SImode)
          || GET_MODE (x8) != E_SImode
          || !register_operand (operands[0], E_SImode)
          || GET_MODE (x3) != E_SImode
          || !register_operand (operands[1], E_SImode)
          || GET_MODE (x4) != E_SImode)
        return -1;
      switch (GET_MODE (operands[4]))
        {
        case E_QImode:
          if (!register_operand (operands[4], E_QImode)
              || !register_operand (operands[2], E_QImode))
            return -1;
          return 3;

        case E_HImode:
          if (!register_operand (operands[4], E_HImode)
              || !register_operand (operands[2], E_HImode))
            return -1;
          return 4;

        case E_PSImode:
          if (!register_operand (operands[4], E_PSImode)
              || !register_operand (operands[2], E_PSImode))
            return -1;
          return 5;

        default:
          return -1;
        }

    default:
      return -1;
    }
}

int
pattern381 (rtx x1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  x3 = XEXP (x2, 0);
  if (GET_CODE (x3) != SCRATCH
      || GET_MODE (x3) != E_QImode)
    return -1;
  x4 = XVECEXP (x1, 0, 0);
  x5 = XEXP (x4, 1);
  x6 = XEXP (x5, 1);
  operands[3] = x6;
  x7 = XEXP (x5, 0);
  if (!rtx_equal_p (x7, operands[0]))
    return -1;
  x8 = PATTERN (peep2_next_insn (2));
  if (GET_CODE (x8) != SET)
    return -1;
  x9 = XEXP (x8, 1);
  if (GET_CODE (x9) != IF_THEN_ELSE)
    return -1;
  x10 = XEXP (x9, 1);
  if (GET_CODE (x10) != LABEL_REF)
    return -1;
  x11 = XEXP (x9, 2);
  if (GET_CODE (x11) != PC)
    return -1;
  x12 = XEXP (x8, 0);
  if (GET_CODE (x12) != PC)
    return -1;
  x13 = XEXP (x10, 0);
  operands[2] = x13;
  return 0;
}

int
pattern392 (rtx x1, machine_mode i1)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4;
  int res ATTRIBUTE_UNUSED;
  if (!register_operand (operands[0], i1)
      || GET_MODE (x1) != i1
      || !register_operand (operands[1], i1))
    return -1;
  x2 = PATTERN (peep2_next_insn (2));
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 0);
  return pattern388 (x4, 
i1); /* [-1, 5] */
}

 int
recog_1 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 0);
  if (GET_CODE (x2) == REG
      && REGNO (x2) == 22)
    {
      x3 = XEXP (x1, 1);
      operands[0] = x3;
      switch (pattern159 (x2))
        {
        case 0:
          if (
#line 572 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))))
            return 5; /* load_qi_libgcc */
          if (pnum_clobbers != NULL
              && 
#line 585 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
            {
              *pnum_clobbers = 1;
              return 20; /* *load_qi_libgcc */
            }
          break;

        case 1:
          if (
#line 572 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))))
            return 6; /* load_qq_libgcc */
          if (pnum_clobbers != NULL
              && 
#line 585 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
            {
              *pnum_clobbers = 1;
              return 21; /* *load_qq_libgcc */
            }
          break;

        case 2:
          if (
#line 572 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))))
            return 7; /* load_uqq_libgcc */
          if (pnum_clobbers != NULL
              && 
#line 585 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
            {
              *pnum_clobbers = 1;
              return 22; /* *load_uqq_libgcc */
            }
          break;

        case 3:
          if (
#line 572 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))))
            return 8; /* load_hi_libgcc */
          if (pnum_clobbers != NULL
              && 
#line 585 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
            {
              *pnum_clobbers = 1;
              return 23; /* *load_hi_libgcc */
            }
          break;

        case 4:
          if (
#line 572 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))))
            return 9; /* load_hq_libgcc */
          if (pnum_clobbers != NULL
              && 
#line 585 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
            {
              *pnum_clobbers = 1;
              return 24; /* *load_hq_libgcc */
            }
          break;

        case 5:
          if (
#line 572 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))))
            return 10; /* load_uhq_libgcc */
          if (pnum_clobbers != NULL
              && 
#line 585 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
            {
              *pnum_clobbers = 1;
              return 25; /* *load_uhq_libgcc */
            }
          break;

        case 6:
          if (
#line 572 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))))
            return 11; /* load_ha_libgcc */
          if (pnum_clobbers != NULL
              && 
#line 585 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
            {
              *pnum_clobbers = 1;
              return 26; /* *load_ha_libgcc */
            }
          break;

        case 7:
          if (
#line 572 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))))
            return 12; /* load_uha_libgcc */
          if (pnum_clobbers != NULL
              && 
#line 585 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
            {
              *pnum_clobbers = 1;
              return 27; /* *load_uha_libgcc */
            }
          break;

        case 8:
          if (
#line 572 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))))
            return 13; /* load_si_libgcc */
          if (pnum_clobbers != NULL
              && 
#line 585 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
            {
              *pnum_clobbers = 1;
              return 28; /* *load_si_libgcc */
            }
          break;

        case 9:
          if (
#line 572 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))))
            return 14; /* load_sq_libgcc */
          if (pnum_clobbers != NULL
              && 
#line 585 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
            {
              *pnum_clobbers = 1;
              return 29; /* *load_sq_libgcc */
            }
          break;

        case 10:
          if (
#line 572 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))))
            return 15; /* load_usq_libgcc */
          if (pnum_clobbers != NULL
              && 
#line 585 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
            {
              *pnum_clobbers = 1;
              return 30; /* *load_usq_libgcc */
            }
          break;

        case 11:
          if (
#line 572 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))))
            return 16; /* load_sa_libgcc */
          if (pnum_clobbers != NULL
              && 
#line 585 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
            {
              *pnum_clobbers = 1;
              return 31; /* *load_sa_libgcc */
            }
          break;

        case 12:
          if (
#line 572 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))))
            return 17; /* load_usa_libgcc */
          if (pnum_clobbers != NULL
              && 
#line 585 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
            {
              *pnum_clobbers = 1;
              return 32; /* *load_usa_libgcc */
            }
          break;

        case 13:
          if (
#line 572 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))))
            return 18; /* load_sf_libgcc */
          if (pnum_clobbers != NULL
              && 
#line 585 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
            {
              *pnum_clobbers = 1;
              return 33; /* *load_sf_libgcc */
            }
          break;

        case 14:
          if (
#line 572 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))))
            return 19; /* load_psi_libgcc */
          if (pnum_clobbers != NULL
              && 
#line 585 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avr_load_libgcc_p (operands[0])
   && REG_P (XEXP (operands[0], 0))
   && REG_Z == REGNO (XEXP (operands[0], 0))
   && reload_completed))
            {
              *pnum_clobbers = 1;
              return 34; /* *load_psi_libgcc */
            }
          break;

        default:
          break;
        }
    }
  if (pnum_clobbers == NULL)
    return -1;
  operands[0] = x2;
  x3 = XEXP (x1, 1);
  switch (pattern122 (x3))
    {
    case 0:
      if (!
#line 599 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
        return -1;
      *pnum_clobbers = 1;
      return 35; /* fxmovqi_A */

    case 1:
      if (!
#line 599 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
        return -1;
      *pnum_clobbers = 1;
      return 36; /* fxmovqq_A */

    case 2:
      if (!
#line 599 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
        return -1;
      *pnum_clobbers = 1;
      return 37; /* fxmovuqq_A */

    case 3:
      if (!
#line 599 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
        return -1;
      *pnum_clobbers = 1;
      return 38; /* fxmovhi_A */

    case 4:
      if (!
#line 599 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
        return -1;
      *pnum_clobbers = 1;
      return 39; /* fxmovhq_A */

    case 5:
      if (!
#line 599 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
        return -1;
      *pnum_clobbers = 1;
      return 40; /* fxmovuhq_A */

    case 6:
      if (!
#line 599 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
        return -1;
      *pnum_clobbers = 1;
      return 41; /* fxmovha_A */

    case 7:
      if (!
#line 599 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
        return -1;
      *pnum_clobbers = 1;
      return 42; /* fxmovuha_A */

    case 8:
      if (!
#line 599 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
        return -1;
      *pnum_clobbers = 1;
      return 43; /* fxmovsi_A */

    case 9:
      if (!
#line 599 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
        return -1;
      *pnum_clobbers = 1;
      return 44; /* fxmovsq_A */

    case 10:
      if (!
#line 599 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
        return -1;
      *pnum_clobbers = 1;
      return 45; /* fxmovusq_A */

    case 11:
      if (!
#line 599 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
        return -1;
      *pnum_clobbers = 1;
      return 46; /* fxmovsa_A */

    case 12:
      if (!
#line 599 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
        return -1;
      *pnum_clobbers = 1;
      return 47; /* fxmovusa_A */

    case 13:
      if (!
#line 599 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
        return -1;
      *pnum_clobbers = 1;
      return 48; /* fxmovsf_A */

    case 14:
      if (!
#line 599 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(can_create_pseudo_p()
   && REG_P (XEXP (operands[1], 0))
   && (avr_load_libgcc_insn_p (insn, ADDR_SPACE_MEMX, false)
       || avr_load_libgcc_insn_p (insn, ADDR_SPACE_FLASHX, false))))
        return -1;
      *pnum_clobbers = 1;
      return 49; /* fxmovpsi_A */

    default:
      return -1;
    }
}

 int
recog_26 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  switch (XVECLEN (x2, 0))
    {
    case 3:
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      switch (pattern68 (x2))
        {
        case 0:
          return 172; /* *strlenhi_split */

        case 1:
          return 1011; /* insert_bits */

        case 2:
          return 3126; /* roundqq3_const */

        case 3:
          return 3127; /* roundhq3_const */

        case 4:
          return 3128; /* roundha3_const */

        case 5:
          return 3129; /* roundsa3_const */

        case 6:
          return 3130; /* roundsq3_const */

        case 7:
          return 3131; /* rounduqq3_const */

        case 8:
          return 3132; /* rounduhq3_const */

        case 9:
          return 3133; /* rounduha3_const */

        case 10:
          return 3134; /* roundusa3_const */

        case 11:
          return 3135; /* roundusq3_const */

        default:
          return -1;
        }

    case 2:
      switch (XINT (x2, 1))
        {
        case 4:
          if (GET_MODE (x2) != E_HImode)
            return -1;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (register_operand (operands[0], E_HImode))
            {
              x4 = XVECEXP (x2, 0, 0);
              operands[1] = x4;
              if (register_operand (operands[1], E_QImode))
                {
                  x5 = XVECEXP (x2, 0, 1);
                  operands[2] = x5;
                  if (register_operand (operands[2], E_QImode))
                    {
                      if (
#line 9703 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
                        return 1057; /* fmul_insn */
                      if (pnum_clobbers != NULL
                          && 
#line 9718 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                        {
                          *pnum_clobbers = 1;
                          return 1058; /* *fmul_insn */
                        }
                    }
                }
            }
          if (pnum_clobbers == NULL
              || pattern160 (x1) != 0)
            return -1;
          if (
#line 9729 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(!AVR_HAVE_MUL))
            {
              *pnum_clobbers = 1;
              return 1059; /* *fmul.call_split */
            }
          if (!
#line 9744 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(!AVR_HAVE_MUL && reload_completed))
            return -1;
          *pnum_clobbers = 2;
          return 1060; /* *fmul.call */

        case 5:
          if (GET_MODE (x2) != E_HImode)
            return -1;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (register_operand (operands[0], E_HImode))
            {
              x4 = XVECEXP (x2, 0, 0);
              operands[1] = x4;
              if (register_operand (operands[1], E_QImode))
                {
                  x5 = XVECEXP (x2, 0, 1);
                  operands[2] = x5;
                  if (register_operand (operands[2], E_QImode))
                    {
                      if (
#line 9775 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
                        return 1061; /* fmuls_insn */
                      if (pnum_clobbers != NULL
                          && 
#line 9790 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                        {
                          *pnum_clobbers = 1;
                          return 1062; /* *fmuls_insn */
                        }
                    }
                }
            }
          if (pnum_clobbers == NULL
              || pattern160 (x1) != 0)
            return -1;
          if (
#line 9801 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(!AVR_HAVE_MUL))
            {
              *pnum_clobbers = 1;
              return 1063; /* *fmuls.call_split */
            }
          if (!
#line 9816 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(!AVR_HAVE_MUL && reload_completed))
            return -1;
          *pnum_clobbers = 2;
          return 1064; /* *fmuls.call */

        case 6:
          if (GET_MODE (x2) != E_HImode)
            return -1;
          x3 = XEXP (x1, 0);
          operands[0] = x3;
          if (register_operand (operands[0], E_HImode))
            {
              x4 = XVECEXP (x2, 0, 0);
              operands[1] = x4;
              if (register_operand (operands[1], E_QImode))
                {
                  x5 = XVECEXP (x2, 0, 1);
                  operands[2] = x5;
                  if (register_operand (operands[2], E_QImode))
                    {
                      if (
#line 9847 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
                        return 1065; /* fmulsu_insn */
                      if (pnum_clobbers != NULL
                          && 
#line 9862 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                        {
                          *pnum_clobbers = 1;
                          return 1066; /* *fmulsu_insn */
                        }
                    }
                }
            }
          if (pnum_clobbers == NULL
              || pattern160 (x1) != 0)
            return -1;
          if (
#line 9873 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(!AVR_HAVE_MUL))
            {
              *pnum_clobbers = 1;
              return 1067; /* *fmulsu.call_split */
            }
          if (!
#line 9888 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(!AVR_HAVE_MUL && reload_completed))
            return -1;
          *pnum_clobbers = 2;
          return 1068; /* *fmulsu.call */

        case 8:
          if (pnum_clobbers == NULL)
            return -1;
          x4 = XVECEXP (x2, 0, 0);
          if (GET_CODE (x4) != REG)
            return -1;
          x5 = XVECEXP (x2, 0, 1);
          if (GET_CODE (x5) != REG
              || REGNO (x5) != 24
              || GET_MODE (x5) != E_QImode)
            return -1;
          x3 = XEXP (x1, 0);
          if (GET_CODE (x3) != REG)
            return -1;
          switch (REGNO (x4))
            {
            case 22:
              if (REGNO (x3) != 24)
                return -1;
              switch (GET_MODE (x3))
                {
                case E_QQmode:
                  if (GET_MODE (x2) != E_QQmode
                      || GET_MODE (x4) != E_QQmode)
                    return -1;
                  *pnum_clobbers = 1;
                  return 3146; /* *roundqq3.libgcc_split */

                case E_UQQmode:
                  if (GET_MODE (x2) != E_UQQmode
                      || GET_MODE (x4) != E_UQQmode)
                    return -1;
                  *pnum_clobbers = 1;
                  return 3147; /* *rounduqq3.libgcc_split */

                case E_HQmode:
                  if (GET_MODE (x2) != E_HQmode
                      || GET_MODE (x4) != E_HQmode)
                    return -1;
                  *pnum_clobbers = 1;
                  return 3150; /* *roundhq3.libgcc_split */

                case E_UHQmode:
                  if (GET_MODE (x2) != E_UHQmode
                      || GET_MODE (x4) != E_UHQmode)
                    return -1;
                  *pnum_clobbers = 1;
                  return 3151; /* *rounduhq3.libgcc_split */

                case E_HAmode:
                  if (GET_MODE (x2) != E_HAmode
                      || GET_MODE (x4) != E_HAmode)
                    return -1;
                  *pnum_clobbers = 1;
                  return 3152; /* *roundha3.libgcc_split */

                case E_UHAmode:
                  if (GET_MODE (x2) != E_UHAmode
                      || GET_MODE (x4) != E_UHAmode)
                    return -1;
                  *pnum_clobbers = 1;
                  return 3153; /* *rounduha3.libgcc_split */

                default:
                  return -1;
                }

            case 18:
              if (REGNO (x3) != 22)
                return -1;
              switch (GET_MODE (x3))
                {
                case E_SQmode:
                  if (GET_MODE (x2) != E_SQmode
                      || GET_MODE (x4) != E_SQmode)
                    return -1;
                  *pnum_clobbers = 1;
                  return 3158; /* *roundsq3.libgcc_split */

                case E_USQmode:
                  if (GET_MODE (x2) != E_USQmode
                      || GET_MODE (x4) != E_USQmode)
                    return -1;
                  *pnum_clobbers = 1;
                  return 3159; /* *roundusq3.libgcc_split */

                case E_SAmode:
                  if (GET_MODE (x2) != E_SAmode
                      || GET_MODE (x4) != E_SAmode)
                    return -1;
                  *pnum_clobbers = 1;
                  return 3160; /* *roundsa3.libgcc_split */

                case E_USAmode:
                  if (GET_MODE (x2) != E_USAmode
                      || GET_MODE (x4) != E_USAmode)
                    return -1;
                  *pnum_clobbers = 1;
                  return 3161; /* *roundusa3.libgcc_split */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        default:
          return -1;
        }

    case 1:
      if (pnum_clobbers == NULL
          || XINT (x2, 1) != 3
          || GET_MODE (x2) != E_QImode)
        return -1;
      x4 = XVECEXP (x2, 0, 0);
      if (GET_CODE (x4) != IOR
          || GET_MODE (x4) != E_QImode)
        return -1;
      x6 = XEXP (x4, 0);
      if (GET_CODE (x6) != ASHIFT
          || GET_MODE (x6) != E_QImode)
        return -1;
      x3 = XEXP (x1, 0);
      operands[0] = x3;
      if (!register_operand (operands[0], E_QImode))
        return -1;
      x7 = XEXP (x6, 0);
      operands[1] = x7;
      if (!register_operand (operands[1], E_QImode))
        return -1;
      x8 = XEXP (x6, 1);
      operands[2] = x8;
      if (!const_0_to_7_operand (operands[2], E_QImode))
        return -1;
      x9 = XEXP (x4, 1);
      operands[3] = x9;
      if (!register_operand (operands[3], E_QImode)
          || !
#line 11130 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits))
        return -1;
      *pnum_clobbers = 1;
      return 1495; /* *nzb=1.ior.ashift */

    default:
      return -1;
    }
}

 int
recog_31 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7;
  int res ATTRIBUTE_UNUSED;
  x2 = XEXP (x1, 1);
  x3 = XEXP (x2, 0);
  switch (GET_CODE (x3))
    {
    case REG:
    case SUBREG:
      operands[1] = x3;
      switch (pattern75 (x1, pnum_clobbers))
        {
        case 0:
          return 618; /* andqi3 */

        case 1:
          *pnum_clobbers = 1;
          return 620; /* andhi3 */

        case 2:
          *pnum_clobbers = 1;
          return 622; /* andpsi3 */

        case 3:
          *pnum_clobbers = 1;
          return 624; /* andsi3 */

        default:
          break;
        }
      if (GET_CODE (x3) != SUBREG
          || maybe_ne (SUBREG_BYTE (x3), 0)
          || GET_MODE (x3) != E_QImode)
        return -1;
      x4 = XEXP (x2, 1);
      if (x4 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      switch (pattern216 (x2))
        {
        case 0:
          if (!
#line 10632 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(! reload_completed))
            return -1;
          return 1210; /* *extract.subreg.bit */

        case 1:
          if (!
#line 10632 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(! reload_completed))
            return -1;
          return 1212; /* *extract.subreg.bit */

        case 2:
          if (!
#line 10632 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(! reload_completed))
            return -1;
          return 1214; /* *extract.subreg.bit */

        case 3:
          if (!
#line 10632 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(! reload_completed))
            return -1;
          return 1211; /* *extract.subreg.bit */

        case 4:
          if (!
#line 10632 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(! reload_completed))
            return -1;
          return 1213; /* *extract.subreg.bit */

        case 5:
          if (!
#line 10632 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(! reload_completed))
            return -1;
          return 1215; /* *extract.subreg.bit */

        default:
          return -1;
        }

    case MEM:
      if (pattern40 (x1) != 0
          || !single_zero_operand (operands[1], E_QImode))
        return -1;
      x6 = XEXP (x3, 0);
      if (!rtx_equal_p (x6, operands[0]))
        return -1;
      return 980; /* *cbi */

    case LSHIFTRT:
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      switch (pattern77 (x2))
        {
        case 0:
          return 1182; /* *insv.any_shift.qi_split */

        case 1:
          return 1185; /* *insv.any_shift.hi_split */

        case 2:
          return 1188; /* *insv.any_shift.psi_split */

        case 3:
          return 1191; /* *insv.any_shift.si_split */

        case 4:
          if (!
#line 10988 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits
   && !reload_completed
   && avr_nonzero_bits_lsr_operands_p (AND, operands)))
            return -1;
          return 1481; /* *nzb=1.and.lsr_split */

        case 5:
          if (!
#line 11038 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits
   && !reload_completed
   && INTVAL (operands[2]) == exact_log2 (0xff & INTVAL (operands[4]))
   && avr_nonzero_bits_lsr_operands_p (AND, operands)))
            return -1;
          return 1487; /* *nzb=1.and.lsr.not_split */

        default:
          return -1;
        }

    case ASHIFTRT:
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      switch (pattern78 (x2))
        {
        case 0:
          return 1183; /* *insv.any_shift.qi_split */

        case 1:
          return 1186; /* *insv.any_shift.hi_split */

        case 2:
          return 1189; /* *insv.any_shift.psi_split */

        case 3:
          return 1192; /* *insv.any_shift.si_split */

        default:
          return -1;
        }

    case ASHIFT:
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      switch (pattern78 (x2))
        {
        case 0:
          return 1184; /* *insv.any_shift.qi_split */

        case 1:
          return 1187; /* *insv.any_shift.hi_split */

        case 2:
          return 1190; /* *insv.any_shift.psi_split */

        case 3:
          return 1193; /* *insv.any_shift.si_split */

        default:
          return -1;
        }

    case SIGN_EXTRACT:
      x7 = XEXP (x3, 1);
      if (x7 != const_int_rtx[MAX_SAVED_CONST_INT + 1])
        return -1;
      x5 = XEXP (x1, 0);
      operands[0] = x5;
      switch (pattern136 (x2))
        {
        case 0:
          if (!
#line 10914 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1457; /* *map.and1-to-skip.qi */

        case 1:
          if (!
#line 10914 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1461; /* *map.and1-to-skip.qi */

        case 2:
          if (!
#line 10914 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1465; /* *map.and1-to-skip.qi */

        case 3:
          if (!
#line 10914 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1469; /* *map.and1-to-skip.qi */

        case 4:
          if (!
#line 10914 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1458; /* *map.and1-to-skip.hi */

        case 5:
          if (!
#line 10914 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1462; /* *map.and1-to-skip.hi */

        case 6:
          if (!
#line 10914 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1466; /* *map.and1-to-skip.hi */

        case 7:
          if (!
#line 10914 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1470; /* *map.and1-to-skip.hi */

        case 8:
          if (!
#line 10914 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1459; /* *map.and1-to-skip.psi */

        case 9:
          if (!
#line 10914 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1463; /* *map.and1-to-skip.psi */

        case 10:
          if (!
#line 10914 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1467; /* *map.and1-to-skip.psi */

        case 11:
          if (!
#line 10914 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1471; /* *map.and1-to-skip.psi */

        case 12:
          if (!
#line 10914 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1460; /* *map.and1-to-skip.si */

        case 13:
          if (!
#line 10914 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1464; /* *map.and1-to-skip.si */

        case 14:
          if (!
#line 10914 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1468; /* *map.and1-to-skip.si */

        case 15:
          if (!
#line 10914 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! reload_completed))
            return -1;
          return 1472; /* *map.and1-to-skip.si */

        default:
          return -1;
        }

    case ZERO_EXTRACT:
      switch (pattern42 (x1))
        {
        case 0:
          if (!
#line 10943 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits
   && !reload_completed
   && (AND == IOR || AND == XOR
       || nonzero_bits (operands[3], QImode) == 1)))
            return -1;
          return 1475; /* *nzb=1.and.zerox_split */

        case 1:
          if (!
#line 11012 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits
   && !reload_completed
   && INTVAL (operands[2]) == exact_log2 (0xff & INTVAL (operands[4]))
   && (AND == IOR
       || nonzero_bits (operands[3], QImode) == 1)))
            return -1;
          return 1484; /* *nzb=1.and.zerox.not_split */

        default:
          return -1;
        }

    case GE:
      if (pattern44 (x1) != 0
          || !
#line 11062 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(optimize && avropt_use_nonzero_bits
   && !reload_completed
   && (AND == IOR || AND == XOR
       || nonzero_bits (operands[2], QImode) == 1)))
        return -1;
      return 1490; /* *nzb=1.and.ge0_split */

    default:
      return -1;
    }
}

 int
recog_43 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  x3 = XEXP (x2, 1);
  x4 = XEXP (x3, 1);
  switch (GET_CODE (x4))
    {
    case SIGN_EXTEND:
      switch (pattern219 (x1))
        {
        case 0:
          if (!
#line 2034 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed
   && 2 > 1))
            return -1;
          return 258; /* *subhi3.sign_extend.qi */

        case 1:
          if (!
#line 2034 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed
   && 3 > 1))
            return -1;
          return 260; /* *subpsi3.sign_extend.qi */

        case 2:
          if (!
#line 2034 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed
   && 3 > 2))
            return -1;
          return 264; /* *subpsi3.sign_extend.hi */

        case 3:
          if (!
#line 2034 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed
   && 4 > 1))
            return -1;
          return 262; /* *subsi3.sign_extend.qi */

        case 4:
          if (!
#line 2034 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed
   && 4 > 2))
            return -1;
          return 266; /* *subsi3.sign_extend.hi */

        case 5:
          if (!
#line 2034 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed
   && 4 > 3))
            return -1;
          return 268; /* *subsi3.sign_extend.psi */

        default:
          return -1;
        }

    case ZERO_EXTEND:
      switch (pattern219 (x1))
        {
        case 0:
          if (!
#line 2034 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed
   && 2 > 1))
            return -1;
          return 259; /* *subhi3.zero_extend.qi */

        case 1:
          if (!
#line 2034 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed
   && 3 > 1))
            return -1;
          return 261; /* *subpsi3.zero_extend.qi */

        case 2:
          if (!
#line 2034 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed
   && 3 > 2))
            return -1;
          return 265; /* *subpsi3.zero_extend.hi */

        case 3:
          if (!
#line 2034 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed
   && 4 > 1))
            return -1;
          return 263; /* *subsi3.zero_extend.qi */

        case 4:
          if (!
#line 2034 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed
   && 4 > 2))
            return -1;
          return 267; /* *subsi3.zero_extend.hi */

        case 5:
          if (!
#line 2034 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed
   && 4 > 3))
            return -1;
          return 269; /* *subsi3.zero_extend.psi */

        default:
          return -1;
        }

    case CONST_INT:
    case CONST_WIDE_INT:
    case CONST_POLY_INT:
    case CONST_FIXED:
    case CONST_DOUBLE:
    case CONST_VECTOR:
    case CONST:
    case REG:
    case SUBREG:
    case LABEL_REF:
    case SYMBOL_REF:
    case HIGH:
      operands[2] = x4;
      x5 = XEXP (x3, 0);
      operands[1] = x5;
      x6 = XVECEXP (x1, 0, 1);
      x7 = XEXP (x6, 0);
      if (GET_CODE (x7) == REG
          && REGNO (x7) == 36
          && GET_MODE (x7) == E_CCmode)
        {
          switch (GET_MODE (operands[0]))
            {
            case E_PSImode:
              if (pattern321 (x3, 
E_PSImode) == 0
                  && 
#line 2088 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
                return 273; /* *subpsi3 */
              break;

            case E_QImode:
              if (pattern308 (x3, 
E_QImode) == 0
                  && 
#line 2115 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
                return 277; /* *subqi3 */
              break;

            case E_QQmode:
              if (pattern308 (x3, 
E_QQmode) == 0
                  && 
#line 2115 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
                return 278; /* *subqq3 */
              break;

            case E_UQQmode:
              if (pattern308 (x3, 
E_UQQmode) == 0
                  && 
#line 2115 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
                return 279; /* *subuqq3 */
              break;

            default:
              break;
            }
        }
      operands[3] = x7;
      if (!scratch_operand (operands[3], E_QImode))
        return -1;
      switch (GET_MODE (operands[0]))
        {
        case E_HImode:
          if (pattern308 (x3, 
E_HImode) != 0)
            return -1;
          return 280; /* subhi3 */

        case E_HQmode:
          if (pattern308 (x3, 
E_HQmode) != 0)
            return -1;
          return 281; /* subhq3 */

        case E_UHQmode:
          if (pattern308 (x3, 
E_UHQmode) != 0)
            return -1;
          return 282; /* subuhq3 */

        case E_HAmode:
          if (pattern308 (x3, 
E_HAmode) != 0)
            return -1;
          return 283; /* subha3 */

        case E_UHAmode:
          if (pattern308 (x3, 
E_UHAmode) != 0)
            return -1;
          return 284; /* subuha3 */

        case E_SImode:
          if (pattern308 (x3, 
E_SImode) != 0)
            return -1;
          return 290; /* subsi3 */

        case E_SQmode:
          if (pattern308 (x3, 
E_SQmode) != 0)
            return -1;
          return 291; /* subsq3 */

        case E_USQmode:
          if (pattern308 (x3, 
E_USQmode) != 0)
            return -1;
          return 292; /* subusq3 */

        case E_SAmode:
          if (pattern308 (x3, 
E_SAmode) != 0)
            return -1;
          return 293; /* subsa3 */

        case E_USAmode:
          if (pattern308 (x3, 
E_USAmode) != 0)
            return -1;
          return 294; /* subusa3 */

        default:
          return -1;
        }

    case GE:
      switch (pattern221 (x1))
        {
        case 0:
          if (!
#line 2370 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 348; /* *subqi3.ge0 */

        case 1:
          if (!
#line 2370 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 356; /* *subqi3.ge0 */

        case 2:
          if (!
#line 2370 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 364; /* *subqi3.ge0 */

        case 3:
          if (!
#line 2370 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 372; /* *subqi3.ge0 */

        case 4:
          if (!
#line 2370 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 350; /* *subhi3.ge0 */

        case 5:
          if (!
#line 2370 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 358; /* *subhi3.ge0 */

        case 6:
          if (!
#line 2370 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 366; /* *subhi3.ge0 */

        case 7:
          if (!
#line 2370 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 374; /* *subhi3.ge0 */

        case 8:
          if (!
#line 2370 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 352; /* *subpsi3.ge0 */

        case 9:
          if (!
#line 2370 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 360; /* *subpsi3.ge0 */

        case 10:
          if (!
#line 2370 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 368; /* *subpsi3.ge0 */

        case 11:
          if (!
#line 2370 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 376; /* *subpsi3.ge0 */

        case 12:
          if (!
#line 2370 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 354; /* *subsi3.ge0 */

        case 13:
          if (!
#line 2370 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 362; /* *subsi3.ge0 */

        case 14:
          if (!
#line 2370 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 370; /* *subsi3.ge0 */

        case 15:
          if (!
#line 2370 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 378; /* *subsi3.ge0 */

        default:
          return -1;
        }

    case LT:
      switch (pattern221 (x1))
        {
        case 0:
          if (!
#line 2370 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 349; /* *subqi3.lt0 */

        case 1:
          if (!
#line 2370 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 357; /* *subqi3.lt0 */

        case 2:
          if (!
#line 2370 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 365; /* *subqi3.lt0 */

        case 3:
          if (!
#line 2370 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 373; /* *subqi3.lt0 */

        case 4:
          if (!
#line 2370 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 351; /* *subhi3.lt0 */

        case 5:
          if (!
#line 2370 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 359; /* *subhi3.lt0 */

        case 6:
          if (!
#line 2370 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 367; /* *subhi3.lt0 */

        case 7:
          if (!
#line 2370 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 375; /* *subhi3.lt0 */

        case 8:
          if (!
#line 2370 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 353; /* *subpsi3.lt0 */

        case 9:
          if (!
#line 2370 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 361; /* *subpsi3.lt0 */

        case 10:
          if (!
#line 2370 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 369; /* *subpsi3.lt0 */

        case 11:
          if (!
#line 2370 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 377; /* *subpsi3.lt0 */

        case 12:
          if (!
#line 2370 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 355; /* *subsi3.lt0 */

        case 13:
          if (!
#line 2370 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 363; /* *subsi3.lt0 */

        case 14:
          if (!
#line 2370 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 371; /* *subsi3.lt0 */

        case 15:
          if (!
#line 2370 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
            return -1;
          return 379; /* *subsi3.lt0 */

        default:
          return -1;
        }

    case MULT:
      x5 = XEXP (x3, 0);
      operands[3] = x5;
      switch (pattern234 (x3))
        {
        case 0:
          x8 = XEXP (x4, 1);
          operands[2] = x8;
          switch (GET_CODE (operands[2]))
            {
            case REG:
            case SUBREG:
              if (!register_operand (operands[2], E_QImode))
                return -1;
              x6 = XVECEXP (x1, 0, 1);
              x7 = XEXP (x6, 0);
              if (GET_CODE (x7) != REG
                  || REGNO (x7) != 36
                  || GET_MODE (x7) != E_CCmode
                  || !
#line 2633 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              return 493; /* *msubqi4 */

            case CONST_INT:
              if (!const_int_operand (operands[2], E_QImode))
                return -1;
              x6 = XVECEXP (x1, 0, 1);
              x7 = XEXP (x6, 0);
              operands[4] = x7;
              if (!scratch_operand (operands[4], E_QImode)
                  || !
#line 2662 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
                return -1;
              return 495; /* *msubqi4.const */

            default:
              return -1;
            }

        case 1:
          x8 = XEXP (x4, 1);
          switch (GET_CODE (x8))
            {
            case SIGN_EXTEND:
              if (pattern362 (x1) != 0
                  || !
#line 2745 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              return 502; /* *msubqihi4 */

            case ZERO_EXTEND:
              if (pattern362 (x1) != 0
                  || !
#line 2811 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL
   && reload_completed
   && SIGN_EXTEND != ZERO_EXTEND))
                return -1;
              return 511; /* *sumsubqihi4 */

            case CONST_INT:
              operands[2] = x8;
              x6 = XVECEXP (x1, 0, 1);
              x7 = XEXP (x6, 0);
              operands[4] = x7;
              if (!scratch_operand (operands[4], E_QImode))
                return -1;
              if (s8_operand (operands[2], E_HImode)
                  && 
#line 2877 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
                return 515; /* *msubqihi4.sconst */
              if (!u8_operand (operands[2], E_HImode)
                  || !
#line 2968 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL
   && !s8_operand (operands[2], VOIDmode)))
                return -1;
              return 520; /* *sumsubqihi4.uconst */

            default:
              return -1;
            }

        case 2:
          x8 = XEXP (x4, 1);
          switch (GET_CODE (x8))
            {
            case ZERO_EXTEND:
              if (pattern362 (x1) != 0
                  || !
#line 2745 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              return 503; /* *umsubqihi4 */

            case SIGN_EXTEND:
              if (pattern362 (x1) != 0
                  || !
#line 2811 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL
   && reload_completed
   && ZERO_EXTEND != SIGN_EXTEND))
                return -1;
              return 510; /* *usmsubqihi4 */

            case CONST_INT:
              operands[2] = x8;
              if (!u8_operand (operands[2], E_HImode))
                return -1;
              x6 = XVECEXP (x1, 0, 1);
              x7 = XEXP (x6, 0);
              operands[4] = x7;
              if (!scratch_operand (operands[4], E_QImode)
                  || !
#line 2877 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
                return -1;
              return 516; /* *umsubqihi4.uconst */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case ASHIFT:
      if (pattern222 (x3) != 0)
        return -1;
      x8 = XEXP (x4, 1);
      operands[2] = x8;
      x6 = XVECEXP (x1, 0, 1);
      x7 = XEXP (x6, 0);
      operands[4] = x7;
      if (!scratch_operand (operands[4], E_QImode))
        return -1;
      x9 = XEXP (x4, 0);
      switch (pattern352 (x9))
        {
        case 0:
          if (!
#line 2900 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
            return -1;
          return 517; /* *umsubqihi4.uconst.ashift */

        case 1:
          if (!
#line 2924 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL))
            return -1;
          return 518; /* *msubqihi4.sconst.ashift */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_65 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 1);
  if (GET_CODE (x2) != CLOBBER)
    return -1;
  x3 = XVECEXP (x1, 0, 0);
  x4 = XEXP (x3, 1);
  x5 = XEXP (x4, 0);
  switch (GET_CODE (x5))
    {
    case ZERO_EXTEND:
      if (GET_MODE (x5) != E_HImode)
        return -1;
      x6 = XEXP (x4, 1);
      if (GET_CODE (x6) != ZERO_EXTEND
          || GET_MODE (x6) != E_HImode
          || pattern169 (x1, 
E_HImode) != 0)
        return -1;
      x7 = XEXP (x5, 0);
      operands[1] = x7;
      if (!register_operand (operands[1], E_QImode))
        return -1;
      x8 = XEXP (x6, 0);
      operands[2] = x8;
      if (!register_operand (operands[2], E_QImode)
          || !
#line 1783 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 192; /* *udiff_widenqihi3 */

    case REG:
    case SUBREG:
      x9 = XEXP (x3, 0);
      operands[0] = x9;
      res = recog_43 (x1, insn, pnum_clobbers);
      if (res >= 0)
        return res;
      if (GET_CODE (x5) != REG
          || pattern204 (x1) != 0)
        return -1;
      x6 = XEXP (x4, 1);
      switch (GET_CODE (x6))
        {
        case REG:
          switch (pattern330 (x3))
            {
            case 0:
              if (!
#line 224 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
                return -1;
              return 3203; /* *subdi3_insn */

            case 1:
              if (!
#line 224 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
                return -1;
              return 3204; /* *subdq3_insn */

            case 2:
              if (!
#line 224 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
                return -1;
              return 3205; /* *subudq3_insn */

            case 3:
              if (!
#line 224 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
                return -1;
              return 3206; /* *subda3_insn */

            case 4:
              if (!
#line 224 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
                return -1;
              return 3207; /* *subuda3_insn */

            case 5:
              if (!
#line 224 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
                return -1;
              return 3208; /* *subta3_insn */

            case 6:
              if (!
#line 224 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
                return -1;
              return 3209; /* *subuta3_insn */

            default:
              return -1;
            }

        case CONST_INT:
        case CONST_FIXED:
        case CONST_DOUBLE:
          switch (pattern331 (x3))
            {
            case 0:
              if (!
#line 249 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
                return -1;
              return 3217; /* *subdi3_const_insn */

            case 1:
              if (!
#line 249 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
                return -1;
              return 3218; /* *subdq3_const_insn */

            case 2:
              if (!
#line 249 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
                return -1;
              return 3219; /* *subudq3_const_insn */

            case 3:
              if (!
#line 249 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
                return -1;
              return 3220; /* *subda3_const_insn */

            case 4:
              if (!
#line 249 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
                return -1;
              return 3221; /* *subuda3_const_insn */

            case 5:
              if (!
#line 249 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
                return -1;
              return 3222; /* *subta3_const_insn */

            case 6:
              if (!
#line 249 "../../gcc-15.1.0/gcc/config/avr/avr-dimode.md"
(avr_have_dimode && reload_completed))
                return -1;
              return 3223; /* *subuta3_const_insn */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_73 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case SET:
      return recog_72 (x1, insn, pnum_clobbers);

    case CALL:
      x3 = XEXP (x2, 0);
      if (GET_CODE (x3) != MEM
          || GET_MODE (x3) != E_HImode)
        return -1;
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != USE)
        return -1;
      x5 = XEXP (x3, 0);
      operands[0] = x5;
      if (!nonmemory_operand (operands[0], E_HImode))
        return -1;
      x6 = XEXP (x2, 1);
      operands[1] = x6;
      if (!general_operand (operands[1], E_HImode))
        return -1;
      x7 = XEXP (x4, 0);
      operands[2] = x7;
      if (!const_int_operand (operands[2], E_HImode))
        return -1;
      return 970; /* call_insn */

    case UNSPEC_VOLATILE:
      x4 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x4) != SET)
        return -1;
      x8 = XEXP (x4, 1);
      if (pattern103 (x8) != 0)
        return -1;
      switch (XVECLEN (x2, 0))
        {
        case 1:
          switch (XINT (x2, 1))
            {
            case 5:
              x9 = XVECEXP (x2, 0, 0);
              operands[0] = x9;
              if (!const_int_operand (operands[0], E_QImode))
                return -1;
              x7 = XEXP (x4, 0);
              operands[1] = x7;
              x10 = XVECEXP (x8, 0, 0);
              if (!rtx_equal_p (x10, operands[1]))
                return -1;
              return 995; /* cli_sei */

            case 7:
              x9 = XVECEXP (x2, 0, 0);
              operands[0] = x9;
              if (!const_int_operand (operands[0], E_SImode))
                return -1;
              x7 = XEXP (x4, 0);
              operands[1] = x7;
              x10 = XVECEXP (x8, 0, 0);
              if (!rtx_equal_p (x10, operands[1]))
                return -1;
              return 1054; /* *nopv */

            case 8:
              x9 = XVECEXP (x2, 0, 0);
              if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              x7 = XEXP (x4, 0);
              operands[0] = x7;
              x10 = XVECEXP (x8, 0, 0);
              if (!rtx_equal_p (x10, operands[0]))
                return -1;
              return 1055; /* *sleep */

            case 9:
              x9 = XVECEXP (x2, 0, 0);
              if (x9 != const_int_rtx[MAX_SAVED_CONST_INT + 0])
                return -1;
              x7 = XEXP (x4, 0);
              operands[0] = x7;
              x10 = XVECEXP (x8, 0, 0);
              if (!rtx_equal_p (x10, operands[0]))
                return -1;
              return 1056; /* *wdr */

            default:
              return -1;
            }

        case 2:
          if (pnum_clobbers == NULL
              || XINT (x2, 1) != 10)
            return -1;
          x11 = XVECEXP (x2, 0, 1);
          if (GET_CODE (x11) != CONST_INT)
            return -1;
          x9 = XVECEXP (x2, 0, 0);
          operands[0] = x9;
          x7 = XEXP (x4, 0);
          operands[1] = x7;
          x10 = XVECEXP (x8, 0, 0);
          if (!rtx_equal_p (x10, operands[1]))
            return -1;
          switch (XWINT (x11, 0))
            {
            case 1L:
              if (!const_int_operand (operands[0], E_QImode))
                return -1;
              *pnum_clobbers = 1;
              return 1003; /* delay_cycles_1 */

            case 2L:
              if (!const_int_operand (operands[0], E_HImode))
                return -1;
              *pnum_clobbers = 1;
              return 1005; /* delay_cycles_2 */

            case 3L:
              if (!const_int_operand (operands[0], E_SImode))
                return -1;
              *pnum_clobbers = 3;
              return 1007; /* delay_cycles_3 */

            case 4L:
              if (!const_int_operand (operands[0], E_SImode))
                return -1;
              *pnum_clobbers = 4;
              return 1009; /* delay_cycles_4 */

            default:
              return -1;
            }

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 int
recog_83 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3;
  int res ATTRIBUTE_UNUSED;
  if (pattern105 (x1) != 0
      || !scratch_operand (operands[3], E_QImode))
    return -1;
  switch (GET_MODE (operands[0]))
    {
    case E_HImode:
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 1);
      if (pattern307 (x3, 
E_HImode) != 0
          || !
#line 1923 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 209; /* *addhi3_clobber */

    case E_HQmode:
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 1);
      if (pattern307 (x3, 
E_HQmode) != 0
          || !
#line 1923 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 210; /* *addhq3_clobber */

    case E_UHQmode:
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 1);
      if (pattern307 (x3, 
E_UHQmode) != 0
          || !
#line 1923 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 211; /* *adduhq3_clobber */

    case E_HAmode:
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 1);
      if (pattern307 (x3, 
E_HAmode) != 0
          || !
#line 1923 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 212; /* *addha3_clobber */

    case E_UHAmode:
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 1);
      if (pattern307 (x3, 
E_UHAmode) != 0
          || !
#line 1923 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 213; /* *adduha3_clobber */

    case E_SImode:
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 1);
      if (pattern108 (x3, 
E_SImode) != 0
          || !
#line 1954 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 219; /* *addsi3 */

    case E_SQmode:
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 1);
      if (pattern108 (x3, 
E_SQmode) != 0
          || !
#line 1954 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 220; /* *addsq3 */

    case E_USQmode:
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 1);
      if (pattern108 (x3, 
E_USQmode) != 0
          || !
#line 1954 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 221; /* *addusq3 */

    case E_SAmode:
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 1);
      if (pattern108 (x3, 
E_SAmode) != 0
          || !
#line 1954 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 222; /* *addsa3 */

    case E_USAmode:
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 1);
      if (pattern108 (x3, 
E_USAmode) != 0
          || !
#line 1954 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 223; /* *addusa3 */

    case E_PSImode:
      x2 = XVECEXP (x1, 0, 0);
      x3 = XEXP (x2, 1);
      if (pattern108 (x3, 
E_PSImode) != 0
          || !
#line 2064 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
        return -1;
      return 271; /* *addpsi3 */

    default:
      return -1;
    }
}

 int
recog_88 (rtx x1 ATTRIBUTE_UNUSED,
	rtx_insn *insn ATTRIBUTE_UNUSED,
	int *pnum_clobbers ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx x2, x3, x4, x5, x6, x7, x8, x9;
  rtx x10, x11, x12, x13, x14, x15, x16, x17;
  rtx x18, x19, x20, x21, x22, x23, x24, x25;
  rtx x26, x27, x28, x29, x30, x31, x32, x33;
  rtx x34, x35, x36, x37, x38, x39, x40, x41;
  rtx x42, x43, x44, x45, x46, x47, x48, x49;
  rtx x50, x51, x52;
  int res ATTRIBUTE_UNUSED;
  x2 = XVECEXP (x1, 0, 0);
  switch (GET_CODE (x2))
    {
    case SET:
      x3 = XEXP (x2, 1);
      switch (GET_CODE (x3))
        {
        case CONST_INT:
          if (XWINT (x3, 0) != 0L)
            return -1;
          x4 = XEXP (x2, 0);
          if (GET_CODE (x4) != MEM
              || GET_MODE (x4) != E_BLKmode)
            return -1;
          x5 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x5) != USE)
            return -1;
          x6 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x6) != USE)
            return -1;
          x7 = XVECEXP (x1, 0, 3);
          if (GET_CODE (x7) != CLOBBER)
            return -1;
          x8 = XVECEXP (x1, 0, 4);
          if (GET_CODE (x8) != CLOBBER)
            return -1;
          switch (pattern288 (x1))
            {
            case 0:
              return 168; /* *clrmemqi_split */

            case 1:
              return 170; /* *clrmemhi_split */

            default:
              return -1;
            }

        case MULT:
          x9 = XEXP (x3, 0);
          if (GET_CODE (x9) != REG
              || pattern150 (x2) != 0
              || pattern106 (x1) != 0)
            return -1;
          x7 = XVECEXP (x1, 0, 3);
          if (GET_CODE (x7) != CLOBBER)
            return -1;
          x10 = XEXP (x7, 0);
          if (GET_CODE (x10) != REG
              || GET_MODE (x10) != E_HImode)
            return -1;
          x8 = XVECEXP (x1, 0, 4);
          if (pattern176 (x8) != 0)
            return -1;
          switch (pattern360 (x1))
            {
            case 0:
              if (!
#line 3762 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(avropt_pr118012
   && ! AVR_HAVE_MUL
   && ! AVR_TINY
   && reload_completed))
                return -1;
              return 567; /* *mulsi3_call_pr118012 */

            case 1:
              if (!
#line 4268 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_MUL && reload_completed))
                return -1;
              return 605; /* *mulpsi3.libgcc */

            default:
              return -1;
            }

        case DIV:
          switch (pattern118 (x1, 
MOD))
            {
            case 0:
              x11 = XEXP (x3, 1);
              if (REGNO (x11) != 22)
                return -1;
              x5 = XVECEXP (x1, 0, 1);
              x12 = XEXP (x5, 1);
              x13 = XEXP (x12, 0);
              if (REGNO (x13) != 24)
                return -1;
              x14 = XEXP (x12, 1);
              if (REGNO (x14) != 22)
                return -1;
              x8 = XVECEXP (x1, 0, 4);
              x15 = XEXP (x8, 0);
              if (REGNO (x15) != 36
                  || GET_MODE (x15) != E_CCmode)
                return -1;
              switch (pattern374 (x1))
                {
                case 0:
                  if (!
#line 3936 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
                    return -1;
                  return 586; /* *divmodqi4_call */

                case 1:
                  if (!
#line 4024 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
                    return -1;
                  return 592; /* *divmodhi4_call */

                default:
                  return -1;
                }

            case 1:
              switch (pattern368 (x1))
                {
                case 0:
                  return 607; /* *divmodpsi4_call_split */

                case 1:
                  if (!
#line 4422 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
                    return -1;
                  return 614; /* *divmodsi4_call */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case UDIV:
          switch (pattern118 (x1, 
UMOD))
            {
            case 0:
              if (pattern361 (x1, 
E_HImode, 
22, 
24) != 0)
                return -1;
              x5 = XVECEXP (x1, 0, 1);
              x16 = XEXP (x5, 0);
              if (REGNO (x16) != 24
                  || GET_MODE (x16) != E_HImode)
                return -1;
              x6 = XVECEXP (x1, 0, 2);
              x17 = XEXP (x6, 0);
              if (REGNO (x17) != 26
                  || GET_MODE (x17) != E_HImode)
                return -1;
              x7 = XVECEXP (x1, 0, 3);
              x10 = XEXP (x7, 0);
              if (REGNO (x10) != 21
                  || GET_MODE (x10) != E_QImode)
                return -1;
              x8 = XVECEXP (x1, 0, 4);
              x15 = XEXP (x8, 0);
              if (REGNO (x15) != 36
                  || GET_MODE (x15) != E_CCmode
                  || GET_MODE (x3) != E_HImode)
                return -1;
              x12 = XEXP (x5, 1);
              if (GET_MODE (x12) != E_HImode
                  || !
#line 4071 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
                return -1;
              return 595; /* *udivmodhi4_call */

            case 1:
              switch (pattern368 (x1))
                {
                case 0:
                  return 610; /* *udivmodpsi4_call_split */

                case 1:
                  if (!
#line 4469 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(reload_completed))
                    return -1;
                  return 617; /* *udivmodsi4_call */

                default:
                  return -1;
                }

            default:
              return -1;
            }

        case UNSPEC:
          if (pattern119 (x1) != 0
              || pattern177 (x1, 
CLOBBER) != 0)
            return -1;
          x7 = XVECEXP (x1, 0, 3);
          x10 = XEXP (x7, 0);
          if (x10 == const_int_rtx[MAX_SAVED_CONST_INT + 0])
            {
              x18 = XVECEXP (x3, 0, 0);
              operands[0] = x18;
              if (register_operand (operands[0], E_HImode))
                {
                  x5 = XVECEXP (x1, 0, 1);
                  x16 = XEXP (x5, 0);
                  x19 = XEXP (x16, 0);
                  operands[1] = x19;
                  x6 = XVECEXP (x1, 0, 2);
                  x17 = XEXP (x6, 0);
                  operands[2] = x17;
                  if (scratch_operand (operands[2], E_HImode)
                      && 
#line 7950 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(!AVR_HAVE_EIJMP_EICALL && reload_completed))
                    return 975; /* *tablejump */
                }
            }
          x18 = XVECEXP (x3, 0, 0);
          if (GET_CODE (x18) != REG
              || pattern325 (x1) != 0
              || !
#line 7987 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(AVR_HAVE_EIJMP_EICALL && reload_completed))
            return -1;
          return 977; /* *tablejump.3byte-pc */

        case SIGN_EXTEND:
        case ZERO_EXTEND:
          operands[10] = x3;
          if (!extend_operator (operands[10], E_SImode))
            return -1;
          x5 = XVECEXP (x1, 0, 1);
          if (GET_CODE (x5) != PARALLEL
              || XVECLEN (x5, 0) != 2)
            return -1;
          x20 = XVECEXP (x5, 0, 0);
          if (GET_CODE (x20) != SET)
            return -1;
          x21 = XEXP (x20, 1);
          if (GET_CODE (x21) != PLUS
              || GET_MODE (x21) != E_SImode)
            return -1;
          x22 = XVECEXP (x5, 0, 1);
          if (GET_CODE (x22) != CLOBBER)
            return -1;
          x23 = XEXP (x22, 0);
          if (GET_CODE (x23) != SCRATCH
              || GET_MODE (x23) != E_QImode)
            return -1;
          x6 = XVECEXP (x1, 0, 2);
          if (GET_CODE (x6) != PARALLEL
              || XVECLEN (x6, 0) != 2)
            return -1;
          x24 = XVECEXP (x6, 0, 0);
          if (GET_CODE (x24) != SET)
            return -1;
          x25 = XEXP (x24, 1);
          if (GET_CODE (x25) != IF_THEN_ELSE)
            return -1;
          x26 = XEXP (x25, 0);
          if (GET_CODE (x26) != GTU)
            return -1;
          x27 = XEXP (x25, 1);
          if (GET_CODE (x27) != LABEL_REF)
            return -1;
          x28 = XEXP (x25, 2);
          if (GET_CODE (x28) != PC)
            return -1;
          x29 = XEXP (x24, 0);
          if (GET_CODE (x29) != PC)
            return -1;
          x30 = XVECEXP (x6, 0, 1);
          if (GET_CODE (x30) != CLOBBER)
            return -1;
          x31 = XEXP (x30, 0);
          if (GET_CODE (x31) != SCRATCH
              || GET_MODE (x31) != E_QImode)
            return -1;
          x7 = XVECEXP (x1, 0, 3);
          if (GET_CODE (x7) != SET)
            return -1;
          x8 = XVECEXP (x1, 0, 4);
          if (GET_CODE (x8) != PARALLEL
              || XVECLEN (x8, 0) != 4)
            return -1;
          x32 = XVECEXP (x8, 0, 0);
          if (GET_CODE (x32) != SET)
            return -1;
          x33 = XEXP (x32, 1);
          if (GET_CODE (x33) != UNSPEC
              || XVECLEN (x33, 0) != 1
              || XINT (x33, 1) != 2
              || GET_MODE (x33) != E_HImode)
            return -1;
          x34 = XEXP (x32, 0);
          if (GET_CODE (x34) != PC)
            return -1;
          x35 = XVECEXP (x8, 0, 1);
          if (GET_CODE (x35) != USE)
            return -1;
          x36 = XEXP (x35, 0);
          if (GET_CODE (x36) != LABEL_REF)
            return -1;
          x37 = XVECEXP (x8, 0, 2);
          if (GET_CODE (x37) != CLOBBER)
            return -1;
          x38 = XVECEXP (x8, 0, 3);
          if (GET_CODE (x38) != CLOBBER)
            return -1;
          x4 = XEXP (x2, 0);
          operands[0] = x4;
          if (!register_operand (operands[0], E_SImode))
            return -1;
          x9 = XEXP (x3, 0);
          operands[11] = x9;
          x39 = XEXP (x20, 0);
          operands[5] = x39;
          if (!register_operand (operands[5], E_SImode))
            return -1;
          x40 = XEXP (x21, 1);
          operands[1] = x40;
          if (!const_int_operand (operands[1], E_SImode))
            return -1;
          x41 = XEXP (x26, 1);
          operands[2] = x41;
          if (!const_int_operand (operands[2], E_SImode))
            return -1;
          x42 = XEXP (x27, 0);
          operands[4] = x42;
          x10 = XEXP (x7, 0);
          operands[7] = x10;
          if (!register_operand (operands[7], E_HImode))
            return -1;
          x43 = XEXP (x7, 1);
          operands[6] = x43;
          x44 = XEXP (x36, 0);
          operands[3] = x44;
          x45 = XEXP (x37, 0);
          operands[8] = x45;
          x46 = XEXP (x38, 0);
          operands[9] = x46;
          x47 = XEXP (x21, 0);
          if (!rtx_equal_p (x47, operands[0]))
            return -1;
          x48 = XEXP (x26, 0);
          if (!rtx_equal_p (x48, operands[5]))
            return -1;
          x49 = XVECEXP (x33, 0, 0);
          if (!rtx_equal_p (x49, operands[7]))
            return -1;
          switch (GET_MODE (operands[11]))
            {
            case E_QImode:
              if (!register_operand (operands[11], E_QImode)
                  || !
#line 8100 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(optimize
   && avr_casei_sequence_check_operands (operands)))
                return -1;
              return 978; /* casesi_qi_sequence */

            case E_HImode:
              if (!register_operand (operands[11], E_HImode)
                  || !
#line 8100 "../../gcc-15.1.0/gcc/config/avr/avr.md"
(optimize
   && avr_casei_sequence_check_operands (operands)))
                return -1;
              return 979; /* casesi_hi_sequence */

            default:
              return -1;
            }

        default:
          return -1;
        }

    case UNSPEC_VOLATILE:
      x5 = XVECEXP (x1, 0, 1);
      if (GET_CODE (x5) != SET)
        return -1;
      x7 = XVECEXP (x1, 0, 3);
      if (GET_CODE (x7) != CLOBBER)
        return -1;
      x8 = XVECEXP (x1, 0, 4);
      if (GET_CODE (x8) != CLOBBER)
        return -1;
      switch (XVECLEN (x2, 0))
        {
        case 1:
          if (pattern175 (x1) != 0
              || pattern187 (x1, 
E_CCmode, 
36, 
30) != 0)
            return -1;
          x12 = XEXP (x5, 1);
          x14 = XEXP (x12, 1);
          operands[0] = x14;
          if (!immediate_operand (operands[0], E_HImode))
            return -1;
          x6 = XVECEXP (x1, 0, 2);
          x50 = XEXP (x6, 1);
          x51 = XEXP (x50, 1);
          if (!rtx_equal_p (x51, operands[0]))
            return -1;
          return 997; /* epilogue_restores */

        case 2:
          if (XINT (x2, 1) != 10)
            return -1;
          x52 = XVECEXP (x2, 0, 1);
          if (x52 != const_int_rtx[MAX_SAVED_CONST_INT + 3]
              || pattern248 (x1) != 0)
            return -1;
          return 1007; /* delay_cycles_3 */

        default:
          return -1;
        }

    default:
      return -1;
    }
}

 rtx_insn *
split_9 (rtx x1 ATTRIBUTE_UNUSED, rtx_insn *insn ATTRIBUTE_UNUSED)
{
  rtx * const operands ATTRIBUTE_UNUSED = &recog_data.operand[0];
  rtx_insn *res ATTRIBUTE_UNUSED;
  switch (pattern23 (x1))
    {
    case 0:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UQQmode != QQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1031 (insn, operands);

    case 1:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HQmode != QQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1032 (insn, operands);

    case 2:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UHQmode != QQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1033 (insn, operands);

    case 3:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HAmode != QQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1034 (insn, operands);

    case 4:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UHAmode != QQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1035 (insn, operands);

    case 5:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SQmode != QQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1036 (insn, operands);

    case 6:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(USQmode != QQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1037 (insn, operands);

    case 7:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SAmode != QQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1038 (insn, operands);

    case 8:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(USAmode != QQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1039 (insn, operands);

    case 9:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DQmode != QQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1040 (insn, operands);

    case 10:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UDQmode != QQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1041 (insn, operands);

    case 11:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DAmode != QQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1042 (insn, operands);

    case 12:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UDAmode != QQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1043 (insn, operands);

    case 13:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(TAmode != QQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1044 (insn, operands);

    case 14:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UTAmode != QQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1045 (insn, operands);

    case 15:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(QImode != QQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1046 (insn, operands);

    case 16:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HImode != QQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1047 (insn, operands);

    case 17:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SImode != QQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1048 (insn, operands);

    case 18:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DImode != QQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1049 (insn, operands);

    case 19:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(QQmode != UQQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1050 (insn, operands);

    case 20:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HQmode != UQQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1051 (insn, operands);

    case 21:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UHQmode != UQQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1052 (insn, operands);

    case 22:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HAmode != UQQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1053 (insn, operands);

    case 23:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UHAmode != UQQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1054 (insn, operands);

    case 24:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SQmode != UQQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1055 (insn, operands);

    case 25:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(USQmode != UQQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1056 (insn, operands);

    case 26:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SAmode != UQQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1057 (insn, operands);

    case 27:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(USAmode != UQQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1058 (insn, operands);

    case 28:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DQmode != UQQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1059 (insn, operands);

    case 29:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UDQmode != UQQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1060 (insn, operands);

    case 30:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DAmode != UQQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1061 (insn, operands);

    case 31:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UDAmode != UQQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1062 (insn, operands);

    case 32:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(TAmode != UQQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1063 (insn, operands);

    case 33:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UTAmode != UQQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1064 (insn, operands);

    case 34:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(QImode != UQQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1065 (insn, operands);

    case 35:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HImode != UQQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1066 (insn, operands);

    case 36:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SImode != UQQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1067 (insn, operands);

    case 37:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DImode != UQQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1068 (insn, operands);

    case 38:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(QQmode != HQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1069 (insn, operands);

    case 39:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UQQmode != HQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1070 (insn, operands);

    case 40:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UHQmode != HQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1071 (insn, operands);

    case 41:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HAmode != HQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1072 (insn, operands);

    case 42:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UHAmode != HQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1073 (insn, operands);

    case 43:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SQmode != HQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1074 (insn, operands);

    case 44:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(USQmode != HQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1075 (insn, operands);

    case 45:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SAmode != HQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1076 (insn, operands);

    case 46:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(USAmode != HQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1077 (insn, operands);

    case 47:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DQmode != HQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1078 (insn, operands);

    case 48:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UDQmode != HQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1079 (insn, operands);

    case 49:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DAmode != HQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1080 (insn, operands);

    case 50:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UDAmode != HQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1081 (insn, operands);

    case 51:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(TAmode != HQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1082 (insn, operands);

    case 52:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UTAmode != HQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1083 (insn, operands);

    case 53:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(QImode != HQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1084 (insn, operands);

    case 54:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HImode != HQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1085 (insn, operands);

    case 55:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SImode != HQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1086 (insn, operands);

    case 56:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DImode != HQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1087 (insn, operands);

    case 57:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(QQmode != UHQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1088 (insn, operands);

    case 58:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UQQmode != UHQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1089 (insn, operands);

    case 59:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HQmode != UHQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1090 (insn, operands);

    case 60:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HAmode != UHQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1091 (insn, operands);

    case 61:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UHAmode != UHQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1092 (insn, operands);

    case 62:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SQmode != UHQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1093 (insn, operands);

    case 63:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(USQmode != UHQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1094 (insn, operands);

    case 64:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SAmode != UHQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1095 (insn, operands);

    case 65:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(USAmode != UHQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1096 (insn, operands);

    case 66:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DQmode != UHQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1097 (insn, operands);

    case 67:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UDQmode != UHQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1098 (insn, operands);

    case 68:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DAmode != UHQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1099 (insn, operands);

    case 69:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UDAmode != UHQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1100 (insn, operands);

    case 70:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(TAmode != UHQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1101 (insn, operands);

    case 71:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UTAmode != UHQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1102 (insn, operands);

    case 72:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(QImode != UHQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1103 (insn, operands);

    case 73:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HImode != UHQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1104 (insn, operands);

    case 74:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SImode != UHQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1105 (insn, operands);

    case 75:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DImode != UHQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1106 (insn, operands);

    case 76:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(QQmode != HAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1107 (insn, operands);

    case 77:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UQQmode != HAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1108 (insn, operands);

    case 78:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HQmode != HAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1109 (insn, operands);

    case 79:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UHQmode != HAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1110 (insn, operands);

    case 80:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UHAmode != HAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1111 (insn, operands);

    case 81:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SQmode != HAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1112 (insn, operands);

    case 82:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(USQmode != HAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1113 (insn, operands);

    case 83:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SAmode != HAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1114 (insn, operands);

    case 84:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(USAmode != HAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1115 (insn, operands);

    case 85:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DQmode != HAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1116 (insn, operands);

    case 86:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UDQmode != HAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1117 (insn, operands);

    case 87:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DAmode != HAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1118 (insn, operands);

    case 88:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UDAmode != HAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1119 (insn, operands);

    case 89:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(TAmode != HAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1120 (insn, operands);

    case 90:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UTAmode != HAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1121 (insn, operands);

    case 91:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(QImode != HAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1122 (insn, operands);

    case 92:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HImode != HAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1123 (insn, operands);

    case 93:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SImode != HAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1124 (insn, operands);

    case 94:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DImode != HAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1125 (insn, operands);

    case 95:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(QQmode != UHAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1126 (insn, operands);

    case 96:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UQQmode != UHAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1127 (insn, operands);

    case 97:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HQmode != UHAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1128 (insn, operands);

    case 98:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UHQmode != UHAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1129 (insn, operands);

    case 99:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HAmode != UHAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1130 (insn, operands);

    case 100:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SQmode != UHAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1131 (insn, operands);

    case 101:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(USQmode != UHAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1132 (insn, operands);

    case 102:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SAmode != UHAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1133 (insn, operands);

    case 103:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(USAmode != UHAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1134 (insn, operands);

    case 104:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DQmode != UHAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1135 (insn, operands);

    case 105:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UDQmode != UHAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1136 (insn, operands);

    case 106:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DAmode != UHAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1137 (insn, operands);

    case 107:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UDAmode != UHAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1138 (insn, operands);

    case 108:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(TAmode != UHAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1139 (insn, operands);

    case 109:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UTAmode != UHAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1140 (insn, operands);

    case 110:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(QImode != UHAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1141 (insn, operands);

    case 111:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HImode != UHAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1142 (insn, operands);

    case 112:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SImode != UHAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1143 (insn, operands);

    case 113:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DImode != UHAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1144 (insn, operands);

    case 114:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(QQmode != SQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1145 (insn, operands);

    case 115:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UQQmode != SQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1146 (insn, operands);

    case 116:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HQmode != SQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1147 (insn, operands);

    case 117:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UHQmode != SQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1148 (insn, operands);

    case 118:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HAmode != SQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1149 (insn, operands);

    case 119:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UHAmode != SQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1150 (insn, operands);

    case 120:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(USQmode != SQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1151 (insn, operands);

    case 121:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SAmode != SQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1152 (insn, operands);

    case 122:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(USAmode != SQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1153 (insn, operands);

    case 123:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DQmode != SQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1154 (insn, operands);

    case 124:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UDQmode != SQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1155 (insn, operands);

    case 125:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DAmode != SQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1156 (insn, operands);

    case 126:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UDAmode != SQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1157 (insn, operands);

    case 127:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(TAmode != SQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1158 (insn, operands);

    case 128:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UTAmode != SQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1159 (insn, operands);

    case 129:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(QImode != SQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1160 (insn, operands);

    case 130:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HImode != SQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1161 (insn, operands);

    case 131:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SImode != SQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1162 (insn, operands);

    case 132:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DImode != SQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1163 (insn, operands);

    case 133:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(QQmode != USQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1164 (insn, operands);

    case 134:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UQQmode != USQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1165 (insn, operands);

    case 135:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HQmode != USQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1166 (insn, operands);

    case 136:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UHQmode != USQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1167 (insn, operands);

    case 137:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HAmode != USQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1168 (insn, operands);

    case 138:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UHAmode != USQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1169 (insn, operands);

    case 139:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SQmode != USQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1170 (insn, operands);

    case 140:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SAmode != USQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1171 (insn, operands);

    case 141:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(USAmode != USQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1172 (insn, operands);

    case 142:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DQmode != USQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1173 (insn, operands);

    case 143:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UDQmode != USQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1174 (insn, operands);

    case 144:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DAmode != USQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1175 (insn, operands);

    case 145:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UDAmode != USQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1176 (insn, operands);

    case 146:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(TAmode != USQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1177 (insn, operands);

    case 147:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UTAmode != USQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1178 (insn, operands);

    case 148:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(QImode != USQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1179 (insn, operands);

    case 149:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HImode != USQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1180 (insn, operands);

    case 150:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SImode != USQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1181 (insn, operands);

    case 151:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DImode != USQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1182 (insn, operands);

    case 152:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(QQmode != SAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1183 (insn, operands);

    case 153:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UQQmode != SAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1184 (insn, operands);

    case 154:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HQmode != SAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1185 (insn, operands);

    case 155:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UHQmode != SAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1186 (insn, operands);

    case 156:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HAmode != SAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1187 (insn, operands);

    case 157:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UHAmode != SAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1188 (insn, operands);

    case 158:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SQmode != SAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1189 (insn, operands);

    case 159:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(USQmode != SAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1190 (insn, operands);

    case 160:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(USAmode != SAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1191 (insn, operands);

    case 161:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DQmode != SAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1192 (insn, operands);

    case 162:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UDQmode != SAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1193 (insn, operands);

    case 163:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DAmode != SAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1194 (insn, operands);

    case 164:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UDAmode != SAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1195 (insn, operands);

    case 165:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(TAmode != SAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1196 (insn, operands);

    case 166:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UTAmode != SAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1197 (insn, operands);

    case 167:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(QImode != SAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1198 (insn, operands);

    case 168:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HImode != SAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1199 (insn, operands);

    case 169:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SImode != SAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1200 (insn, operands);

    case 170:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DImode != SAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1201 (insn, operands);

    case 171:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(QQmode != USAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1202 (insn, operands);

    case 172:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UQQmode != USAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1203 (insn, operands);

    case 173:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HQmode != USAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1204 (insn, operands);

    case 174:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UHQmode != USAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1205 (insn, operands);

    case 175:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HAmode != USAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1206 (insn, operands);

    case 176:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UHAmode != USAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1207 (insn, operands);

    case 177:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SQmode != USAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1208 (insn, operands);

    case 178:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(USQmode != USAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1209 (insn, operands);

    case 179:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SAmode != USAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1210 (insn, operands);

    case 180:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DQmode != USAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1211 (insn, operands);

    case 181:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UDQmode != USAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1212 (insn, operands);

    case 182:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DAmode != USAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1213 (insn, operands);

    case 183:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UDAmode != USAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1214 (insn, operands);

    case 184:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(TAmode != USAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1215 (insn, operands);

    case 185:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UTAmode != USAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1216 (insn, operands);

    case 186:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(QImode != USAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1217 (insn, operands);

    case 187:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HImode != USAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1218 (insn, operands);

    case 188:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SImode != USAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1219 (insn, operands);

    case 189:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DImode != USAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1220 (insn, operands);

    case 190:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(QQmode != DQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1221 (insn, operands);

    case 191:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UQQmode != DQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1222 (insn, operands);

    case 192:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HQmode != DQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1223 (insn, operands);

    case 193:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UHQmode != DQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1224 (insn, operands);

    case 194:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HAmode != DQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1225 (insn, operands);

    case 195:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UHAmode != DQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1226 (insn, operands);

    case 196:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SQmode != DQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1227 (insn, operands);

    case 197:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(USQmode != DQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1228 (insn, operands);

    case 198:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SAmode != DQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1229 (insn, operands);

    case 199:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(USAmode != DQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1230 (insn, operands);

    case 200:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UDQmode != DQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1231 (insn, operands);

    case 201:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DAmode != DQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1232 (insn, operands);

    case 202:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UDAmode != DQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1233 (insn, operands);

    case 203:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(TAmode != DQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1234 (insn, operands);

    case 204:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UTAmode != DQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1235 (insn, operands);

    case 205:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(QImode != DQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1236 (insn, operands);

    case 206:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HImode != DQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1237 (insn, operands);

    case 207:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SImode != DQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1238 (insn, operands);

    case 208:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DImode != DQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1239 (insn, operands);

    case 209:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(QQmode != UDQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1240 (insn, operands);

    case 210:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UQQmode != UDQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1241 (insn, operands);

    case 211:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HQmode != UDQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1242 (insn, operands);

    case 212:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UHQmode != UDQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1243 (insn, operands);

    case 213:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HAmode != UDQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1244 (insn, operands);

    case 214:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UHAmode != UDQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1245 (insn, operands);

    case 215:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SQmode != UDQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1246 (insn, operands);

    case 216:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(USQmode != UDQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1247 (insn, operands);

    case 217:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SAmode != UDQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1248 (insn, operands);

    case 218:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(USAmode != UDQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1249 (insn, operands);

    case 219:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DQmode != UDQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1250 (insn, operands);

    case 220:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DAmode != UDQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1251 (insn, operands);

    case 221:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UDAmode != UDQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1252 (insn, operands);

    case 222:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(TAmode != UDQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1253 (insn, operands);

    case 223:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UTAmode != UDQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1254 (insn, operands);

    case 224:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(QImode != UDQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1255 (insn, operands);

    case 225:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HImode != UDQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1256 (insn, operands);

    case 226:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SImode != UDQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1257 (insn, operands);

    case 227:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DImode != UDQmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1258 (insn, operands);

    case 228:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(QQmode != DAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1259 (insn, operands);

    case 229:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UQQmode != DAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1260 (insn, operands);

    case 230:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HQmode != DAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1261 (insn, operands);

    case 231:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UHQmode != DAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1262 (insn, operands);

    case 232:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HAmode != DAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1263 (insn, operands);

    case 233:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UHAmode != DAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1264 (insn, operands);

    case 234:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SQmode != DAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1265 (insn, operands);

    case 235:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(USQmode != DAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1266 (insn, operands);

    case 236:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SAmode != DAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1267 (insn, operands);

    case 237:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(USAmode != DAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1268 (insn, operands);

    case 238:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DQmode != DAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1269 (insn, operands);

    case 239:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UDQmode != DAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1270 (insn, operands);

    case 240:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UDAmode != DAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1271 (insn, operands);

    case 241:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(TAmode != DAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1272 (insn, operands);

    case 242:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UTAmode != DAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1273 (insn, operands);

    case 243:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(QImode != DAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1274 (insn, operands);

    case 244:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HImode != DAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1275 (insn, operands);

    case 245:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SImode != DAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1276 (insn, operands);

    case 246:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DImode != DAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1277 (insn, operands);

    case 247:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(QQmode != UDAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1278 (insn, operands);

    case 248:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UQQmode != UDAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1279 (insn, operands);

    case 249:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HQmode != UDAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1280 (insn, operands);

    case 250:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UHQmode != UDAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1281 (insn, operands);

    case 251:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HAmode != UDAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1282 (insn, operands);

    case 252:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UHAmode != UDAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1283 (insn, operands);

    case 253:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SQmode != UDAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1284 (insn, operands);

    case 254:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(USQmode != UDAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1285 (insn, operands);

    case 255:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SAmode != UDAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1286 (insn, operands);

    case 256:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(USAmode != UDAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1287 (insn, operands);

    case 257:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DQmode != UDAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1288 (insn, operands);

    case 258:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UDQmode != UDAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1289 (insn, operands);

    case 259:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DAmode != UDAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1290 (insn, operands);

    case 260:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(TAmode != UDAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1291 (insn, operands);

    case 261:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UTAmode != UDAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1292 (insn, operands);

    case 262:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(QImode != UDAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1293 (insn, operands);

    case 263:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HImode != UDAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1294 (insn, operands);

    case 264:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SImode != UDAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1295 (insn, operands);

    case 265:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DImode != UDAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1296 (insn, operands);

    case 266:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(QQmode != TAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1297 (insn, operands);

    case 267:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UQQmode != TAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1298 (insn, operands);

    case 268:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HQmode != TAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1299 (insn, operands);

    case 269:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UHQmode != TAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1300 (insn, operands);

    case 270:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HAmode != TAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1301 (insn, operands);

    case 271:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UHAmode != TAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1302 (insn, operands);

    case 272:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SQmode != TAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1303 (insn, operands);

    case 273:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(USQmode != TAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1304 (insn, operands);

    case 274:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SAmode != TAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1305 (insn, operands);

    case 275:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(USAmode != TAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1306 (insn, operands);

    case 276:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DQmode != TAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1307 (insn, operands);

    case 277:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UDQmode != TAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1308 (insn, operands);

    case 278:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DAmode != TAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1309 (insn, operands);

    case 279:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UDAmode != TAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1310 (insn, operands);

    case 280:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UTAmode != TAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1311 (insn, operands);

    case 281:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(QImode != TAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1312 (insn, operands);

    case 282:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HImode != TAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1313 (insn, operands);

    case 283:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SImode != TAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1314 (insn, operands);

    case 284:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DImode != TAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1315 (insn, operands);

    case 285:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(QQmode != UTAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1316 (insn, operands);

    case 286:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UQQmode != UTAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1317 (insn, operands);

    case 287:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HQmode != UTAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1318 (insn, operands);

    case 288:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UHQmode != UTAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1319 (insn, operands);

    case 289:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HAmode != UTAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1320 (insn, operands);

    case 290:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UHAmode != UTAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1321 (insn, operands);

    case 291:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SQmode != UTAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1322 (insn, operands);

    case 292:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(USQmode != UTAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1323 (insn, operands);

    case 293:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SAmode != UTAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1324 (insn, operands);

    case 294:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(USAmode != UTAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1325 (insn, operands);

    case 295:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DQmode != UTAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1326 (insn, operands);

    case 296:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UDQmode != UTAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1327 (insn, operands);

    case 297:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DAmode != UTAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1328 (insn, operands);

    case 298:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UDAmode != UTAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1329 (insn, operands);

    case 299:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(TAmode != UTAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1330 (insn, operands);

    case 300:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(QImode != UTAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1331 (insn, operands);

    case 301:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HImode != UTAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1332 (insn, operands);

    case 302:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SImode != UTAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1333 (insn, operands);

    case 303:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DImode != UTAmode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1334 (insn, operands);

    case 304:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(QQmode != QImode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1335 (insn, operands);

    case 305:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UQQmode != QImode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1336 (insn, operands);

    case 306:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HQmode != QImode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1337 (insn, operands);

    case 307:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UHQmode != QImode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1338 (insn, operands);

    case 308:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HAmode != QImode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1339 (insn, operands);

    case 309:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UHAmode != QImode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1340 (insn, operands);

    case 310:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SQmode != QImode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1341 (insn, operands);

    case 311:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(USQmode != QImode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1342 (insn, operands);

    case 312:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SAmode != QImode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1343 (insn, operands);

    case 313:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(USAmode != QImode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1344 (insn, operands);

    case 314:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DQmode != QImode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1345 (insn, operands);

    case 315:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UDQmode != QImode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1346 (insn, operands);

    case 316:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DAmode != QImode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1347 (insn, operands);

    case 317:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UDAmode != QImode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1348 (insn, operands);

    case 318:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(TAmode != QImode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1349 (insn, operands);

    case 319:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UTAmode != QImode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1350 (insn, operands);

    case 320:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HImode != QImode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1351 (insn, operands);

    case 321:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SImode != QImode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1352 (insn, operands);

    case 322:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DImode != QImode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1353 (insn, operands);

    case 323:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(QQmode != HImode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1354 (insn, operands);

    case 324:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UQQmode != HImode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1355 (insn, operands);

    case 325:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HQmode != HImode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1356 (insn, operands);

    case 326:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UHQmode != HImode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1357 (insn, operands);

    case 327:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HAmode != HImode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1358 (insn, operands);

    case 328:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UHAmode != HImode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1359 (insn, operands);

    case 329:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SQmode != HImode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1360 (insn, operands);

    case 330:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(USQmode != HImode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1361 (insn, operands);

    case 331:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SAmode != HImode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1362 (insn, operands);

    case 332:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(USAmode != HImode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1363 (insn, operands);

    case 333:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DQmode != HImode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1364 (insn, operands);

    case 334:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UDQmode != HImode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1365 (insn, operands);

    case 335:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DAmode != HImode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1366 (insn, operands);

    case 336:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UDAmode != HImode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1367 (insn, operands);

    case 337:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(TAmode != HImode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1368 (insn, operands);

    case 338:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UTAmode != HImode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1369 (insn, operands);

    case 339:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(QImode != HImode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1370 (insn, operands);

    case 340:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SImode != HImode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1371 (insn, operands);

    case 341:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DImode != HImode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1372 (insn, operands);

    case 342:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(QQmode != SImode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1373 (insn, operands);

    case 343:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UQQmode != SImode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1374 (insn, operands);

    case 344:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HQmode != SImode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1375 (insn, operands);

    case 345:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UHQmode != SImode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1376 (insn, operands);

    case 346:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HAmode != SImode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1377 (insn, operands);

    case 347:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UHAmode != SImode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1378 (insn, operands);

    case 348:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SQmode != SImode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1379 (insn, operands);

    case 349:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(USQmode != SImode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1380 (insn, operands);

    case 350:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SAmode != SImode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1381 (insn, operands);

    case 351:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(USAmode != SImode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1382 (insn, operands);

    case 352:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DQmode != SImode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1383 (insn, operands);

    case 353:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UDQmode != SImode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1384 (insn, operands);

    case 354:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DAmode != SImode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1385 (insn, operands);

    case 355:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UDAmode != SImode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1386 (insn, operands);

    case 356:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(TAmode != SImode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1387 (insn, operands);

    case 357:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UTAmode != SImode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1388 (insn, operands);

    case 358:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(QImode != SImode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1389 (insn, operands);

    case 359:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HImode != SImode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1390 (insn, operands);

    case 360:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DImode != SImode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1391 (insn, operands);

    case 361:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(QQmode != DImode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1392 (insn, operands);

    case 362:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UQQmode != DImode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1393 (insn, operands);

    case 363:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HQmode != DImode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1394 (insn, operands);

    case 364:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UHQmode != DImode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1395 (insn, operands);

    case 365:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HAmode != DImode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1396 (insn, operands);

    case 366:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UHAmode != DImode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1397 (insn, operands);

    case 367:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SQmode != DImode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1398 (insn, operands);

    case 368:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(USQmode != DImode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1399 (insn, operands);

    case 369:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SAmode != DImode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1400 (insn, operands);

    case 370:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(USAmode != DImode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1401 (insn, operands);

    case 371:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DQmode != DImode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1402 (insn, operands);

    case 372:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UDQmode != DImode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1403 (insn, operands);

    case 373:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(DAmode != DImode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1404 (insn, operands);

    case 374:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UDAmode != DImode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1405 (insn, operands);

    case 375:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(TAmode != DImode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1406 (insn, operands);

    case 376:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(UTAmode != DImode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1407 (insn, operands);

    case 377:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(QImode != DImode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1408 (insn, operands);

    case 378:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(HImode != DImode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1409 (insn, operands);

    case 379:
      if (!(
#line 62 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
(SImode != DImode) && 
#line 64 "../../gcc-15.1.0/gcc/config/avr/avr-fixed.md"
( reload_completed)))
        return NULL;
      return gen_split_1410 (insn, operands);

    default:
      return NULL;
    }
}
